--[[--
	* @Description: main.lua
	* @Author:      weirui.y
	* @DateTime:    2016-08-08 18:15:09
]]

DEBUG = 1
is_MICRO = true

NO_SDK_APP = false           --没有sdk的app
INNER_TEST_APP = false       --内部测试包
CHANNEL_TEST_APP = false     --渠道测试包
CHANNEL_TEST_APP_VERSION = 4 --渠道测试包版本
IS_THREE_DIR = false

if not is_MICRO then
	IS_THREE_DIR = true          --是否三个面
end

USE_NEW_UPDATE_MODE = false   --新更新模式
IS_ANDROID_TEST_MODE = false --安卓测试模式，只显示测试稳定服

IS_NEW_SHOWCHONG_FASHION = true

ROLE_MOVE_FUNC = {} --PC移动用

--全部全局配置
GlobalClientCfg = {
	tick = "",
	gameID = 0,            --区别不同的游戏
	appKey = 0,
	platID = 666,
	isPromote = 0,         --是否是审核版本
	isBanHao  = false,     --颁号
	channelID = 32760,
	channelGroup = "",     --渠道分组
	gameChannelID = 32760, --君海sdk和后台识别的标识
	isShowCharge = true,
	channelName = "windows",
	serverVersion = "",
	isBT = true,
	isSpecial = true,
}
--渠道测试包
if CHANNEL_TEST_APP then
	GlobalClientCfg = {
		tick = "",
		gameID = 0,            --区别不同的游戏
		appKey = 0,
		platID = 101,
		isPromote = 0,         --是否是审核版本
		isBanHao  = false,     --颁号
		channelID = 8888,
		channelGroup = "",     --渠道分组
		gameChannelID = 8888, --君海sdk和后台识别的标识
		isShowCharge = true,
		channelName = "windows",
	}
end

require("cocos.init")
require("game.core.CFunction")
require("game.core.Runner")
require("game.core.RenderUnit")
require("game.core.Platform")
require("game.core.Different")

--是否更新
IsUpdateFlag = true

function Start()
	--设置垃圾回收频率
	collectgarbage("setpause", 120)
	collectgarbage("setstepmul", 5000)
	math.randomseed(os.time())

	local fps = (SystemInfo.platform == cc.PLATFORM_OS_WINDOWS) and 1.0 / 1000 or 1.0 / 60
    cc.Director:getInstance():setAnimationInterval(fps)

    --初始化主渲染器
	HandleRenderUnit = RenderUnit.new("MainRenderUnit")
	HandleRenderUnit:initAsMainStage()

	GlobalTimerQuest = TimerQuest:new()
    GlobalTimerQuest.update = GlobalTimerQuest.Update
    Runner:getInstance():addRunObj(GlobalTimerQuest, 3)

    Different.initPlatform()
    
	--校验本地资源
	if is_MICRO then
		Launcher = require("game.launcher.newUpdate.Launcher")
		Launcher.init()
	else
		if cc.ResService:getInstance().CheckGamePatchCompress then
			if cc.ResService:getInstance():CheckGamePatchCompress() then
				Launcher = require("game.launcher.Launcher")
				Launcher.init()
			else
				LauncherShowView()
			end
		else
			Launcher = require("game.launcher.Launcher")
			Launcher.init()
		end
	end
end

function LauncherShowView()
	if globalLauncherRoot then return end
	globalLauncherRoot = cc.Node:create()
	HandleRenderUnit:getCoreScene():addToRenderGroup(globalLauncherRoot, cc.RenderQueue.GRQ_UI)

	--添加背景
	local bg = cc.Sprite:create("assets/icon/login/launch.jpg")
	bg:setScale(HandleRenderUnit:getMaxResolution())
	bg:setPosition(0, 0)
	globalLauncherRoot:addChild(bg)

	local aryStr = {
		"上仙，准备好进入修仙世界吧",
		"正在解压资源，该过程不会消耗流量，请上仙耐心等待",
		"正在校验本地游戏资源，请稍等...",
		"本地游戏资源已是最新",
	}

	local tipsLbl = cc.Label:create()
	tipsLbl:setSystemFontSize(18)
	tipsLbl:setColor(cc.c3b(0xff, 0xf9, 0xd1))
	tipsLbl:setPosition(0, 30 * HandleRenderUnit:getResolutionScale() - display.height / 2)
	tipsLbl:setString(aryStr[1])
	tipsLbl:setLabelEffect(cc.LabelEffect.SHADOW)
	tipsLbl:setScale(HandleRenderUnit:getResolutionScale())
	globalLauncherRoot:addChild(tipsLbl)
	local labelIndex = 1

	schedule(globalLauncherRoot, function()
			labelIndex = (labelIndex + 1 ) % 4
			if labelIndex == 0 then labelIndex = 4 end
			tipsLbl:setString(aryStr[labelIndex])
		end, 1.5)

	--进度条底
	local progressBg = cc.Scale9SpriteUI:createWithResCSpriteLoader("assets/icon/login/login.csprite", "loadingBg")
    progressBg:setContentSize(cc.size(1136, 14))
    progressBg:setPosition(0, 8 * HandleRenderUnit:getResolutionScale() - display.height / 2)
    globalLauncherRoot:addChild(progressBg)
    progressBg:setScaleX(display.width / 1136)

    local progress = cc.SpriteUI:createWithResCSpriteLoader("assets/icon/login/loginLoading.csprite", "default")
    progress:setAnchorPoint(cc.p(0, 0.5))
    progress:setPosition(0, 7)
    progressBg:addChild(progress)
    progress:setScaleX(0)
    local act = cc.ScaleTo:create(4, 1)
    progress:runAction(act)
end

function LauncherEnter(isSuccess)
	if not isSuccess then
		require("game.utils.init")
		Message:getInstance():showMessage("手机内存不足！2s后关闭游戏！")
		globalLauncherRoot:stopAllActions()
		performWithDelay(globalLauncherRoot, function()
				cc.Director:getInstance():endToLua()
			end, 2.5)
		return
	end
	if globalLauncherRoot then
		globalLauncherRoot:removeFromParent(true)
		globalLauncherRoot = nil
	end
	--获取版本，更新版本
    Launcher = require("game.launcher.Launcher")
    Launcher.init()	
end