require("game.modules.scene.FuncNpcUtil")
require("game.modules.scene.sceneUtils.SceneConfig")
require("game.modules.scene.sceneUtils.SceneUtils")
require("game.modules.scene.sceneObj.init")
require("game.modules.scene.sceneUtils.SceneLoading")
require("game.modules.scene.SceneEvent")
require("game.modules.scene.SceneWords")
require("game.modules.scene.fight.AutoFighting")
require("game.modules.scene.fight.SkillDisplay")
require("game.modules.task.TranslateView")
require("game.modules.scene.sceneUtils.SceneCamera")
require("game.modules.set.SetUtil")
require("game.modules.newPlayerKun.NewPlayerKunUtil")

Scene = Scene or class("Scene", BaseController)

Scene.LOGIC_WIDTH = 60
Scene.LOGIC_HEIGHT = 30
Scene.PIXEL_NUM = 512

Scene.SCENE_WIDTH = nil
Scene.SCENE_HEIGHT = nil

Scene.WIDTH_BLOCK_NUM = 0
Scene.HEIGHT_BLOCK_NUM = 0
Scene.WIDTH_MAP_NUM = 0
Scene.HEIGHT_MAP_NUM = 0

Scene.SHOW_FIHGT_INFO = true 
Scene.IN_FIGHT_TIME = 0

Scene.SHOW_ROLE_NUM = 50
Scene.FAST_MODE = false

-- 速度比例
Scene.SPEED_RATE = 18
--分帧创建
Scene.MonsterFixed = 5

Scene.EFFECT_TEST = nil
local min = math.min

function Scene:ctor()
    Scene.instance = self

    --上一个场景ID
    self.lastSceneID = nil
    self.curDropInfo = {}

    self.enterMonMap = {}
    self.outMonMap = {}
    self.doubleMountVo = {}
    self.recvMonList = {}
    self.leaveMonList = {}
    self.addMonList = {}
    self.createMonList = {}
    self.deleteMonList = {}
    self.isReport = false

    self.loadingUtils = SceneLoading.new()
    AutoFighting:getInstance()
    self.isLoadingMap = false
    self.figureSpCache = nil --存储变身资源
    self.figureSpCacheID = nil

    self:init()

    self.delayNode = cc.Node:create()
    HandleRenderUnit:getCoreScene():addToRenderGroup(self.delayNode, cc.RenderQueue.GRQ_AIR)

    self.delayNode1 = cc.Node:create() --切换场景自动战斗独立延时节点
    HandleRenderUnit:getCoreScene():addToRenderGroup(self.delayNode1, cc.RenderQueue.GRQ_AIR)

    self.delayNode = cc.Node:create()
    HandleRenderUnit:getCoreScene():addToRenderGroup(self.delayNode, cc.RenderQueue.GRQ_AIR)
    self.findWayNode = cc.Node:create()
    HandleRenderUnit:getCoreScene():addToRenderGroup(self.findWayNode, cc.RenderQueue.GRQ_AIR)

    self.delDelayNode = cc.Node:create()
    HandleRenderUnit:getCoreScene():addToRenderGroup(self.delDelayNode, cc.RenderQueue.GRQ_AIR)
end

function Scene:onMonEnter(vo, desc)
    vo = vo or {}
    local key = vo.mkey
    if SceneUtils.isInSMZC() then
        self.enterMonMap[key] = true
    end
    if SceneUtils.isInCopyCheckScene() then
        -- log("onMonEnter", desc, key, vo.mid)
         -- {(6305_30511,x = 80,y = 56, hp = 54236428, kind = 35, shadow_key = 0 scene = 12010),(1994824_30512,58,96,62371999,35,0_12010)}|{}=[]
        local info = string.format("%s,%s,%s,%s,%s", tostring(vo.x), tostring(vo.y), tostring(vo.hp), tostring(vo.kind), tostring(vo.shadow_key))
        local record = string.format("(%s_%s,%s_%s)", tostring(vo.mkey), tostring(vo.mid), info, tostring(desc))
        local len = #self.recvMonList
        if len <= 5 then
            self.recvMonList[len + 1] = record
        end
    end
end

function Scene:onMonLeave(key, desc)
    if SceneUtils.isInSMZC() then
        self.outMonMap[key] = true
    end
    if SceneUtils.isInCopyCheckScene() then
        -- log("onMonLeave", key, desc)
        local len = #self.leaveMonList
        if len <= 5 then
            self.leaveMonList[len + 1] = key .. "_" .. tostring(desc)
        end
    end
end

function Scene:onMonAdd(vo)
    if SceneUtils.isInCopyCheckScene() then
        -- log("onMonAdd", vo.mid)
        local len = #self.addMonList
        if len <= 5 then
            self.addMonList[len + 1] = tostring(vo.mkey) .. "_" .. tostring(vo.mid)
        end
    end
end

function Scene:onMonCreate(vo)
    if SceneUtils.isInCopyCheckScene() then
        -- log("onMonCreate", vo.mid, vo.mkey)
        SceneUtils.cancelCheckCopyMonster()
        local len = #self.createMonList
        if len <= 5 then
            self.createMonList[len + 1] = tostring(vo.mkey) .. "_" .. tostring(vo.mid)
        end
    end
end

function Scene:onMonDelete(vo)
    if SceneUtils.isInCopyCheckScene() then
        -- log("onMonDelete", vo.mid, vo.mkey)
        local len = #self.deleteMonList
        if len <= 5 then
            self.deleteMonList[len + 1] = tostring(vo.mkey) .. "_" .. tostring(vo.mid)
        end
    end
end

function Scene:getInstance()
    if not Scene.instance then
        Scene.new()
    end
    return Scene.instance
end

function Scene:init()
    self.camera = SceneCamera.new()

    --主角色
    self.mainpKey = nil

    self.frame = 1
    --角色展示数据
    self.roleRealVo = nil

    --连续跳跃
    self.isLoopJump = nil
    --是否可以震屏
    self.isShake = ( CookieManager.getCookie("sceneShake", "B")) 
    if self.isShake == nil then
        self.isShake = true
    end
    --是否在同一条寻路上
    self.pathID = 0

    self.roleNum = 0
    self.filterRoleNum = 0
    self.filterRoleKey = {}

    --是不是显示loading
    self.isShowLoading = true

    --上一个场景中角色的屏幕坐标
    self.lastScreenPos = cc.vec2(0, 0)
    self.delayLoadParallaxTimer = nil

    -- 是否要播放VIP技能
    self.isPlayVipSkill = false

    --屏蔽(本地数据)
    self.setLocalHideData = {}
    for var = 1, 11 do
        local isOpen = CookieManager.getCookie("setFunc"..var, "B")
        self.setLocalHideData[var] = isOpen
    end
    self.isHideMyTeamer = self.setLocalHideData[1]
    self.isHideMonster = self.setLocalHideData[6]
    self.isHideMagic = self.setLocalHideData[3]
    self.isHidePet = self.setLocalHideData[4]
    self.isHideOtherRole = self.setLocalHideData[2]
    self.isHideShenling = self.setLocalHideData[3]

    self.isHideOtherRolePart = {
        [SetHideType.Wing] = self.setLocalHideData[5],--翅膀
        [SetHideType.SwordPool] = self.setLocalHideData[10],--剑池
        [SetHideType.ArtifactUp] = self.setLocalHideData[9],--十方神器
        [SetHideType.Title] = self.setLocalHideData[7],--称号
    }
    self.isHideSelfRolePart = {
        [SetHideType.Wing] = CookieManager.getCookie("HideWing", "B"), --翅膀
        [SetHideType.SwordPool] = CookieManager.getCookie("HideSwordPool", "B"),--剑池
        [SetHideType.Cloak] = CookieManager.getCookie("HideCloak", "B"), --披风
    }
    self.isGoldCopyScene = false --是否金钱副本
    self.isBossCopyScene = false --是否boss副本
    self.isGhostBattleScene = false --是否神魔战场

    self.roleMap = {}
    self.monsterMap = {}
    self.npcMap = {}
    self.doorMap = {}
    self.flyMap = {}
    self.dropMap = {}
    self.zbMap = {} -- 珍宝对象列表
    self.deadMap = {}
    self.skillMap = {}
    self.sceneEffectMap = {}
    self.sceneEffectDic = {}
    self.vipSkillMonMap = {} -- vip技能对象列表

    self.roleList = List.New()     --玩家队列
    self.monsterList = List.New()  --怪物队列
    self.npcList = List.New()      --NPC队列
    self.doorList = List.New()     --传送门队列
    self.dropList = List.New()     --传送门队列
    self.flyList = List.New()     --跳跃点队列

    self.kunList = {}            -- 新手送鲲

    self.moveList = List.New()

    self.followerList = List.New()   --跟随物数据队列
    self.followerMap = {}            --跟随物队列

    self.skillList = List.New()

    self.petList = List.New() --宠物队列
    self.zbList = List.New() --珍宝队列
    self.vipSkillMonList = List.New() -- vip技能队列

    self.npcStatusList = {} --npc状态列表
    self.clearMonList = {}--消消乐怪物列表
    self.objVisible = true

    self.pickObj = nil
    self.stopWirteRealPos = 2
    self.checkDropPerSecond = 1

    self.flyCallback = nil

    self.deadClientMap = {}
    self.clientNpcList = List.New()
    self.clientRoleList = List.New()
    self.clientMonsterList = List.New()

    self.clientNpcMap = {}
    self.clientRoleMap = {}
    self.clientMonsterMap = {}

    --保存玩家镜像[name = true]，防止同样名字的镜像出现在场景中
    self.roleShadowNameMap = {}

    --采集后的效果
    self.gatherEffectMap = {}

    --回调的列表
    self.storyCallbackList = {}

    --宠物存储对象
    self.petMap = {}
    --护送水晶
    self.escortMap = {}
    --法器
    self.magicWeaponMap = {}
    --神灵
    self.shenlingMap = {}
    --怪物
    self.monsterKeepMap = {}
    --妖灵
    self.catMap = {}

    self.pickMask = ObjPickType.All - ObjPickType.UnPick - ObjPickType.Buffer

    --是否显示
    self.objsVisibleList = {role = true, mon = true, npc = true, door = true, fly = true, drop = true}

    --注册区域
    self.zoneList = {}
    --技能时间
    self.skillTimeMap = {}

    --死亡存储(怪物等死亡后的节点移除，防止登出各种场景信息删除报错)
    self.deadList = {}

    self.getSceneObjMap = {
        [ObjPickType.MainRole] = function (pkey)
            return self:getMainRole()
        end,
        [ObjPickType.Role] = function (pkey)
            return self.roleMap[pkey]
        end,
        [ObjPickType.Pet] = function (pkey)
            return self.roleMap[pkey]
        end,
        [ObjPickType.Monster] = function (mkey)
            return self.monsterMap[mkey]
        end,
        [ObjPickType.Gather] = function (pkey)
            return self.monsterMap[pkey]
        end,
        [ObjPickType.Npc] = function (nkey)
            return self.npcMap[nkey]
        end,
        [ObjPickType.Door] = function (pkey)
            return self.doorMap[pkey]
        end,
        [ObjPickType.Fly] = function (pkey)
            return self.flyMap[pkey]
        end,
        [ObjPickType.Armyer] = function (mkey)
            return self.monsterMap[mkey]
        end,
        [ObjPickType.RoleShadow] = function (mkey)
            return self.monsterMap[mkey]
        end,
        [ObjPickType.MapMonster] = function (mkey)
            return self.monsterMap[mkey]
        end,
        [ObjPickType.ZhenBao] = function (mkey)
            return self.zbMap[mkey]
        end,
    }

    self:registerAllProtocal()
    self:addEvents()
end

function Scene:addEvents()
    GlobalEventSystem:bind(GlobalEventType.INIT_SCENE, handler(self, self.enterScene))
    GlobalEventSystem:bind(GlobalEventType.SHOW_SCENE_OBJ, handler(self, self.showSceneObj))

    --开始采集
    self:bind(SceneEvent.SCENE_START_PICKING, handler(self, self.startPicking))

    self:bind(SceneEvent.FIND_SCENE_OBJ, handler(self, self.findSceneObj))
    GlobalEventSystem:bind(GlobalEventType.FIND_SCENE_OBJ, handler(self, self.findSceneObj))
    self:bind(SceneEvent.FINDOBJ_AND_OPERATE, handler(self, self.findObjAndOperate))
    self:bind(SceneEvent.SCENE_OBJ_DEAD, handler(self, self.deadClean))

    --刷新npc任务状态
    self:bind(SceneEvent.NPC_STATUS_UPDATE, handler(self, self.updateNpcStatus))

    self:bind(SceneEvent.REQUEST_12001, handler(self, self.request12001))
    self:bind(SceneEvent.REQUEST_12002, handler(self, self.request12002))
    self:bind(SceneEvent.REQUEST_12005, handler(self, self.request12005))
    GlobalEventSystem:bind(GlobalEventType.REQUEST_12005, handler(self, self.request12005))

    self:bind(SceneEvent.REQUEST_12011, handler(self, self.request12011))

    self:bind(SceneEvent.REQUEST_12014, handler(self, self.request12014))
    self:bind(SceneEvent.REQUEST_12016, handler(self, self.request12016))
    self:bind(SceneEvent.REQUEST_12017, handler(self, self.request12017))
    self:bind(SceneEvent.REQUEST_12021, handler(self, self.request12021))
    self:bind(SceneEvent.REQUEST_12071, handler(self, self.request12071))
    
    self:bind(SceneEvent.REQUEST_12023, handler(self, self.request12023))
    self:bind(SceneEvent.REQUEST_12025, handler(self, self.request12025))
    self:bind(SceneEvent.REQUEST_12030, handler(self, self.request12030))

    self:bind(SceneEvent.REQUEST_32001, handler(self, self.request32001))
    self:bind(SceneEvent.REQUEST_12047, handler(self, self.request12047))

    self:bind(SceneEvent.MAIN_ROLE_START_MOVE, handler(self, self.following))
    self:bind(SceneEvent.FOLLOW_ROLE_UPDATE, handler(self, self.followerOption))
    self:bind(SceneEvent.PET_FIGTH_UPDATE, handler(self, self.createPetHandler))

    self:bind(SceneEvent.DELAY_TO_FIGHT, handler(self, self.delayToFight))
    self:bind(GlobalEventType.CLEAN_END_POINT, handler(self, self.cleanEndPoint), GlobalEventSystem)
    self:bind(SceneEvent.SHOW_SKILL_TIPS, handler(self, self.showSkillTips))
    self:bind(SceneEvent.STOP_RUNNING, handler(self, self.stopRunning))

    GlobalEventSystem:bind(GlobalEventType.ROLE_INFO_CHANGE, handler(self, self.changeRoleInfo))
    GlobalEventSystem:bind(GlobalEventType.MAINUI_SHOW_TARGET, handler(self, self.changeMonsterTarget))
    GlobalEventSystem:bind(GlobalEventType.SET_FAST_MODE, handler(self, self.setFastMode))
    GlobalEventSystem:bind(GlobalEventType.OPERATE_MOVE_END, handler(self, self.onPathChange))
    GlobalEventSystem:bind(GlobalEventType.ROLE_OPERATE_END, handler(self, self.jumpEndFindSceneObj))
    GlobalEventSystem:bind(GlobalEventType.TRANSFER_REQUEST, handler(self, self.request12015))

    --强制跳跃
    self:bind(SceneEvent.FORCE_JUMP_ROLE, handler(self, self.handlerJump))
    GlobalEventSystem:bind(GlobalEventType.SCENE_AUTO_FIGHT, handler(self, self.sceneAutoFight))
    GlobalEventSystem:bind(GlobalEventType.DEFAULT_LOADING_CLOSE, handler(self, self.showFloating))
    GlobalEventSystem:bind(GlobalEventType.AUTO_FLY, handler(self, self.autoFly))
    GlobalEventSystem:bind(GlobalEventType.OVERFLY_END, handler(self, self.overflyEnd))


    GlobalEventSystem:bind(GlobalEventType.CLOSE_TOWER_TIP, handler(self, self.closeTowerTip))
    GlobalEventSystem:bind(GlobalEventType.JUHUN_TOWER_NUM, handler(self, self.refreshTowerTip))

    GlobalEventSystem:bind(GlobalEventType.BEFORE_ACTIVE, function()
        --游戏切换回来，重新计算
        log("重新计算..")
        SceneUtils.cancelCheckCopyMonster()
        GlobalTimerQuest:AddDelayQuest(function()
            SceneUtils.checkCopyMonster()
        end, 10)
    end)  
end

function Scene:registerAllProtocal()
    local array = {12001, 12002, 12003, 12004, 12005, 12006, 12007, 12008, 12009, 12010, 12011, 12012, 12013, 12014, 12015, 
        12016, 12017, 12018, 12019, 12020, 12021, 12022, 12023, 12024, 12025, 12026, 12027, 12028, 12029, 12030, 12031, 12032,
        12033, 12034, 12035, 12036, 12037, 12038, 12039, 12040, 12041, 32001, 12045, 12046, 12047, 12048, 12049, 12050, 12051,
        12053, 12054, 12056, 12057, 12058, 12060, 12061, 12062, 12099, 13029, 12224,
        12071, 12072, 12073, 12074, 12075, 12063, 12064, 12065, 12066, 12067, 12068,12069,12076}

    for var = 1, #array do
        self:registerProtocal(array[var], "response" .. array[var])
    end
end

function Scene:request12001(tox, toy, type, skillType)
    tox = math.ceil(tox)
    toy = math.ceil(toy)

    self.lastRequestPos = self.lastRequestPos or cc.p(0, 0)
    if SceneUtils.isSamePoint(self.lastRequestPos, cc.p(tox, toy)) and not skillType then
        return
    end
    self.lastRequestPos = cc.p(tox, toy)
    -- print(" role :----- ", tox, toy, type, skillType)
    if tox <= 0 or tox > Scene.WIDTH_BLOCK_NUM or toy <= 0 or toy > Scene.HEIGHT_BLOCK_NUM then
        local msg = ""
        msg = msg.."{request12001 role position error !! x:"..tox .." y:"..toy.."}"
        if platform == cc.PLATFORM_OS_ANDROID or platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD then 
            -- buglyReportLuaException(msg, debug.traceback())
            FeedbackController:getInstance():httpSend(msg)
        else
            log(msg)
        end
    end

    self:send(12001, tox, toy, type, skillType or 0)
end

function Scene:updateLastPos(pos)
    self.lastRequestPos = cc.vec2(pos.x, pos.y)
end

function Scene:handlerJump(jumpVo)
    if self.isLoopJump then
        return
    end

    self.isLoopJump = true
    local nextJumpVo = self.cfg.flys[jumpVo.nextId]
    local nextLogic = cc.p(nextJumpVo.x, nextJumpVo.y)
    local pixelPos = SceneUtils.logicToPixel(nextLogic)
    self.role:doJump(nil, pixelPos)
end

function Scene:doMoveHandler(vo, obj)
    local obj = obj or self:getRoleObj(vo.pkey)
    if obj then
        --强制跳跃
        if vo.type == 7 then
            self.roleMap[vo.pkey]:doJump(nil, cc.p(vo.x, vo.y), nil, true)
        elseif vo.type == 6 then
            self.roleMap[vo.pkey]:doFlyattack(nil, cc.p(vo.x, vo.y))
        elseif vo.type == 5 then
            self.roleMap[vo.pkey]:doOverFly(nil, cc.p(vo.x, vo.y))
        else
            self.roleMap[vo.pkey]:doMove(nil, cc.p(vo.x, vo.y))
            if self.role and self.role.isCommonMount then
                if vo.pkey == self.role.isCommonMount then
                    self.role:doMove(nil, cc.p(vo.x, vo.y))
                end
            end
        end

        self:following(obj, vo)
    end
end

function Scene:response12001(vo)
    local obj, flag = self:getRoleObj(vo.pkey)
    --特殊没有目标放技能处理
    if obj and vo.skillType > 0 then
        if not flag then
            local cfg = Config.getSkill(vo.skillType)
            if cfg.drop_block and cfg.drop_block > 0 then --特殊骑战跳跃技能
                obj.skillJumpPoint = SceneUtils.logicToPixel(cc.p(vo.x, vo.y))
            end
            obj:doAttack(nil, cfg.action_type or 1, cfg.sftime, vo.skillType, nil, cc.pNormalize(AutoFighting:getInstance():getDirNormal(self.role.dir)))
            return
        end
    end

    if obj then
        if flag then
            if self.stopWirteRealPos > 0 then
                self.stopWirteRealPos = self.stopWirteRealPos - 1
            else
                local pos = self.role:getLogicPos()

                if self.role and (SceneUtils.getDistanceSQ(pos, vo) > 16*16) then
                    self.errorPosCount = self.errorPosCount or 0
                    self.errorPosCount = self.errorPosCount + 1
                    local msg = string.format("current position x: %s, y: %s", tostring(pos.x), tostring(pos.y))
                    local target = AutoFighting:getInstance():getTarget()
                    if target then
                        local tp = target:getLogicPos() or {}
                        msg = msg .. ", target position x:" .. tostring(tp.x) .. " y:" .. tostring(tp.y)
                    else
                        msg = msg .. ", no target"
                    end

                    msg = msg .. ", server position x:" .. tostring(vo.x) .. " y:" .. tostring(vo.y)
                    --上报当前坐标pos.x, pos.y ，目标怪物坐标target.x, target.y ，服务器返回坐标vo.x, vo.y
                    if platform == cc.PLATFORM_OS_ANDROID or platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD then 
                        buglyReportLuaException(msg, debug.traceback())
                        log(msg)
                    else
                        log(msg)
                    end

                    if self.errorPosCount > 20 then
                        log("坐标错误修正。。。。。")
                        self.errorPosCount = 0
                        self.role.setLogicPos(vo)
                    end
                end
                if RoleController:getInstance().model.mainRoleVo then
                    RoleController:getInstance().model.mainRoleVo.x = vo.x
                    RoleController:getInstance().model.mainRoleVo.y = vo.y
                end
            end
        else
            obj:pushMoveInfo(vo)
        end
    end
end

function Scene:request12002(...)
    self:send(12002, ...)
end

function Scene:response12002(vo)
    log("response12002", #vo.sceneplayer.player_list, #vo.monlist.mon_list)
    --上报后收到12002，继续上报信息
    for var = 1, #vo.sceneplayer.player_list do
        List.PushBack(self.roleList, {vo.sceneplayer.player_list[var], "add"}) 
    end

    for var = 1, #vo.monlist.mon_list do
        local monInfo = vo.monlist.mon_list[var]
        self:onMonEnter(monInfo, "12002")
        if monInfo.shadow_key ~= 0 then
            log("monInfo.shadow_key", monInfo.shadow_key)
        end
        if monInfo.hp then
            monInfo.hp = tonumber(monInfo.hp)
        end
        if monInfo.hp_lim then
            monInfo.hp_lim = tonumber(monInfo.hp_lim)
        end
        List.PushBack(self.monsterList, {monInfo, "add"}) 
    end

    if self.isReport then
        self.isReport = false
        GlobalTimerQuest:AddDelayQuest(function()
            self:reportInfo("after666")
        end, 2)
    end

    --进入野外BOSS场景通知更新当前BOSS血量和最大血量
    if self.isBossCopyScene then
        if vo.monlist.mon_list and vo.monlist.mon_list[1] then
            local monsVo = vo.monlist.mon_list[1]
            GlobalEventSystem:fire(GlobalEventType.ENTER_BOSS, monsVo.hp_lim, monsVo.hp, monsVo.mkey) 
        end    
    end    

    if self.role and #vo.scenenpc.npc_list > 0 then
        local pos = self.role:getLogicPos()
        for var = 1, #vo.scenenpc.npc_list do
            vo.scenenpc.npc_list[var].distance = math.abs(vo.scenenpc.npc_list[var].x - pos.x) + math.abs(vo.scenenpc.npc_list[var].y - pos.y)
        end
        
        table.sort(vo.scenenpc.npc_list, function (a, b)
            return a.distance < b.distance
        end)
    end
    for var = 1, #vo.scenenpc.npc_list do
        List.PushBack(self.npcList, vo.scenenpc.npc_list[var])
    end
    
    for var = 1, #vo.elemlist.elem_list do
        vo.elemlist.elem_list[var].scene = vo.elemlist.elem_list[var].sid
        List.PushBack(self.doorList, vo.elemlist.elem_list[var])
    end

    if SociatyUtils.isInDinner() then
        if vo.monlist.mon_list[1] then
            SociatyController:getInstance():request18209(vo.monlist.mon_list[1].mid)--fire(SociatyEvent.SOCIATY_CHECK_GATHER,vo.monlist.mon_list)
        end
    end
    --获取掉落列表
    self:request12021()
    if (GlobalClientCfg.isBT or GlobalClientCfg.isKorea) then
        self:request12071()    
    end
end

function Scene:response12003(vo)
    for var =1, #vo.playerlist.player_list do
        List.PushBack(self.roleList, {vo.playerlist.player_list[var], "add"})    
    end
end

function Scene:response12004(vo)
    log("12004", #vo.pkeylist)
    for var =1, #vo.pkeylist do
        if not self.sceneId or vo.pkeylist[var].scene == self.sceneId then
            List.PushBack(self.roleList, {vo.pkeylist[var], "remove"})
            --移除尸体
            local removeKey = vo.pkeylist[var].pkey
            log("response12004", vo.pkeylist[var].pkey)
            if self.deadMap[removeKey] then
                self.deadMap[removeKey]:removeFromParent(true)
                self.deadMap[removeKey]=nil
            end
        end
    end
end

function Scene:request12005(sid, line)
    --监狱场景不允许跳转
    if SceneUtils.isPrisonType(Scene:getInstance().sceneId) then
        Message:getInstance():showMessage("当前处于监狱场景，无法跳转")
        return
    end

    local sid = sid
    local limit = Config.BaseScene[sid] and Config.BaseScene[sid].limit or 0
    if RoleController:getInstance().model.mainRoleVo.lv < limit then        
        if GlobalClientCfg.isBanHao then
            Message:getInstance():showMessage(string.format("等级%s才能进入该场景", limit))
        else
            Message:getInstance():showMessage(string.format("Lv.%s才能进入该场景", limit))
        end
        return
    end

    if SystemInfo.platform == cc.PLATFORM_OS_WINDOWS then
         self:send(12005, sid, line)
    else
        MapDownController.CheckMapExist(sid,
            function ()
                self:send(12005, sid, line)
            end)
    end
end

function Scene:response12005(vo)
    self:updateScreenPos()
    AutoFighting:getInstance():stopAutoFight()
    --骑战屏蔽
    -- MountsController:getInstance():startDownMounts(false, false)--下坐骑
    log("Scene:response12005", vo.x, vo.y)
    local _vo = {}
    _vo.x = vo.x
    _vo.y = vo.y
    _vo.scene = vo.scene
    if RoleController:getInstance().model.mainRoleVo then
        RoleController:getInstance().model.mainRoleVo.line = vo.line
    end

    self.stopWirteRealPos = 2
    if vo.scene > 0 then
        if not Different.isCanShow() then 
            FightScene:getInstance():resetData() 
        end 
        RoleController:getInstance():fire(RoleEvent.CHANGE_ROLE_INFO, _vo)
        self:enterScene(vo.scene)
        GlobalEventSystem:fire(GlobalEventType.SUCCD_ENTER_SCENE)
    else
        Message:getInstance():showMessage(vo.name)
    end
    --对于一些需要切换场景之后的逻辑处理增加事件
    GlobalEventSystem:fire(GlobalEventType.RESULT_12005, vo.scene > 0)
end

function Scene:request12011(...)
    self:send(12011, ...)
end

function Scene:response12011(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.guildkey = vo.guild_key
        RoleController:getInstance().model.mainRoleVo.guildname = vo.guild_name
        RoleController:getInstance().model.mainRoleVo.guildpos = vo.position
    end

    if obj then
        obj.vo.guildkey = vo.guild_key
        obj.vo.guildname = vo.guild_name
        obj:updateName()
    end
    if vo.guild_key == "0" then
        SociatyController:getInstance():fire(SociatyEventType.CLOSE_VIEW)
    end
end

function Scene:response12013(teamVo)
    --检查是否是主角
    local obj, isMain = self:getRoleObj(teamVo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.teamkey = teamVo.team_key

        if teamVo.team_key == "0" then
            TeamFieldController:getInstance():fire(TeamFieldEventType.OUT_TEAM)
        end
    end
    --检查是否是其他玩家
    if self.roleMap[teamVo.key] then
        local _info = self.roleMap[teamVo.key].vo
        _info.teamkey = teamVo.team_key
    end

    if obj then
        local info = obj.vo
        info.teamkey = teamVo.team_key
        obj:updateName()
    end
end

function Scene:request12014(...)
    self:send(12014, ...)
end
function Scene:response12014(vo)
    if self.mainpKey == vo.key then
        local roleVo = RoleController:getInstance().model.mainRoleVo
        local lastPetId = RoleController:getInstance().model.mainRoleVo.pettypeid
        if lastPetId <= 0 then --第一次获得宠物
            GlobalEventSystem:fire(GlobalEventType.FIRST_TIME_PET_CHANGE)
        end
        roleVo.pettypeid = vo.pettypeid
        roleVo.petfigure = vo.petfigure
        roleVo.petname = vo.petname
    end

    if self.petMap[vo.key] then
        local _info = self.petMap[vo.key].vo
        _info.pettypeid = vo.pettypeid
        _info.petfigure = vo.petfigure 
        _info.petname = vo.petname

        local petVoList = {[1] = {pkey = vo.key, typeid = vo.pettypeid, mid = vo.petfigure, petname = _info.petname, name = _info.name, dir = 1, x = _info.x, y = _info.y, speed = 200 * Scene.SPEED_RATE}}
        if vo.petfigure > 0 then
            self:createPetHandler(petVoList, "add")
        else
            self:createPetHandler(petVoList, "remove")
        end
    else
        local master = SceneUtils.getMasterRole(vo.key)
        if master then
            master.vo.pettypeid = vo.pettypeid
            master.vo.petfigure = vo.petfigure
            master.vo.petname = vo.petname
            self:createFollowObj(master.vo)
        end
    end
end

--[[
12015 - 场景目标传送

客户端请求:

int8    target_type 目标类型（1场景，2NPC，3怪物）
int32   target_id   目标ID
int8    pos_type    位置类型(0点传场景,1点传点)]]
function Scene:request12015( ... )
    self:send(12015, ... )
end

function Scene:response12015(resultVo)
    if resultVo.code ~= 1 then
        Message:getInstance():showMessage(Proto.errorCode[120][resultVo.code])
    end
end

function Scene:response12016(vo)
    local list = {x = vo.x , y = vo.y , scene = vo.sid}
    List.PushBack(self.doorList, list)
end

function Scene:response12017(vo)
    local _door = self.doorMap[vo.sid]
    if _door then
        _door:delete()
        self.doorMap[vo.sid] = nil
    end
end

function Scene:response12006(vo)
    for var =1, #vo.monlist.mon_list do
        local monInfo = vo.monlist.mon_list[var]
        self:onMonEnter(monInfo, "12006")
        monInfo.hp = monInfo.hp and tonumber(monInfo.hp) or nil
        monInfo.hp_lim = monInfo.hp_lim and tonumber(monInfo.hp_lim) or nil
        List.PushBack(self.monsterList, {monInfo, "add"}) 
    end
end

function Scene:response12007(vo)
    for var =1, #vo.mkeylist do
        self.removedMonList[vo.mkeylist[var]] = true
        self:onMonLeave(vo.mkeylist[var], "12007")
        self:createMonsterHandler({{mkey = vo.mkeylist[var]}, "remove"})
    end
end

function Scene:response12008(vo)
    local objMon = self.monsterMap[vo.mkey]
    if objMon and objMon.stateMechine then
        if vo.move_type == 1 or vo.move_type == 2 then
            objMon:doMove(nil, cc.p(vo.x, vo.y))
        elseif vo.move_type == 6 then
            objMon:doFlyattack(nil, cc.p(vo.x, vo.y))
        elseif vo.move_type == 7 then
            objMon:doJump(nil, cc.p(vo.x, vo.y), nil, true)
        end

        self:following(objMon, cc.p(vo.x, vo.y))
    end
end

function Scene:response12009(vo)
    for var =1, #vo.outkeylist do
        List.PushBack(self.roleList, {{pkey = vo.outkeylist[var]}, "remove"})
    end
    
    for var =1, #vo.inplayerlist.player_list do
        List.PushBack(self.roleList, {vo.inplayerlist.player_list[var], "add"})
    end
end

function Scene:response12010(vo)
    for var = 1, #vo.outkeylist do
        self:onMonLeave(vo.outkeylist[var], "12010")
        self.removedMonList[vo.outkeylist[var]] = true
        self:createMonsterHandler({{mkey = vo.outkeylist[var]}, "remove"})
    end
    
    for var = 1, #vo.inmonlist.mon_list do
        local monInfo = vo.inmonlist.mon_list[var]
        self:onMonEnter(monInfo, "12010")
        monInfo.hp = monInfo.hp and tonumber(monInfo.hp) or nil
        monInfo.hp_lim = monInfo.hp_lim and tonumber(monInfo.hp_lim) or nil
        List.PushBack(self.monsterList, {monInfo, "add"}) 
    end
end

function Scene:getRoleObj(key)
    if not key then return end
    if self.role and key == self.role.vo.pkey then
        return self.role, true
    else
        if self.roleMap[key] then
            return self.roleMap[key], false
        elseif self.monsterMap[key] then --镜像玩家
            return self.monsterMap[key], false
        end
    end
end

function Scene:response12012(vo)
    local obj, isMain = self:getRoleObj(vo.playerkey)
    if obj and not isMain then
        local modelVo = obj.vo
        modelVo.mount_id = vo.mount_id
        obj:refreshHorseState()
        obj:upordownMounts(false)
        obj:initWithVo(modelVo)
        obj:resetAnimate()
    elseif isMain then
        MountsUtils.updateMount(vo.mount_id)
    end
end

--翅膀更新
function Scene:response12018(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        local lastWingId = RoleController:getInstance().model.mainRoleVo.wing_id or 0
        RoleController:getInstance().model.mainRoleVo.wing_id = vo.wing_id
        --第一次装备翅膀
        
    end

    if obj then
        obj.vo.wing_id = vo.wing_id
        obj:updateResource()
        obj:resetAnimate()
    end
    RoleController:getInstance():fire(RoleEvent.RESPONSE_FANCY)
end

--装备更新
function Scene:response12019(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        local lastWeponId = RoleController:getInstance().model.mainRoleVo.wepon_id

        RoleController:getInstance().model.mainRoleVo.wepon_id = vo.weapon_id
        RoleController:getInstance().model.mainRoleVo.clothing_id = vo.clothing_id

        if lastWeponId <= 0 and vo.weapon_id > 0 then  --第一次获得武器播完剧情后刷新外观
            return 
        end
    end
    if obj then
        obj.vo.wepon_id = vo.weapon_id
        obj.vo.clothing_id = vo.clothing_id
        local info = obj.vo
        info.guard_spirit_id = vo.guard_spirit_id
        obj:initWithVo(info)
        obj:updateResource()
        obj:resetAnimate()
    end
end

--时装信息更新
function Scene:response12020(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.fashion_cloth_id = vo.fashion_cloth_id
        RoleController:getInstance().model.mainRoleVo.fashion_footprint_id = vo.fashion_footprint_id
        RoleController:getInstance().model.mainRoleVo.fashion_circle_id = vo.fashion_circle_id
        RoleController:getInstance().model.mainRoleVo.fashion_bubble_id = vo.fashion_bubble_id
        RoleController:getInstance().model.mainRoleVo.fashion_head_frame_id = vo.fashion_head_frame_id
        RoleController:getInstance().model.mainRoleVo.fashion_weapon_id = vo.fashion_weapon_id
        RoleController:getInstance().model.mainRoleVo.fashion_bg_id = vo.fashion_bg_id
        RoleController:getInstance().model.mainRoleVo.fashion_head_id = vo.fashion_head_id
    end  
    if obj then
        local _info = obj.vo
        _info.fashion_cloth_id = vo.fashion_cloth_id
        _info.fashion_footprint_id = vo.fashion_footprint_id
        _info.fashion_circle_id = vo.fashion_circle_id
        _info.fashion_bubble_id = vo.fashion_bubble_id
        _info.fashion_head_frame_id = vo.fashion_head_frame_id
        _info.fashion_weapon_id = vo.fashion_weapon_id
        _info.fashion_bg_id = vo.fashion_bg_id    
        _info.fashion_head_id = vo.fashion_head_id     
        obj:initWithVo(_info)
        obj:resetAnimate()
    end
    RoleController:getInstance():fire(RoleEvent.RESPONSE_FANCY)
end

--光武信息更新
function Scene:response12024(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.light_wepon_id = vo.light_weapon_id
        local fw_id = RoleController:getInstance().model.mainRoleVo.fashion_weapon_id
        local id = 100001
        if fw_id > 0 and tonumber(vo.light_weapon_id) > tonumber(id) then
            -- 从神兵幻化成光武 需要先取消光武幻化
            ChangeImageController:getInstance():fire(FashionChangeEvents.REQUEST_FANCY, 0, fw_id)
        end
    end

    if obj then
        local _info = obj.vo
        _info.light_wepon_id = vo.light_weapon_id
        obj:initWithVo(_info)
        obj:resetAnimate()
    end
    RoleController:getInstance():fire(RoleEvent.RESPONSE_FANCY)
end

--强化等级更新
function Scene:response12033(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        if vo.stren_lv then
            RoleController:getInstance().model.mainRoleVo.stren_lv = vo.stren_lv
        end
    end

    if obj then
        local _info = obj.vo
        _info.stren_lv = vo.stren_lv
    end
end

-- string  key 玩家key
-- string  scene_face  玩家场景表情
function Scene:response12034(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        if vo.scene_face then
            RoleController:getInstance().model.mainRoleVo.scene_face = vo.scene_face
        end
    end

    if obj then
        local _info = obj.vo
        _info.scene_face = vo.scene_face
        obj:showSceneFace(vo.scene_face)
    end
end

--场景名字更改
function Scene:response12035(vo)
    print("改名字了：",vo.new_name)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        RoleController:getInstance().model.mainRoleVo.name = vo.new_name
    end
    if obj then
        local _info = obj.vo
        _info.name = vo.new_name
        obj:updateName()
    end
end

--更新城战皇冠信息
function Scene:response12036(vo)
    local obj,isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.crown = vo.crown
    end

    if obj then
        local _info = obj.vo
        _info.crown = vo.crown
        obj:updateName()
    end
end

function Scene:setCommonMount(obj, isSelf, bool)
    if isSelf then
        obj.isCommonMount = bool

        if bool then
            AutoFighting:getInstance():stopAutoFight()
            self:setCancelMove(function ()
                Message:getInstance():showMessage("正在共骑中，不可移动!")
            end)
        else
            self:setCancelMove()
        end
    end
end

--坐骑共乘
function Scene:response12037(vo)
    local lastState = self.doubleMountVo and self.doubleMountVo.state or -1
    self.doubleMountVo = vo
    local obj1, isMain1 = self:getRoleObj(vo.main_key)  -- 邀请者
    local obj2, isMain2 = self:getRoleObj(vo.common_key) -- 被邀请者
    if vo.state > 0 then
        if obj1 and obj1.vo and obj2 and obj2.vo then
            -- 若自己是被邀请者 则跟随邀请者 且 不能移动
            self:setCommonMount(obj2, isMain2, vo.main_key)
            -- 隐藏被邀请者及其跟随者
            self:setRoleVisibleByKey(vo.common_key, false)
            local _info = obj1.vo
            _info.common_mount_state = 1
            _info.main_mount_pkey = vo.main_key
            _info.common_mount_pkey = vo.common_key
            -- 在邀请者上显示被邀请者，若我是被邀请者，镜头锁定邀请者
            self:refreshBackMan(_info)
            local nameVo = {
                name = obj2.vo.name,
            }
            obj1:showDoubleMountName(nameVo)
        end
        
        if isMain1 then
            -- 若我是邀请者 那么 主界面上“邀请”按钮 变为 “请离”
            --GlobalEventSystem:fire(GlobalEventType.MAINUI_CHANGE_DOUBLE_MOUNT, obj2)
        elseif isMain2 then
            -- 若我是被邀请者 那么 主界面上显示 “离开” 按钮
            if obj1 then
                self.camera:setTarget(obj1)
            end
        end
    else
        self:setCommonMount(obj2, isMain2, false)
        self:setRoleVisibleByKey(vo.common_key, true)
        if obj1 then
            local _info = obj1.vo
            _info.common_mount_state = 0
            _info.main_mount_pkey = vo.main_key
            _info.common_mount_pkey = vo.common_key
            obj1:totalHorseInfo()
            obj1:removeDoubleMountName()
        end
        if isMain1 then
            --GlobalEventSystem:fire(GlobalEventType.MAINUI_CHANGE_DOUBLE_MOUNT, nil)
            if obj2 and obj2.vo then
                if lastState ~= vo.state then
                    local s = string.format("%s离开双人坐骑", obj2.vo.name or "")
                    Message:getInstance():showMessage(s)
                end
            end
        end
        if isMain2 then
            --GlobalEventSystem:fire(GlobalEventType.MAINUI_CHANGE_DOUBLE_MOUNT, nil)
            if self.role then
                self.camera:setTarget(self.role)
            end
            if lastState ~= vo.state then
                Message:getInstance():showMessage("你已离开双人坐骑")
            end
        end
    end
    -- local mountTmpController = MountsController:getInstance()
    -- mountTmpController:setMountsType()
    GlobalEventSystem:fire(GlobalEventType.MAINUI_CHANGE_MOUNTSTYPE)
end

function Scene:response12038(vo)
    Message:getInstance():showMessage(Proto.errorCode[120][vo.error_code])
end

function Scene:response12039(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.sword_pool_figure = vo.sword_pool_figure
    end

    if obj then
        local info = obj.vo
        info.sword_pool_figure = vo.sword_pool_figure
        obj:initWithVo(info)
        obj:resetAnimate()
    end
end


function Scene:response12040(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain and RoleController:getInstance().model and RoleController:getInstance().model.mainRoleVo then
        local lastMagicWeapon = RoleController:getInstance().model.mainRoleVo.magic_weapon_id or 0
        RoleController:getInstance().model.mainRoleVo.magic_weapon_id = vo.magic_weapon_id
        --第一次装备法器
    end

    if obj then
        local info = obj.vo
        info.magic_weapon_id = vo.magic_weapon_id
        local modelVo = {key = vo.key, x = info.x, y = info.y, magicWeaponID = vo.magic_weapon_id}
        if modelVo.magicWeaponID > 0 then
            self:createMagicWeaponHandler(modelVo, "add")
        else
            self:createMagicWeaponHandler(modelVo, "remove")
        end
    end
    RoleController:getInstance():fire(RoleEvent.RESPONSE_FANCY)
end

function Scene:response12041(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        local lastGodWeapon = RoleController:getInstance().model.mainRoleVo.god_weapon_id or 0
        RoleController:getInstance().model.mainRoleVo.god_weapon_id = vo.god_weapon_id
    end

    if obj then
        local _info = obj.vo
        _info.god_weapon_id = vo.god_weapon_id
        obj:initWithVo(_info)
        obj:resetAnimate()
    end
end

--更新神灵形象
function Scene:response12063(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    local changeGodId = vo.magic_weapon_id  --协议指定的时候，这个命名直接用了法宝的。
    local mainRoleVo = RoleController:getInstance().model and RoleController:getInstance().model.mainRoleVo or nil
    if isMain and mainRoleVo then
        local lastMagicWeapon = mainRoleVo.god_id or 0
        mainRoleVo.god_id = changeGodId
    end

    if obj then
        local info = obj.vo
        info.god_id = changeGodId
        local modelVo = {key = vo.key, x = info.x, y = info.y, god_id = changeGodId}
        if modelVo.god_id > 0 then
            self:createShenlingHandler(modelVo, "add")
        else
            self:createShenlingHandler(modelVo, "remove")
        end
    end
end


--更新神灵形象
function Scene:response12076(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    local cat_id = vo.cat_id  --协议指定的时候，这个命名直接用了法宝的。
    local mainRoleVo = RoleController:getInstance().model and RoleController:getInstance().model.mainRoleVo or nil
    if isMain and mainRoleVo then
        local lastCatID = mainRoleVo.cat_id or 0
        mainRoleVo.cat_id = lastCatID
    end

    if obj then
        local info = obj.vo
        info.cat_id = cat_id
        local modelVo = {key = vo.key, x = info.x, y = info.y, cat_id = cat_id}
        if modelVo.cat_id > 0 then
            self:createCatHandler(modelVo, "add")
        else
            self:createCatHandler(modelVo, "remove")
        end
    end
end

--更新pk值
function Scene:response12045(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.pkvalue = vo.pk_value
        RoleController:getInstance().model.mainRoleVo.pk_kill = vo.pk_kill
        RoleController:getInstance().model.mainRoleVo.chivalry = vo.chivalry
        RoleController:getInstance().model.mainRoleVo.pk_protect_time = vo.pk_protect_time
        RoleController:getInstance().model.pkstate = vo.pk
    end

    if obj then
        local info = obj.vo
        info.pkvalue = vo.pk_value
        info.pk_kill = vo.pk_kill
        info.chivalry = vo.chivalry
        info.pk_protect_time = vo.pk_protect_time
        info.pkstate = vo.pk
        obj:updateName()
    end
end    

--更新妖灵
function Scene:response12046(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.pet_weapon_id = vo.pet_weapon_id
    end
    if obj then
        local info = obj.vo
        info.pet_weapon_id = vo.pet_weapon_id
        obj:initWithVo(info)
        obj:resetAnimate()
    end

    if self.petMap[vo.key] then
        local info = self.petMap[vo.key].vo
        info.pet_weapon_id = vo.pet_weapon_id
        self.petMap[vo.key]:initWithVo(info)
    end
end

-- 掉落归属更新
function Scene:response12048(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.is_drop_owner = vo.is_drop_owner
        RoleController:getInstance().model.mainRoleVo.is_drop_py = vo.is_drop_py
        RoleController:getInstance().model.mainRoleVo.is_drop_py_sl = vo.is_drop_py_sl
    end
    if obj then
        local info = obj.vo
        info.is_drop_owner = vo.is_drop_owner
        info.is_drop_py = vo.is_drop_py
        info.is_drop_py_sl = vo.is_drop_py_sl
        obj:updateName()
    end

    GlobalEventSystem:fire(GlobalEventType.ON_DROP_OWNER_CHANGE, vo)
end

--境界信息更新
function Scene:response12049(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        RoleController:getInstance().model.mainRoleVo.stage_id = vo.stage_id
    end

    if obj then
        local info = obj.vo
        info.stage_id = vo.stage_id
        obj:updateName()
    end
end

function Scene:request12021(...)
    self:send(12021, ...)
end

function Scene:response12021(vo)
    for var =1, #vo.droplist do
        List.PushBack(self.dropList, {vo.droplist[var], "add"})
    end
end

--@param isPick 是否需要拾取播放动画
function Scene:addDropVirtual(vo, isPick)
    local _math = math
    local _logic = self.role:getLogicPos()

    local sqrt = math.ceil(math.sqrt(#vo))
    for var =1, #vo do
        local function _build(num)
            local _vo = {}
            _vo.isVirtural = true
            _vo.goodstype = vo[var].goods_id
            _vo.x =  _logic.x
            _vo.y =  _logic.y
            _vo.num = vo[var].goods_num or 1
            _vo.key = _vo.goodstype.."_".._vo.x.."_".._vo.y.."_"..(num or 0)
            _vo.var = var
            _vo.sqrt = sqrt

            List.PushBack(self.dropList, {_vo, "add"})

            if not isPick then
                _vo.code = 1
                _vo.dropx = _vo.x
                _vo.dropy = _vo.y
                local function func()
                    self:playVirturalDrop(_vo)
                end
                performWithDelay(self.delayNode, func, 0.15 * (var -1))
            end    
        end
        _build(var)
    end
end

function Scene:response12022(vo)
    for var =1, #vo.removelist do
        List.PushBack(self.dropList, {{key = vo.removelist[var]}, "remove"})
    end
end

function Scene:request12023(...)
    local t = {...}
    self:send(12023, ...)
end

function Scene:playVirturalDrop(vo)
    if self.role then
        local goodsCfg = Config.getGoods(vo.goodstype)
        local resPath = goodsCfg.drop_icon
        local _sp = cc.Sprite:create(string.format(GoodsUtil.dropIconPath, resPath))

        local goodsLbl = cc.Label:create()
        goodsLbl:setPosition(cc.p(36, -10))
        goodsLbl:setSystemFontSize(16)
    local dropNum = vo.num  
    goodsLbl:setString(goodsCfg.goods_name .. "x" .. dropNum)
        goodsLbl:setColor(cc.c3b(255, 254, 209)) 
        goodsLbl:setAnchorPoint(cc.p(0.5,0))
        goodsLbl:setLabelEffect(cc.LabelEffect.SHADOW)
        _sp:addChild(goodsLbl)
        _sp:setScale(0.8)

        local pos = SceneUtils.logicToPixel(cc.p(vo.dropx, vo.dropy))
        local col = math.ceil(vo.var / vo.sqrt)
        local row = vo.var % vo.sqrt
        if row == 0 then
           row = vo.sqrt 
        end  
        if vo.sqrt % 2 == 0 then
            pos.x =  pos.x - (math.ceil(vo.sqrt / 2) - row) * 70 - 36
            pos.y =  pos.y - (math.ceil(vo.sqrt / 2) - col + 1) * 70 - 36
        elseif vo.sqrt % 2 == 1 then
            pos.x =  pos.x - (math.ceil(vo.sqrt / 2) - row) * 70
            pos.y =  pos.y - (math.ceil(vo.sqrt / 2) - col + 1) * 70
        end    

        pos = cc.p(pos.x , Scene.SCENE_HEIGHT - pos.y - 70)
        _sp:setPosition(pos)
        HandleRenderUnit:getCoreScene():addToRenderGroup(_sp, cc.RenderQueue.GRQ_SHADOW)

        local nodePosX = _sp:getPositionX()
        local nodePosY = _sp:getPositionY()

        --Bezier曲线的范围    
        local gap = math.random(80, 100)
        if nodePosX < self.role:getPixelPos().x then   
            gapX = -gap
        else
            gapX = gap      
        end 
        local roleY = Scene.SCENE_HEIGHT - self.role:getPixelPos().y + 70
        if nodePosY < roleY then   
            gapY = -gap
        else
            gapY = gap
        end   

        local aBezierConfig ={
            cc.p(pos.x , pos.y), 
            cc.p(pos.x + gapX, pos.y + gapY), 
            cc.p(self.role:getPixelPos().x, Scene.SCENE_HEIGHT - self.role:getPixelPos().y + 70),
        } 
        local function _fuc()
            Message:getInstance():showGoodsMSG(vo.goodstype, vo.num)
            _sp:removeFromParent(true)
        end

        local function _bezierTo()
            local bezierToenemy = cc.BezierTo:create(1, aBezierConfig)
            local action = cc.EaseIn:create(bezierToenemy, 2)
            _sp:runAction(cc.Sequence:create(action, cc.CallFunc:create(_fuc)))
        end    

        local function _cb()
            _sp:runAction(cc.RepeatForever:create(cc.Sequence:create(
                cc.MoveTo:create(0.2, cc.p(nodePosX, nodePosY + 35)),
                cc.MoveTo:create(0.2, cc.p(nodePosX, nodePosY + 35)),
                cc.DelayTime:create(3),
                cc.CallFunc:create(_bezierTo)
                )
              )
            )
        end
        _sp:runAction(cc.Sequence:create(cc.Spawn:create(cc.Sequence:create(cc.MoveTo:create(0.2, cc.p(nodePosX, nodePosY + 110)), 
            cc.MoveTo:create(0.2, cc.p(nodePosX, nodePosY + 35))), 
            cc.RotateTo:create(0.2, 0)), 
            cc.CallFunc:create(_cb))
        )

        List.PushBack(self.dropList, {{key = vo.key}, "remove"})
    end
end

function Scene:response12023(_vo)
    local _list = _vo["pickuplist"]
    for var=1, #_list do
        local vo = _list[var]
        if vo.code == 1 or vo.code == 2 then
            local drop = self.dropMap[vo.key]
            if drop then
                --防止多次添加到list
                if not drop._ispicked then
                    List.PushBack(self.dropList, {{key = vo.key}, "remove", true})
                end
                drop._ispicked = true
            end
        else
            if vo.leave_time > 0 then --拾取时间还没到
                Message:getInstance():showMessage(string.format(SceneWords[1], vo.leave_time))
            else 
                Message:getInstance():showMessage(Proto.errorCode[120][vo.code])
            end
        end
    end
end

--变身形象更新
function Scene:response12025(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if not obj then return end
    local group = vo.group or obj.vo.group --如果没有下发变身后的阵营，则用以前的阵营
    if isMain then
        RoleController:getInstance().model.mainRoleVo.figure = vo.figure
        RoleController:getInstance().model.mainRoleVo.group = group
    end

    if obj then
        local _info = obj.vo
        _info.figure = vo.figure
        _info.group = group 
        obj:initWithVo(_info)
        obj:resetAnimate()
    end
end

--[[12026 - 护送状态
string  key 玩家key
int8    convoy  护送状态（0无，1白，2蓝，3紫，4橙）
int8    is_show 是否显示（1是0否）[字段没有了, 默认显示]
]]
function Scene:response12026(vo)
    if not self.role then
        return
    end
    vo.is_show = vo.convoy > 0 and 1 or 0

    local role = SceneUtils.getMasterRole(vo.key)
    if not role then return end

    --全局广播
    role.vo.convoy = vo.convoy
    role.vo.show_convoy = vo.is_show or 1
    role:updateName()

    if vo.is_show == 1 then
        local roleVo = role.vo
        local logicPos = role:getLogicPos()
        local speed = (roleVo.attlist and roleVo.attlist.speed + 15) or 250
        local escortVo = {pkey = vo.key, mid = vo.convoy, name = "", dir = 1, x = logicPos.x, y = logicPos.y, speed = speed, action = "stand"}

        self:createEscortHandler(escortVo, "add")
    else
        vo.pkey = vo.key
        self:createEscortHandler(vo, "remove")
    end
end

--战斗分组更新
function Scene:response12027(vo)
    print("收到12027！！！！！！！！！！！！！！！！！！！！！")
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        print("主角分组更新：" .. vo.group)
        RoleController:getInstance().model.mainRoleVo.group = vo.group
    end

    if obj then
        obj.vo.group = vo.group
        obj:initWithVo(obj.vo)
    end
end

--称号信息更新
function Scene:response12028(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        RoleController:getInstance().model.mainRoleVo.designlist = vo.designlist
    end

    if obj then
        local _info = obj.vo
        _info.designlist = vo.designlist
        obj:updateName()
    end
end

function Scene:response12075(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        RoleController:getInstance().model.mainRoleVo.war_cl_list = vo.war_cl_list
    end

    if obj then
        local _info = obj.vo
        _info.war_cl_list = vo.war_cl_list
        obj:updateName()
    end
end

--采集标记
function Scene:response12029(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if obj then
        if vo.flag == 1 then
            obj:showPicking(true)
        else
            obj:showPicking(false)
        end
    end
end

--vip更新
function Scene:response12030(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        RoleController:getInstance().model.mainRoleVo.vip = vo.viplv
        GlobalEventSystem:fire(GlobalEventType.ROLE_INFO_CHANGE, {vip = vo.viplv})  -- vip 更新
        if GlobalClientCfg.isBT then
            GlobalEventSystem:fire(GlobalEventType.BT_VIP_SKILL, vo.viplv < 6 and true or false)
            VipController:getInstance():fire(VipEvents.REQUEST_47001)
        elseif GlobalClientCfg.isKorea then 
            GlobalEventSystem:fire(GlobalEventType.BT_VIP_SKILL, vo.viplv < 4 and true or false)
            VipController:getInstance():fire(VipEvents.REQUEST_47001)

        end 
    end

    if obj then
        obj.vo.vip = vo.viplv
        obj:updateName()
    end
end

function Scene:response12031(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.lv = vo.lv
        GlobalEventSystem:fire(GlobalEventType.ROLE_LEV_UPDATE, MainMenuOpenType.Level, vo.lv)
        GlobalEventSystem:fire(GlobalEventType.ROLE_LEVEL_GUIDE, vo.lv)
        if GlobalClientCfg.isKorea then
            SdkUtils.onRoleDataUpdate("role_level", vo.lv)
        end
    end
    if obj then
        obj:playAnimate2("assets/effect/uieffect/10025.csprite", "action", nil, cc.p(0, 80), 1)
        obj.vo.lv = vo.lv
    end
end

--战场更新
function Scene:response12032(vo)
    local obj, isMain = self:getRoleObj(vo.key)

    if isMain then
        RoleController:getInstance().model.mainRoleVo.group = vo.group
        RoleController:getInstance().model.mainRoleVo.bf_score = vo.score
        RoleController:getInstance().model.mainRoleVo.double_hit = vo.double_hit
    end

    if obj then
        local _info = obj.vo
        _info.group = vo.group
        _info.bf_score = vo.score
        _info.double_hit = vo.double_hit
        obj:updateName()
    end
end

-- 请求当前场景内的线路
function Scene:request12050(scene_id)
    self:send(12050, scene_id)
end
function Scene:response12050(vo)
    self:fire(WorldMapEventType.CREATE_MENU, vo)
end

---通知客户端移动
function Scene:response12051(vo)
    if self.isStoryScene then 
        local function callBack()
           AutoFighting:getInstance():startAutoFight(nil, 1)
        end
        Scene:getInstance():fire(SceneEvent.FIND_SCENE_OBJ, FindObjType.Point, vo.scene_id, cc.p(vo.x,vo.y), callBack)
    else 
        self.delayNode:stopAllActions()
        local function _delay()
            local function callBack()
               AutoFighting:getInstance():startAutoFight(nil, 1)
            end
            Scene:getInstance():fire(SceneEvent.FIND_SCENE_OBJ, FindObjType.Point, vo.scene_id, cc.p(vo.x,vo.y), callBack)
        end
        performWithDelay(self.delayNode, _delay, self.changeSceneJumping and 2.5 or 0)

    end
end

function Scene:request12053()
    self:send(12053)
end

function Scene:response12053(vo)
    local role, isMain = self:getRoleObj(vo.key)
    if isMain then
        local mainRoleVo = self.role.vo
        if vo.couple_name ~= "" and mainRoleVo.couple_name == "" then
            --结婚照，提前赋值伴侣名字，防止读取不到
            mainRoleVo.couple_name = vo.couple_name
            MarryController:getInstance():openQuickShot(vo.marry_type)
        end
        mainRoleVo.marry_type = vo.marry_type
        mainRoleVo.couple_name = vo.couple_name
        mainRoleVo.couple_sex = vo.couple_sex
        mainRoleVo.couple_key = vo.couple_key
    end

    if role then
        role.vo.marry_type = vo.marry_type
        role.vo.couple_name = vo.couple_name
        role.vo.couple_sex = vo.couple_sex
        role.vo.couple_key = vo.couple_key
        role:initWithVo(role.vo)
    end
end

function Scene:request12054()
    self:send(12054)
end

function Scene:response12054(vo)
    local role, isMain = self:getRoleObj(vo.key)
    if isMain then
        local mainRoleVo = self.role.vo
        mainRoleVo.cruise_state = vo.cruise_state
        --主角巡游状态改变
        GlobalEventSystem:fire(GlobalEventType.CRUISE_STATE_CHANGE)
    end
    
    if role then
        role.vo.cruise_state = vo.cruise_state
        role:setVisible(vo.cruise_state == 0)
        role:setOpacity(255)
    end
end

function Scene:request12056()
    self:send(12056)
end

function Scene:response12056(vo)
    local role, isMain = self:getRoleObj(vo.key)
    if isMain then
        local mainRoleVo = self.role.vo
        mainRoleVo.ring_lv = vo.ring_lv
    end
    if role then
        role.vo.ring_lv = vo.ring_lv
        role:initWithVo(role.vo)
    end
end

--烟花广播
function Scene:request12057()
    self:send(12057)
end

function Scene:response12057(vo)
    local sp = ActionTimeLineUtils.getAnimate("assets/effect/uieffect/50098.csprite", "action")
    local pos = SceneUtils.logicToPixel(vo)
    sp:setPosition(pos.x, Scene.SCENE_HEIGHT - pos.y)
    GlobalEventSystem:fire(GlobalEventType.MAINUI_CHANGE_SCROLLBTN, false)
    HandleRenderUnit:getCoreScene():addToRenderGroup(sp, cc.RenderQueue.GRQ_AIR)
end

--更新采集次数
function Scene:request12058()
    self:send(12058)
end

function Scene:response12058(vo)
    local gather = self.monsterMap[vo.mkey]
    if gather then
        gather.vo.collect_count = vo.collect_count
        gather:setProgress()
    end
end

--怪物速度
function Scene:request12060()

end

function Scene:response12060(vo)
    self.monSpeedMap = self.monSpeedMap or {}
    local obj = self.monsterMap[vo.key]
    if obj then
        obj:setMoveSpeed(vo.speed)
    else
        self.monSpeedMap[vo.key] = vo.speed
    end
end

-- 宠物飞行器更新
function Scene:request12061()

end

function Scene:response12061(vo)
    RoleController:getInstance().model.mainRoleVo.pet_fly_id = vo.pet_fly_id
    RoleController:getInstance().model.mainRoleVo.pet_fly_step = vo.pet_fly_step
    
    local obj = self.petMap[vo.key]
    if obj then
        obj:updatePetFly(vo.pet_fly_id)
    end
end

-- 斗气更新
function Scene:request12062()

end

function Scene:response12062(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.douqi_id = vo.douqi_id
    end  
    if obj then
        local _info = obj.vo
        _info.douqi_id = vo.douqi_id       
        obj:initWithVo(_info)
        obj:resetAnimate()
    end
end

function Scene:request12064()

end

function Scene:response12064(vo)
    print("response12064")
    local _ , isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.pet_wing_id = vo.pet_wing_id
    end
    local obj = self.petMap[vo.key]
    if obj then
        obj:updatePetWing(vo.pet_wing_id)
    end
end

function Scene:request12065()

end

function Scene:response12065(vo)
    print("response12065")
    local _ , isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.pet_weapon_id = vo.pet_weapon_id
    end
    local obj = self.petMap[vo.key]
    if obj then
        obj:updatePetWeapon(vo.pet_weapon_id)
    end
end

function Scene:request12066()

end

function Scene:response12066(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.gvip_flag = vo.gvip_flag
    end
    
    if obj then
        local info = obj.vo
        info.gvip_flag = vo.gvip_flag
        obj:initWithVo(info)
        obj:resetAnimate()
    end
end

function Scene:request12067()
end

function Scene:response12067(vo)
    print("-------------------12067 -----------------")
    dump(vo)
    GlobalEventSystem:fire(GlobalEventType.UPDATE_MINE_STATE, vo)
end

function Scene:request12068()
end

function Scene:response12068(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        local lastCloakId = RoleController:getInstance().model.mainRoleVo.cloak_id or 0
        RoleController:getInstance().model.mainRoleVo.cloak_id = vo.cloak_id
    end
    if obj then
        obj.vo.cloak_id = vo.cloak_id
        obj:updateResource()
        obj:resetAnimate()
    end
    RoleController:getInstance():fire(RoleEvent.RESPONSE_FANCY)
end

function Scene:request12069()
end

function Scene:response12069(vo)
    local obj, isMain = self:getRoleObj(vo.key)
    if isMain then
        local lastCloakId = RoleController:getInstance().model.mainRoleVo.circle_id or 0
        RoleController:getInstance().model.mainRoleVo.circle_id = vo.cloak_id
    end
    if obj then
        obj.vo.circle_id = vo.cloak_id
        obj:updateResource()
        obj:resetAnimate()
    end
    RoleController:getInstance():fire(RoleEvent.RESPONSE_FANCY)
end
--[[
    12071 - 获取珍宝列表
    客户端请求:
    空
    服务端响应:
    arr	zblist	珍宝列表
        uint32	key	        珍宝key
        uint32	boss_id	    boss id
        int32	leave_time	剩余时间 秒
]]
function Scene:request12071()
    self:send(12071)
end

function Scene:response12071(vo)
    for var = 1, #vo.zblist do
        List.PushBack(self.zbList, {vo.zblist[var], "add"})
    end
end

--[[
    12072 - 移除珍宝列表
    客户端请求:
    空
    服务端响应:
    arr	removelist	移除珍宝列表
        uint32	key	珍宝key
]]
function Scene:request12072()
    self:send(12072)
end

function Scene:response12072(vo)
    for var = 1, #vo.removelist do
        List.PushBack(self.zbList, {vo.removelist[var], "remove"})
    end
end

--[[
    12073 - 获取珍宝信息
    客户端请求:
    uint32	key	珍宝key
    服务端响应:
    uint16	leave_time	剩余时间 秒
    uint8	times	    剩余次数
    arr	    goods_list	物品列表
        uint32	goods_id	物品类型id
]]
function Scene:request12073(key)
    self:send(12073, key)
end

function Scene:response12073(vo)
    self:fire(SceneEvent.RESPONSE_12073, vo)
end

--[[
    12074 - 珍宝寻宝
    客户端请求:
    uint32	key	珍宝key
    uint8	type	寻宝类型 1普通2至尊
    服务端响应:
    uint32	res	        结果码
    arr	    goods_list	获得的物品列表
        uint32	goods_id	物品类型id
        uint32	goods_num	物品数量
]]
function Scene:request12074(key, type, is_auto_buy)
    self:send(12074, key, type, is_auto_buy)
end

function Scene:response12074(vo)
    if vo.res == 1 then
        self:request12073(vo.key)
        local rewardView = require("game.modules.mazeTreasure.RewardView").new(vo.goods_list, "digBossView", nil, self.instance)
    elseif vo.res == 23 then -- 钥匙不足
        local key = { 
            {MallType.BIND_GOLD, 20410}, -- 普通钥匙 用绑元购买
            {MallType.COMMONLY, 20411}, -- 至尊购买 用元宝
        }
        MallController:getInstance():request38004(key[vo.type][1], key[vo.type][2])
    elseif vo.res == 24 then
        ChargeTipsView:getInstance():showTips(ChargeTipsView.TypeDiamond)
    else
        Message:getInstance():showMessage(Proto.errorCode[120][vo.res])        
    end
end
--=================================================================
--最后一个参数为是否远程提交
function Scene:request32001(...)
    self:send(32001, ...)
    local args = {...}
    local isFarSubmit = args[#args]
    --远程提交不播放语音
    if isFarSubmit == true then
        return
    end
    local _npc = self.npcMap[self.selectNpcKey]
    if _npc then
        _npc:showTalk()
    end
end

-- 触发场景buff
function Scene:request12099(...)
    self:send(12099, ...)
end

function Scene:response12099(vo)
end

function Scene:response32001(npcStatusVo)
    --刷新npc状态
    self:fire(SceneEvent.RESPONSE_32001, npcStatusVo)
end

--根据参数显示或者隐藏当前模型
function Scene:setObjsVisible(bl, options)
    local objsList = {
        self.roleMap, 
        self.monsterMap, 
        self.npcMap, 
        self.doorMap, 
        self.flyMap, 
        self.dropMap,
        self.petMap,
        self.magicWeaponMap,
        self.catMap,
        self.shenlingMap,
    }

    if options and type(options) == "table" then
        for k, v in pairs(options) do
            for key, var in pairs(objsList[v]) do
                var.model:setVisible(bl)
            end
            if v == 7 then 
                self:setPetHide(not bl)
            elseif v == 2 then 
                self:setMonsterHide(not bl)
            end
        end
        return
    end

    for k, v in pairs(objsList) do
        for key, var in pairs(v) do
            if var.model then
                var.model:setVisible(bl)
            end
        end 
    end
    self:setPetHide(not bl)
    self:setMonsterHide(not bl)
end

function Scene:update(nowTime, elapseTime)
    self.frame = self.frame + 1

    --更新角色 镜头 跟随物
    self:updateMainRole(nowTime, elapseTime)

    for key, var in pairs(self.roleMap) do
        var:update(nowTime, elapseTime)
        self:updateFollowers(var.vo.pkey, nowTime, elapseTime)
    end

    for key, var in pairs(self.monsterMap) do
        var:update(nowTime, elapseTime)
        self:updateFollowers(var.vo.mkey, nowTime, elapseTime)
    end

    for key, var in pairs(self.vipSkillMonMap) do
        var:update(nowTime, elapseTime)        
    end

    --更新ex技能背景

    if RenderUnitMoved then
        self.loadingUtils:update()
        RenderUnitMoved = false
    end
    
    self:inteligentRender(nowTime, elapseTime)

    --更新虚拟

    --掉落拾取
    if self.lastPickDroptime and GlobalMsTime - self.lastPickDroptime > (1 / self.checkDropPerSecond) then
        if self:dropCheckHandler() == 0 then
            self.lastPickDroptime = nil
            self.isPickFirst = false
            self.startRunPick = false
            if AutoFighting:getInstance():isAutoFight() and not self.isGoldCopyScene then
                AutoFighting:getInstance():setLastAttackTime()
            end
        else
            self.lastPickDroptime = GlobalMsTime
        end
    elseif not self.lastPickDroptime and not SceneUtils.isNoneCanDrop() then
        self.lastPickDroptime = GlobalMsTime
    end

    --更新死亡列表
    for key, deadVo in pairs(self.monsterKeepMap or {}) do
        deadVo.gap = deadVo.gap - elapseTime
        if deadVo.gap < 0 then
            self.monsterKeepMap[key] = nil
        end
    end

    self.frame = self.frame > 120 and 1 or self.frame


    self:sceneZoneCheck()
end

function Scene:sceneZoneCheck()
    if self.isExistSceneBuff then 
        if self.role then 
            local curLogicPos = self.role:getLogicPos()
            if not self.last_logic_pos or (GlobalMsTime - self.last_logic_time >= 0.2 and curLogicPos ~= self.last_logic_pos) then 
                local zoneVo = self:zoneCheck(curLogicPos)
                if zoneVo then 
                    if zoneVo.mkey == -1 then   --惊飞鸽子
                        self:showScareBird()
                    elseif zoneVo.mkey == -2 then --boss镜头偏移
                        self:removeZone(zoneVo.mkey) 
                        local cfg = CopyTable(Config.getConfig("Mon", 10503))
                        cfg.mkey = zoneVo.mkey
                        cfg.speed = 1000
                        local obj = Monster.new(cfg)
                        obj.pickType = ObjPickType.Buffer
                        obj:setPixelPos(self.role:getPixelPos())
                        obj:setVisible(false)
                        Scene:getInstance().camera:setTarget(obj, true)
                        obj:doMove(nil, SceneUtils.pixelTologic(StoryUtil.firstBossCameraPos))
                        self.monsterMap[zoneVo.mkey] = obj
                        GlobalTimerQuest:AddDelayQuest(function( ... )
                            if self.monsterMap[zoneVo.mkey] then 
                                self.monsterMap[zoneVo.mkey]:delete()
                                self.monsterMap[zoneVo.mkey] = nil
                            end
                        end,5)
                    else 
                       self:request12099(zoneVo.mkey) 
                    end
                end
                self.last_logic_pos = curLogicPos
                self.last_logic_time = GlobalMsTime
            end
        end
    end
end

function Scene:showScareBird()
    if self.isPlayFlyTime and GlobalMsTime - self.isPlayFlyTime < 4 then 
        return 
    end
    self.isPlayFlyTime = GlobalMsTime
    for k,v in pairs(self.monsterMap) do
        if v.vo.mid == 10112 then 
            v:playAnimate("fly"..math.random(3)*3)
        end
    end
    local function _delay()
        for k,v in pairs(self.monsterMap) do
            if v.vo.mid == 10112 and v.model then  
                self.monsterMap[k]:delete()
                self.monsterMap[k] = nil
            end
        end 
    end
    performWithDelay(self.delayNode, _delay, 1.2)
end

function Scene:request12047(...)
    --人物在巡游不可飞行
    if self:isCruise() then return end
    self:send(12047, ...)
end

function Scene:response12047(vo)
    Message:getInstance():showMessage(Proto.errorCode[120][vo.res])
    if vo.res == 1 and RoleController:getInstance().model.mainRoleVo.vip == 0 then
        Message:getInstance():showMessage("使用成功，成为会员即可无限飞行")
    end
    if vo.is_fly == 1 then
        --清空寻路信息，直接飞行
        if self.role then
            --新的小飞鞋逻辑，修改程瞬间移动
            AutoFighting:getInstance():resetLastAutoFight()
            self.role:doStand()
            if self.flyShoeTimer then
                GlobalTimerQuest:CancelQuest(self.flyShoeTimer)
            end
            self.flyShoeTimer = GlobalTimerQuest:AddDelayQuest(function()
                GlobalEventSystem:fire(GlobalEventType.SHOW_FINDPATH_TEXT, 2, false)
                GlobalEventSystem:fire(GlobalEventType.OPERATE_MOVE_END)
                GlobalEventSystem:fire(GlobalEventType.OVERFLY_END)
            end, 0.7)
            self.role:setLogicPos(cc.p(vo.x, vo.y))
            RoleController:getInstance().model.mainRoleVo.x = vo.x
            RoleController:getInstance().model.mainRoleVo.y = vo.y
            Scene.instance:fire(SceneEvent.REQUEST_12001, vo.x, vo.y, 5)
            if self.not_fly_callback then
                GlobalEventSystem:fire(GlobalEventType.START_AUTO_FIGHT)
                self.not_fly_callback = false
            end
        end
    elseif vo.res == 1 then
        self.isChangeSceneByFly = true
        if self.not_fly_callback then
            GlobalEventSystem:fire(GlobalEventType.START_AUTO_FIGHT)
            self.not_fly_callback = false
        end
    end
end

--场景名字更改
function Scene:response13029(vo)
    print("改名字了：",vo.sex)
    local obj, isMain = self:getRoleObj(vo.pkey)
    if isMain then
        RoleController:getInstance().model.mainRoleVo.sex = vo.sex
        GlobalEventSystem:fire(GlobalEventType.CHANGE_SEX_SUCCESS) 
    end
    if obj then
        local _info = obj.vo
        _info.sex = vo.sex
        obj:initWithVo(_info)
        obj:resetAnimate()
    end
end

function Scene:inteligentRender(nowTime, elapseTime)
    if self.changeSceneJumping then return end

    --策略渲染
    if self.frame%2 == 0 then
        self:createDoorHandler()
        self:createFlyHandler()
        --创建虚拟
    end

    self:createSkillEffectHandler(nowTime, elapseTime)

    local _remainder = self.frame%4
    if _remainder == 0 then
        --技能队列
        if self.forceRun then
            if nowTime - self.forceRun > 2 then
                self.forceRun = false
            end
        end

        self:showLastSelectNpc()

        if self.lastPointClean then
            if nowTime - self.lastPointClean > 0.1 then
                if self.pointNode then
                    self.pointNode:removeFromParent(true)
                    self.pointNode = nil
                end

                self.lastPointClean = nil
            end
        end
    elseif _remainder == 1 then
        self:createNpcHandler()
        self:createDropHandler()
        self:createZbHandler()
        self:createVIPSkillHandler()
    elseif _remainder == 2 then
        self:createRoleHandler()
    elseif _remainder == 3 then
        local size = min(5, List.Size(self.monsterList))
        for index = 1, size do
           self:createMonsterHandler() 
        end
    end

    _remainder = self.frame%7
    if _remainder == 2 then
        self:checkSceneNpcArea()
    elseif _remainder == 3 then
        self:createFollowerHandler()
    end

    --持续施法结束

    --    主角引导光环
    if self.frame%30 == 0 then
        if self.role then
            if self.guidePos and RoleController:getInstance().model.mainRoleVo.lv < 41 and Scene.SHOW_FIHGT_INFO and (self.cfg and self.cfg.type == 0) then
                local _offest = self.role:getLogicPos()
                _offest = cc.pSub(self.guidePos,_offest)
                _offest = cc.pNormalize(_offest)
                self.role:showGuideCircle(SceneUtils.getDirectionNum(_offest))
            else
                self.role:showGuideCircle(0)
            end
        end
    end
end

function Scene:showLastSelectNpc()
    local _npc = self.npcMap[self.selectNpcKey]
    if _npc then
        local flag = SceneUtils.get2ObjDistance(self.role, _npc)
        if self.lastSelectNpcFlag and self.lastSelectNpcFlag ~= flag then
            self:changeNpcTarget(nil)
        else
            self.lastSelectNpcFlag = flag
        end
    end
end

function Scene:updateMainRole(nowTime, elapseTime)
    if self.lastMainRole then
        self.lastMainRole:update(nowTime, elapseTime)
    end

    if not self.role then return end

    self.role:update(nowTime, elapseTime)
    if not self.isLoadingMap then
        self.camera:update(nowTime, elapseTime)
    end
    self:updateFollowers(self.role.vo.pkey, nowTime, elapseTime)
end

function Scene:updateFollowers(key, nowTime, elapseTime)
    if self.petMap[key] then
        self.petMap[key]:update(nowTime, elapseTime)
    end

    if self.followerMap[key] then
        self.followerMap[key]:update(nowTime, elapseTime)
    end

    if self.escortMap[key] then
        self.escortMap[key]:update(nowTime, elapseTime)
    end

    if self.magicWeaponMap[key] then
        self.magicWeaponMap[key]:update(nowTime, elapseTime)
    end

    if self.shenlingMap[key] then
        self.shenlingMap[key]:update(nowTime, elapseTime)
    end
    if self.catMap[key] then
        self.catMap[key]:update(nowTime, elapseTime)
    end
end

function Scene:following(materObj, endPos)
    local function delay()
        for _, follower in pairs(self.followerMap) do
            follower:doFollow(nil, cc.p(endPos.x + math.random(-2, 2),endPos.y + math.random(-2, 2)), nil, MoveEndCircle[ObjPickType.Follower])
        end

        local rolePkey = materObj.vo.mkey or materObj.vo.pkey
        --print("+++++++++++", rolePkey, self.petMap[rolePkey])
        if self.petMap[rolePkey] then
            self.petMap[rolePkey]:doFollow(nil, cc.p(endPos.x + math.random(-4, -3), endPos.y + math.random(1, 2)), nil, MoveEndCircle[ObjPickType.Pet])
        end

        if self.catMap[rolePkey] then
            self.catMap[rolePkey]:doFollow(nil, cc.p(endPos.x + math.random(1, 2), endPos.y + math.random(-2, -1)), nil, MoveEndCircle[ObjPickType.Cat])
        end


        if self.escortMap[rolePkey] then
            self.escortMap[rolePkey]:doFollow(nil, cc.p(endPos.x + math.random(-3, 3), endPos.y + math.random(-3, 3)), nil, MoveEndCircle[ObjPickType.Escorter])
        end

        if self.magicWeaponMap[rolePkey] then
            local tx, ty = 1, 6
            if materObj:getDir() == 3 or materObj:getDir() == 9 then
                tx = -1
            end
            self.magicWeaponMap[rolePkey]:doFollow(nil, cc.p(endPos.x + tx, endPos.y - ty), MoveEndCircle[ObjPickType.Escorter])
        end

        if self.shenlingMap[rolePkey] then
            local masterDir = materObj:getDir()
            local tx, ty = 3, -4
            local offsetPos = ShenlingOffsetPos[masterDir]
            if offsetPos then
                tx, ty = offsetPos.x, offsetPos.y
            end
            self.shenlingMap[rolePkey]:doFollow(nil, cc.p(endPos.x + tx, endPos.y + ty), MoveEndCircle[ObjPickType.Escorter])
        end
    end
    local node = materObj:getAirLayer()
    if node then
        performWithDelay(node, delay, 0.1)
    end
end
function Scene:setBufCatch(pKey,bufs)
    --防止角色没刷新的时候，导致buf没法接收
    if not self.bufCaches then 
        self.bufCaches = {}
    end 
    self.bufCaches[pKey] = {bufs = bufs ,lastTime = GlobalMsTime}
     
end 
function Scene:getBufCatch(pKey)
    if not self.bufCaches or  not self.bufCaches[pKey] then 
        return 
    end 
    local list  = self.bufCaches[pKey].bufs
    local msTime = self.bufCaches[pKey].lastTime
    for i ,v in ipairs(list) do 
        local time =   (msTime + v.time) - GlobalMsTime
        time = time > 0 and time or 0
        v.time = time
    end 
    self.bufCaches[pKey] = nil 
    return list
end 
function Scene:createRoleHandler()
    if List.Empty(self.roleList) then return end

    local _t = List.PopFront(self.roleList)
    local _vo = _t[1]

    if ClientCfg.pkey == _vo.pkey then return end

    if _t[2] == "add" then
        if not self.roleMap[_vo.pkey] then
            self.roleNum = self.roleNum + 1
            local _hideType = 0
            if not SceneUtils.hideFilter(_vo) then
                --未超出同屏人数计数
                local isOverFilter = false
                local filterSysNum = SceneUtils.getOverFilterNum(self.sceneId, self.cfg)
                if self.filterRoleNum <= filterSysNum and filterSysNum > 0 then
                    self.filterRoleNum = self.filterRoleNum + 1
                    self.filterRoleKey[_vo.pkey] = true
                    isOverFilter = true
                end
                if (Scene.FAST_MODE or not isOverFilter and self.roleNum > filterSysNum) then
                    _hideType = 1
                end
            end
            local _role = Role.new(_vo, false, _hideType)
            --竞技场对手面向处理
            self:setBirthDir(_role, _vo.x)
            self.roleMap[_vo.pkey] = _role
            
            _role:registerPickInfo()
            self:createFollowObj(_vo, _hideType)
            if SceneUtils.isCanHideMonster(self.sceneId, _vo) then
                local isHide = self:fliterRoleHide(_role)
            end
            self.roleMap[_vo.pkey]:setLogicPos(cc.p(_vo.x, _vo.y))

        else
            self.roleMap[_vo.pkey]:resetVo(_vo)
        end
        --避免多次设置信息
        self.roleMap[_vo.pkey]:setLogicPos(cc.p(_vo.x, _vo.y))
        self.roleMap[_vo.pkey]:setVisible(self.objsVisibleList.role)
        self:refreshBackMan(_vo)

        if self.deadMap[_vo.pkey] then
            self.deadMap[_vo.pkey]:removeFromParent(true)
            self.deadMap[_vo.pkey]=nil
        end
        
        local bufs = self:getBufCatch(_vo.pkey)
        if bufs then 
            self.roleMap[_vo.pkey]:showBuffs(bufs)
        end 

        --发送人物添加事件
        if self.isBossCopyScene or self.isGhostBattleScene then
            GlobalEventSystem:fire(GlobalEventType.ON_PLAYER_ENTER, _vo.pkey, _vo.group)
        end
    else
        local _role = self.roleMap[_vo.pkey]
        if _role then
            self.roleNum = self.roleNum - 1
            self.roleNum = self.roleNum > 0 and self.roleNum or 0
            --同屏人数显示的角色移出九宫
            if self.filterRoleKey[_vo.pkey] then
                self.filterRoleNum = self.filterRoleNum - 1
                self.filterRoleNum = self.filterRoleNum > 0 and self.filterRoleNum or 0
                self.filterRoleKey[_vo.pkey] = false
            end

            self:deleteFollowObj(_role.vo)
            
            _role:delete()
             self.roleMap[_vo.pkey] = nil
        end
        if self.isBossCopyScene or self.isGhostBattleScene then
            GlobalEventSystem:fire(GlobalEventType.ON_PLAYER_LEAVE, _vo.pkey)
        end
    end

    if not List.Empty(self.roleList) then 
        self:createRoleHandler()
    end
end

function Scene:refreshBackMan(vo)
    if vo.common_mount_state and vo.common_mount_state ~= 0 then
        local obj1, isMain1 = self:getRoleObj(vo.main_mount_pkey)
        local obj2, isMain2 = self:getRoleObj(vo.common_mount_pkey)

        self:setCommonMount(obj2, isMain2, vo.main_mount_pkey)
        self:setRoleVisibleByKey(vo.common_mount_pkey,false)
        if obj1 then
            if obj2 then
                obj1:totalHorseInfo(obj2.vo)
            end
        end
        if isMain2 then
            self.camera:setTarget(obj1)
        end
        return true
    else
        return false
    end
end

--创建其他玩家伴生物
function Scene:createFollowObj(roleVo, hideType)
    if not SceneUtils.isNoShowPet() then
        if roleVo.petfigure and type(roleVo.petfigure) == "number" and roleVo.petfigure > 0 then
            local pkey = roleVo.pkey or roleVo.mkey
            local speed = roleVo.speed or roleVo.attlist.speed
            
            local petVoList = {[1] = {pkey = pkey, typeid = roleVo.pettypeid, mid = roleVo.petfigure, petname = roleVo.petname, dir = 1, x = roleVo.x, y = roleVo.y, speed = speed, hideType =(hideType or 0),pet_fly_id = roleVo.pet_fly_id, pet_wing_id = roleVo.pet_wing_id ,pet_weapon_id = roleVo.pet_weapon_id}}
            self:createPetHandler(petVoList, "add")
        end
    end

    if roleVo.convoy and type(roleVo.convoy) == "number" and roleVo.convoy > 0 then
        local speed = roleVo.speed or roleVo.attlist.speed
        local escortVo = {pkey = roleVo.pkey, mid = roleVo.convoy, name = "", dir = 1, x = roleVo.x, y = roleVo.y, speed = speed, action = "stand", hideType = hideType or 0}
        self:createEscortHandler(escortVo, "add")
    end

    if roleVo.magic_weapon_id and type(roleVo.magic_weapon_id) == "number" and roleVo.magic_weapon_id > 0 then
        local pkey = roleVo.pkey or roleVo.mkey
        local modelVo = {key = pkey, x = roleVo.x, y = roleVo.y, magicWeaponID = roleVo.magic_weapon_id, hideType = hideType or 0}
        self:createMagicWeaponHandler(modelVo, "add")
    end

    if roleVo.god_id and type(roleVo.god_id) == "number" and roleVo.god_id > 0 then
        local pkey = roleVo.pkey or roleVo.mkey
        local modelVo = {key = pkey, x = roleVo.x, y = roleVo.y, god_id = roleVo.god_id, hideType = hideType or 0}
        self:createShenlingHandler(modelVo, "add")
    end

    if roleVo.cat_id and type(roleVo.cat_id) == "number" and roleVo.cat_id > 0 then
        local pkey = roleVo.pkey or roleVo.mkey
        local modelVo = {key = pkey, x = roleVo.x, y = roleVo.y, cat_id = roleVo.cat_id, hideType = hideType or 0}
        self:createCatHandler(modelVo, "add")
    end
end

function Scene:deleteFollowObj(roleVo)
    local pkey = roleVo.pkey or roleVo.mkey
    local petVoList = {[1] = {pkey = pkey}}
    self:createPetHandler(petVoList, "delete")

    local escortVo = {pkey = pkey}
    self:createEscortHandler(escortVo, "delete")

    local magicVo = {key = pkey}
    self:createMagicWeaponHandler(magicVo, "delete")

    local shenlingVo = {key = pkey}
    self:createShenlingHandler(shenlingVo, "delete")

    local catVo = {key = pkey}
    self:createCatHandler(catVo, "delete")
end


--[[
0怪物
1采集
2陷阱
4场景元素
5(不可配置，队友)
6不能点击可杀死
7臧宝图怪物
9魔军入侵采集物
11万兽猎场采集
12神谕恩泽宝箱采集
13战场采集
14世界boss采集
16消消乐采集物
17消消乐怪物
26帮派晚宴采集
27帮派晚宴装饰物
28王城守卫
]]
function Scene:createMonsterHandler(vo)
    local _t, _vo

    if vo then
        _t = vo
    else
        if List.Empty(self.monsterList) then return end
        _t = List.PopFront(self.monsterList)
    end
    -- (x = 80,y = 56, hp = 54236428, kind = 35, shadow_key = 0 scene = 12010)
    _vo = _t[1]
    if SceneUtils.isInSMZC() then
        log("createMonsterHandler", _vo.mkey, _t[2])
    end
    if _t[2] == "add" then
        --     print("添加怪物：" .. _vo.kind)
        if self.monSpeedMap and self.monSpeedMap[_vo.mkey] then
            _vo.speed = self.monSpeedMap[_vo.mkey]
            self.monSpeedMap[_vo.mkey] = nil
        end
        if self.monsterMap[_vo.mkey] then
            --删除模型
            if self.monsterMap[_vo.mkey] == self.pickObj then
                self:stopPicking()
            end

            if self.monsterMap[_vo.mkey].isDead then
                self.monsterMap[_vo.mkey]:exitDead(true)
            end

            if self.monsterMap[_vo.mkey] then
                self.monsterMap[_vo.mkey]:delete()
                self.monsterMap[_vo.mkey] = nil
            end

            if self.selectMonsterKey == _vo.mkey then
                self.selectMonsterKey = nil
            end
        end
        self:onMonAdd(_vo)
        if self.removedMonList[_vo.mkey] or _vo.hp <= 0 then
            self.removedMonList[_vo.mkey] = nil
            return
        end
        --采集物类型
        if GatherCorrectType[_vo.kind] or _vo.kind == 1 or _vo.kind == 40 or _vo.kind == 57 or _vo.kind == 62 or
            _vo.kind == 63 or _vo.kind == 65 or _vo.kind == 67 or _vo.kind == 68 then
            if _vo.kind == 63 or _vo.kind == 65 then --天命战场需要变更采集时间
                local TMtime = _vo.collecttime
                if SociatyController:getInstance() and SociatyController:getInstance().model.TMZC_Box_Info then
                    for tmI,tmV in pairs(SociatyController:getInstance().model.TMZC_Box_Info) do
                        if _vo.mkey == tmV.mkey then
                            TMtime = _vo.collecttime
                            break
                        end
                    end
                end
                _vo.collecttime = TMtime
            end
            if not self.monsterMap[_vo.mkey] then
                local _gather = Gather.new(_vo)
                self.monsterMap[_vo.mkey] = _gather
            end
            --公会晚宴接近采集物时刷出敬酒和摇色子
            if _vo.kind == 26 and _vo.guildkey == RoleController:getInstance().model.mainRoleVo.guildkey then
                SociatyController:getInstance():fire(SociatyEventType.SHOW_PARTY_BUTTON, true)
            end

            --婚礼晚宴接近采集物时刷出宴会信息
            if _vo.kind == 47 then
                MarryController:getInstance():showUtageInfo(true, _vo.party_key)
            end

            self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
        elseif _vo.kind == 32 then
            --buff不可攻不可选
            if not self.monsterMap[_vo.mkey] then
                local buffer = Monster.new(_vo, ObjPickType.Buffer)
                buffer.pickType = ObjPickType.Buffer
                self.monsterMap[_vo.mkey] = buffer

            end
            self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
        elseif _vo.kind == 2 or _vo.kind == 3 or _vo.kind == 4 then
            if not self.monsterMap[_vo.mkey] then
                local _special = Special.new(_vo)
                if SceneUtils.isCanHideMonster(self:getSceneID(), _vo) then
                    _special:setVisible(not self.isHideMonster)
                end
                self.monsterMap[_vo.mkey] = _special
            end
            self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
            --不可攻击的怪物（队友或者特殊宠物）
        elseif _vo.kind == 5 or _vo.kind == 28 then
            --镜像玩家
            if _vo.shadow_key ~= 0 then
                _vo = SceneUtils.getShadowVo(_vo)
                self.roleNum = self.roleNum + 1

                local _hideType = 0
                if not SceneUtils.hideFilter(_vo) then
                    --未超出同屏人数计数
                    local isOverFilter = false
                    local filterSysNum = SceneUtils.getOverFilterNum(self.sceneId, self.cfg)
                    if self.filterRoleNum <= filterSysNum and filterSysNum > 0 then
                        self.filterRoleNum = self.filterRoleNum + 1
                        self.filterRoleKey[_vo.mkey] = true
                        isOverFilter = true
                    end
                    if (Scene.FAST_MODE or not isOverFilter and self.roleNum > filterSysNum) then
                        _hideType = 1
                    end
                end

                if not self.monsterMap[_vo.mkey] then
                    local _role = Role.new(_vo, false, _hideType)
                    _role:setDir(_vo.dir)
                    _role.pickType = ObjPickType.Armyer
                    _role:registerPickInfo()
                    self.monsterMap[_vo.mkey] = _role
                    --创建跟随物、主城雕像不创建跟随物
                    if not SceneUtils.mainSceneModel[_vo.mid] then
                        self:createFollowObj(_vo)
                        if SceneUtils.isCanHideMonster(self.sceneId, _vo) then
                            self:fliterRoleHide(_role)
                            self:partRoleHide(_role)
                        end
                    end
                else
                    self.monsterMap[_vo.mkey]:initWithVo(_vo)
                end
                self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
                --主城模型偏移
                if SceneUtils.mainSceneModel[_vo.mid] then
                    self.monsterMap[_vo.mkey]:setPixelPos(SceneUtils.getMainSceneModelPos(cc.p(_vo.x, _vo.y), _vo.mid))
                end
            else
                if not self.monsterMap[_vo.mkey] then
                    local _mon = Monster.new(_vo)
                    if SceneUtils.isCanHideMonster(self.sceneId, _vo) then
                        _mon:setVisible(not self.isHideMonster)
                    end
                    _mon.pickType = ObjPickType.Armyer
                    self.monsterMap[_vo.mkey] = _mon
                else
                    self.monsterMap[_vo.mkey]:initWithVo(_vo)
                end
				self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
            end
        elseif _vo.kind == 6 then
            if not self.monsterMap[_vo.mkey] then
                local _mon = SpecialMonster.new(_vo)
                if SceneUtils.isCanHideMonster(self.sceneId, _vo) then
                    _mon:setVisible(not self.isHideMonster)
                end
                self.monsterMap[_vo.mkey] = _mon
            else
                self.monsterMap[_vo.mkey]:initWithVo(_vo)
            end

            self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
        elseif _vo.kind == 7 then --藏宝图
            _vo = SceneUtils.getShadowVo(_vo)

            if not self.monsterMap[_vo.mkey] then
                local _mon = Role.new(_vo)
                _mon:setDir(_vo.dir)
                _mon.pickType = ObjPickType.MapMonster
                _mon:registerPickInfo()
                self.monsterMap[_vo.mkey] = _mon
                --创建跟随物
                self:createFollowObj(_vo)
                self:fliterRoleHide(_mon)
                self:partRoleHide(_mon)
            else
                self.monsterMap[_vo.mkey]:initWithVo(_vo)
            end

            self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
        elseif _vo.kind == 24 then --领地战旗帜和采集物
            if not self.monsterMap[_vo.mkey] then
                local _mon = Monster.new(_vo)
                self.monsterMap[_vo.mkey] = _mon
            else
                self.monsterMap[_vo.mkey]:initWithVo(_vo)
            end
            self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
        elseif _vo.kind == 50 then --婚车
            if not self.monsterMap[_vo.mkey] then
                local _mon = Monster.new(_vo)
                _mon.pickType = ObjPickType.MarryBike
                self.monsterMap[_vo.mkey] = _mon
            else
                self.monsterMap[_vo.mkey]:initWithVo(_vo)
            end

            --长安城需要特殊处理，看到旗子时忽略安全区
            MarryController:getInstance():showParadeOperate(true)
            self.isMarryParade = true
            self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
        else
            --可攻击的普通怪 or 镜像玩家 --Guukona
            if _vo.shadow_key ~= 0 then --  镜像玩家 
                _vo = SceneUtils.getShadowVo(_vo)
                local existVo = self.roleShadowNameMap[_vo.name]
                if existVo then
                    local existObj = self.monsterMap[existVo.mkey]
                    if existObj then
                        local removeObj = self.removedMonList[existObj.vo.mkey]
                        if removeObj then
                            self:createMonsterHandler({{mkey = existObj.vo.mkey}, "remove"})
                        end
                    end
                end
                self.roleShadowNameMap[_vo.name] = _vo

                self.roleNum = self.roleNum + 1
                local _hideType = 0
                if not SceneUtils.hideFilter(_vo) then
                    --未超出同屏人数计数
                    local isOverFilter = false
                    local filterSysNum = SceneUtils.getOverFilterNum(self.sceneId, self.cfg)
                    if self.filterRoleNum <= filterSysNum and filterSysNum > 0 then
                        self.filterRoleNum = self.filterRoleNum + 1
                        self.filterRoleKey[_vo.mkey] = true
                        isOverFilter = true
                    end
                    if (Scene.FAST_MODE or not isOverFilter and self.roleNum > filterSysNum) then
                        _hideType = 1
                    end
                end

                if not self.monsterMap[_vo.mkey] then
                    local _role = Role.new(_vo, false, _hideType)
                    --竞技场对手面向处理
                    if self.sceneId and Config.BaseScene[self.sceneId] then 
                        local subtype = Config.getBaseScene(self.sceneId).subtype
                        if subtype == DungeonType.Arena or subtype == DungeonType.CrossMatch then
                            _role:setDir(1)
                        end    
                    else    
                        _role:setDir(_vo.dir)
                    end  
                    _role.pickType = ObjPickType.RoleShadow
                    _role:registerPickInfo()
                    self.monsterMap[_vo.mkey] = _role
                    --创建跟随物
                    self:createFollowObj(_vo)
                    if SceneUtils.isCanHideMonster(self.sceneId, _vo) then
                        self:fliterRoleHide(_role)
                        self:partRoleHide(_role)
                    end
                else
                    self.monsterMap[_vo.mkey]:initWithVo(_vo)
                end
            else
                if not self.monsterMap[_vo.mkey] then
                    local _mon = Monster.new(_vo)
                    if SceneUtils.isCanHideMonster(self.sceneId, _vo) then
                        _mon:setVisible(not self.isHideMonster)
                    end
                    self.monsterMap[_vo.mkey] = _mon

                    --王国守卫特殊处理，准备状态 
                    --注释by kell
                else
                    self.monsterMap[_vo.mkey]:initWithVo(_vo)
                end
            end
            if self.monsterMap[_vo.mkey] then
                self.monsterMap[_vo.mkey]:setLogicPos(cc.p(_vo.x, _vo.y))
            end
        end
        if self.monsterMap[_vo.mkey] then
            if self.isHideMonster then 
                self.monsterMap[_vo.mkey]:setVisible(not self.isHideMonster)
            else 
                self.monsterMap[_vo.mkey]:setVisible(self.objsVisibleList.mon)
            end
            if SceneUtils.monsterFixedDir[_vo.mid] then  --是否设置固定初始方向
                self.monsterMap[_vo.mkey]:setDir(SceneUtils.monsterFixedDir[_vo.mid])
            end
        end
        --消消乐怪物连消重合
        if ClearFunUtilFun.isInClearFun() then
            local posIndex = _vo.x*100+_vo.y
            local lastKey = self.clearMonList[posIndex]
            if lastKey ~= _vo.mkey and self.monsterMap[lastKey] then
                self.monsterMap[lastKey]:delete()
                self.monsterMap[lastKey] = nil
            end
            self.clearMonList[posIndex] = _vo.mkey
        end
        self:playBirthEffect(self.monsterMap[_vo.mkey])
        if self.isBossCopyScene then
            if _vo.boss > 0 then
                GlobalEventSystem:fire(GlobalEventType.ON_BOSS_ENTER, _vo.mkey)
            end
            if _vo.kind == 41 then  --帮派争霸
                GlobalEventSystem:fire(GlobalEventType.QIZHI_ENTER_SCENE, _vo.mkey)
            end
        end
    else
        local _mon = self.monsterMap[_vo.mkey]
        if self.isBossCopyScene then
            GlobalEventSystem:fire(GlobalEventType.ON_BOSS_LEAVE, _vo.mkey)
            if _vo.kind == 41 then  --帮派争霸
                GlobalEventSystem:fire(GlobalEventType.QIZHI_LEAVE_SCENE, _vo.mkey)
            end
        end
        --print("移除怪物", (not _mon and ("找不到怪物".._vo.mkey) or ("key:".._vo.mkey)))
        if _mon then
            local monVo = _mon.vo
            if monVo and monVo.shadow_key and monVo.shadow_key ~= 0 then
                self.roleNum = self.roleNum - 1
                self.roleNum = self.roleNum > 0 and self.roleNum or 0
            end

            if _mon == self.pickObj then
                self:stopPicking()
            end
            if _mon.vo.pickType == ObjPickType.RoleShadow then
                local shadowVo = self.roleShadowNameMap[_mon.vo.name]
                if shadowVo and shadowVo.mkey == _mon.vo.mkey then
                    self.roleShadowNameMap[_mon.vo.name] = nil
                end
            end

            --公会晚宴离开采集物时不显示敬酒和摇色子
            if _mon.vo.kind == 26 then
                SociatyController:getInstance():fire(SociatyEventType.SHOW_PARTY_BUTTON, false)
            elseif _mon.vo.kind == 50 then --离开婚车不显示操作界面
                MarryController:getInstance():showParadeOperate(false)
                self.isMarryParade = false
            end

            self:deleteFollowObj(_vo)
            
            if self.monsterMap[_vo.mkey] then
                self.monsterMap[_vo.mkey]:delete()
                self.monsterMap[_vo.mkey] = nil

                if self.selectMonsterKey == _vo.mkey then
                    self.selectMonsterKey = nil
                end
            end
        end
        self.removedMonList[_vo.mkey] = nil
        self:checkDeadMonsterInList(_vo.mkey)
    end
end

--播放死亡特效
function Scene:playDeadEffect(obj, callBack)
    if not obj then
        if callBack then
            callBack()
        end
        return
    end
    local _m_cfg = Config.Mon[obj.vo.mid]
    if _m_cfg and type(_m_cfg.deatheff) == "table" then
        local effectID = _m_cfg.deatheff[1]
        local scale = _m_cfg.deatheff[2]
        obj:showDeadEffect(effectID, scale, callBack)
    end
end

--播放出生特效
function Scene:playBirthEffect(obj)
    if not obj then return end
    local callBack = function( ... )
        if obj and obj.model then 
           obj.isProtect = false
           obj:setVisible(true)
           self:playBirthAction(obj)
        end
    end
    local _m_cfg = Config.Mon[obj.vo.mid]
    if _m_cfg and type(_m_cfg.birtheff) == "table" then
        local effectID = _m_cfg.birtheff[1]
        local scale = _m_cfg.birtheff[2]
        local flip = _m_cfg.birtheff[3]
        obj:setVisible(false)
        obj.isProtect = true
        obj:showBirthEffect(effectID, scale, flip, callBack)
    else 
        self:playBirthAction(obj)
    end
end

function Scene:playBirthAction(obj)
    if not obj then return end
    --检查战斗
    local function checkFight()
        if List.Empty(self.monsterList) then
            AutoFighting:getInstance():checkAttackNow()
        end
    end
    local _m_cfg = Config.Mon[obj.vo.mid]
    if _m_cfg and type(_m_cfg.birthAct) == "table" then
        obj.isProtect = true 
        local animate = _m_cfg.birthAct[1]
        local time = _m_cfg.birthAct[2]
        obj:playAnimate(animate)
        local function _delay()
            obj.isProtect = false 
            self.camera:setTarget(self.role)
            if obj and obj.model then 
               obj:playAnimate("stand3")
            end
            --检查战斗
            checkFight()
        end
        GlobalTimerQuest:AddDelayQuest(_delay, time)
    elseif _m_cfg and _m_cfg.birthAct == 1 then
        obj.isProtect = true 
        obj.model:fadeToWhiteByLayerID(InnerType.Cloth, 1)
        obj.model:setOpacity(1)
        obj.model:runAction(cc.FadeTo:create(1,255))
        local function _delay()
            if obj and obj.model then
                obj.model:setOpacity(255)
                obj.isProtect = false 
            end
            --检查战斗
            checkFight()
        end
        GlobalTimerQuest:AddDelayQuest(_delay, 1)
    else
        obj.isProtect = false 
        checkFight()
    end
end

function Scene:createNpcHandler()
    if List.Empty(self.npcList) then return end

    local _vo = List.PopFront(self.npcList)

    if self.npcMap[_vo.mid] then
        --删除模型
        self.npcMap[_vo.mid]:delete()
        self.npcMap[_vo.mid] = nil
    end

    if not self.npcMap[_vo.mid] then
        local _npc = Npc.new(_vo, false)
        _npc:setVisible(self.objVisible)

        _npc:updateView(self.npcStatusList[_vo.mid])
        self.npcMap[_vo.mid] = _npc
    end

    self.npcMap[_vo.mid]:setLogicPos(cc.p(_vo.x, _vo.y))

    self.npcMap[_vo.mid]:setVisible(self.objsVisibleList.npc)
end

function Scene:createDoorHandler()
    if SceneUtils.isNoNeedDoor(self.sceneId) then
        return
    end
    
    if List.Empty(self.doorList) then return end

    local _vo = List.PopFront(self.doorList)
    if not self.doorMap[_vo.scene] then
        local _door = Door.new(_vo)
        _door:setVisible(self.objVisible)
        self.doorMap[_vo.scene] = _door
    end

    self.doorMap[_vo.scene]:setLogicPos(cc.p(_vo.x, _vo.y))
    self.doorMap[_vo.scene]:setVisible(self.objsVisibleList.door)
end

function Scene:createFlyHandler()
    if List.Empty(self.flyList) then return end

    local _vo = List.PopFront(self.flyList)
    if not self.flyMap[_vo.id] then
        local _fly = Fly.new(_vo)
        _fly:setVisible(self.objVisible)
        self.flyMap[_vo.id] = _fly
    end

    self.flyMap[_vo.id]:setLogicPos(cc.p(_vo.x, _vo.y))
    self.flyMap[_vo.id]:setVisible(self.objsVisibleList.fly)
end

function Scene:createZbHandler()
    if List.Empty(self.zbList) then return end
    local _t = List.PopFront(self.zbList)
    if _t[2] == "add" then
        local _vo = _t[1]
        if not self.zbMap[_vo.key] then
            local _zb = ZhenBao.new(_vo)
            self.zbMap[_vo.key] = _zb
        end
        local logicPos = cc.p(_vo.x, _vo.y + 5)
        self.zbMap[_vo.key]:setLogicPos(logicPos)
    elseif _t[2] == "remove" then
        local key = _t[1]
        local _zb = self.zbMap[key]
        if _zb then
            _zb:delete()
            self.zbMap[key] = nil
        end
    end
end

function Scene:createDropHandler()
    if List.Empty(self.dropList) then return end

    local _t = List.PopFront(self.dropList)
    local _vo = _t[1]

    if _t[2] == "add" then
        if not self.lastPickDroptime then
            self.lastPickDroptime = GlobalMsTime
        end
        if not self.dropMap[_vo.key] then
            local _drop = Drop.new(_vo)
            _drop:setVisible(self.objVisible)
            self.dropMap[_vo.key] = _drop
        end
        local logicPos = cc.p(_vo.x, _vo.y)
        self.dropMap[_vo.key]:setLogicPos(logicPos)
        self.dropMap[_vo.key]:setVisible(self.objsVisibleList.drop)
    else
        local _drop = self.dropMap[_vo.key]
        if _drop then
            if _t[3] then --采集飞入身上特效
                self:dropFlyEff(_drop)
            end
            _drop:delete()
            self.dropMap[_vo.key] = nil
        end
    end
end


function Scene:dropFlyEff(drop)
    local node = drop:getDropSp()
    local startPos = SceneUtils.logicToPixel(cc.p(drop.vo.x, drop.vo.y))
    node:setPosition(startPos.x, Scene.SCENE_HEIGHT - startPos.y)
    HandleRenderUnit:getCoreScene():addToRenderGroup(node, cc.RenderQueue.GRQ_AIR)
    local endPos = self.role:getPixelPos()
    local a = cc.MoveTo:create(0.3, cc.p(endPos.x, Scene.SCENE_HEIGHT - endPos.y + 100))
    local a1 = cc.ScaleTo:create(0.3, 0.2, 0.2)
    local b = cc.CallFunc:create(function()
        if node then
            node:removeFromParent(true)
            node = nil
        end
     end)
    node:runAction(cc.Sequence:create(cc.Spawn:create(a,a1),b))
end

function Scene:isObjRetain(obj)
    if not obj then return false end

    if obj.pickType == ObjPickType.MainRole then
        if self.role then
            return true
        end
    end

    if not obj.vo then return false end

    if obj.pickType == ObjPickType.Monster or obj.pickType == ObjPickType.Armyer 
        or obj.pickType == ObjPickType.Gather or obj.pickType == ObjPickType.RoleShadow then
        if self.monsterMap[obj.vo.mkey] then
            return true
        end
    elseif obj.pickType == ObjPickType.Pet then
        if self.petMap[obj.vo.pkey] then
            return true
        end
    elseif obj.pickType == ObjPickType.Cat then
        if self.catMap[obj.vo.pkey] then
            return true
        end
    elseif obj.pickType == ObjPickType.MagicWeapon then
        if self.magicWeaponMap[obj.vo.key] then
            return true
        end
    elseif obj.pickType == ObjPickType.Shenling then
        if self.shenlingMap[obj.vo.key] then
            return true
        end
    elseif obj.pickType == ObjPickType.Role then
        if self.roleMap[obj.vo.pkey] then
            return true
        end
    elseif obj.pickType == ObjPickType.ClientMonster then
        if self.clientMonsterMap[obj.vo.mkey] then
            return true
        end
    elseif obj.pickType == ObjPickType.ClientRole then
        if self.clientRoleMap[obj.vo.pkey] then
            return true
        end
    elseif obj.pickType == ObjPickType.ClientGather then
        if self.clientMonsterMap[obj.vo.pkey] then
            return true
        end
    end

    return false
end

function Scene:createSkillEffectHandler(nowTime, elapseTime)
    for key, _skill in pairs(self.skillMap) do
        if GlobalMsTime - _skill.start > _skill.duration then
            if _skill.isStory or Scene.SHOW_FIHGT_INFO then
                    self:addSkillEffect(_skill.p1, _skill.p2, _skill.sid, _skill.isCombine, _skill.scale, _skill.isStory, _skill.attacker, _skill.defenser, _skill.zorder)
            end
            self.skillMap[key] = nil
            return
        end
    end
end

function Scene:addSkillEffect(p1, p2, skillID, isCombine, scale, isStory, attacker, defenser, zorder)
    --为什么要屏蔽怪物特效? by kell
    if attacker and (( attacker.pickType == ObjPickType.Pet)) or skillID == SkillController:getInstance().model.vip_skillid then
    else
        SkillDisplay.skillAnalysis(p1, p2, skillID, isCombine, scale, isStory, attacker, defenser, zorder, self)
    end
end

function Scene:playTimeLineEffect(config)
    if config.res == "" then return end
    local _effect = ActionTimeLineUtils.getSkillAnimate(config.res, config.animate, config.callback, config.isloop, config.style)
    if Scene.EFFECT_TEST then
	    _effect:setEffect(Scene.EFFECT_TEST)
    end
    _effect:setPosition(config.position.x, Scene.SCENE_HEIGHT - config.position.y)
    _effect:setRotation(config.rotation or 0)
    if config.scale then
        _effect:setScale(config.scale[1]*SceneUtils.skillScale, config.scale[2]*SceneUtils.skillScale)
    else
    end
    config.zorder = (config.zorder < cc.RenderQueue.GRQ_DOWN_EFFECT) and cc.RenderQueue.GRQ_DOWN_EFFECT or config.zorder
    HandleRenderUnit:getCoreScene():addToRenderGroup(_effect, config.zorder or cc.RenderQueue.GRQ_DOWN_EFFECT, 20)

    return _effect
end

function Scene:playParticalEffect(config)
    if config.res == "" then return end
    local eft = cc.MyParticleSystem:Create(config.res)
    if Scene.EFFECT_TEST then
	    eft:setEffect(Scene.EFFECT_TEST)
    end
    eft:setPosition(config.position.x, Scene.SCENE_HEIGHT - config.position.y)
    local r = (config.rotation or 0)

    eft:SetZRotation(r * math.pi / 180)
    if config.scale then
        eft:setScale(config.scale[1]*SceneUtils.skillScale, config.scale[2]*SceneUtils.skillScale)
    end
    config.zorder = (config.zorder < cc.RenderQueue.GRQ_DOWN_EFFECT) and cc.RenderQueue.GRQ_DOWN_EFFECT or config.zorder
    HandleRenderUnit:getCoreScene():addToRenderGroup(eft, config.zorder or cc.RenderQueue.GRQ_DOWN_EFFECT, 20)
    
    return eft
end

function Scene:playMatrixEffect(p1, p2, res, animate, scale, callback, isloop, zorder)
    if res == "" then return false end
    local _effect = ActionTimeLineUtils.getSkillAnimate(res, animate, callback, isloop)
    _effect:setPosition(p2.x, Scene.SCENE_HEIGHT - p2.y)

    local _tp = cc.pSub(p1, p2)
    local _rotation = cc.pToAngleSelf(_tp)
    if _effect then
        _effect:setRotation(_rotation*180/math.pi)
        local scaleX = math.sqrt(cc.pDistanceSQ(p1, p2)) / 450 * -1
        _effect:setScale(scaleX, 1.2)
        HandleRenderUnit:getCoreScene():addToRenderGroup(_effect, zorder or cc.RenderQueue.GRQ_AIR, 20)
    end
end

function Scene:playPohunEffect(p1, p2, res, animate, scale, callback, isloop, zorder)
    if res == "" then return false end
    local _effect = ActionTimeLineUtils.getSkillAnimate(res, animate, callback, isloop)
    _effect:setPosition(p1.x, Scene.SCENE_HEIGHT - p1.y)

    local _tp = cc.pSub(p1, p2)
    local _rotation = cc.pToAngleSelf(_tp)
    if _effect then
        _effect:setRotation(_rotation*180/math.pi)
        local scaleX = math.sqrt(cc.pDistanceSQ(p1, p2)) / 450
        _effect:setScale(scaleX, 1.2)
        HandleRenderUnit:getCoreScene():addToRenderGroup(_effect, zorder or cc.RenderQueue.GRQ_AIR, 20)
    end
end

function Scene:playEffect(position, source, resname, began, ended, scale, delaytime, isloop, callback)
    local _effect
    callback = callback or function()
        _effect:removeFromParent(true)
        _effect = nil
    end
    _effect = UITools.createAnimate(source, resname, began, ended, callback, delaytime)
    _effect:setPosition(position.x, Scene.SCENE_HEIGHT - position.y)
    _effect:setCameraMask(cc.CameraFlag.USER1)
    if scale then
        _effect:setScale(scale)
    end

    HandleRenderUnit:getCoreScene():addToRenderGroup(_effect, cc.RenderQueue.GRQ_AIR, 20)

    return _effect
end

function Scene:playTimeLine()

end

function Scene:deadClean(ctype, key, isClient)
    if ctype == ObjPickType.MainRole then
        --停止采集
        self:stopPicking()
        self:deleteFollowObj({mkey=key})
    end

    AutoFighting:getInstance():sceneObjDead(self.monsterMap[key])
    if ctype == ObjPickType.Role then
        local obj = self.roleMap[key]
        if obj then
            local function callback()
                --是否显示尸体
                if SceneUtils.isShowDeadBody(self.sceneId) then
                    local deadNode = obj:getDeadSprite()
                    self:deleteFollowObj({mkey=key})
                    self.deadMap[key] = deadNode
                end
                --删除模型
                if self.roleMap[key] then
                    self.roleMap[key]:delete()
                    self:updateMonsterKeepMap(key, self.roleMap[key])
                    self.roleNum = math.max(0, self.roleNum - 1)
                end
                self.roleMap[key] = nil
            end
            obj:deadEffect(callback)
        end
   elseif ctype == ObjPickType.Armyer then
        self:deleteFollowObj({mkey=key})
        self.monsterMap[key]:delete()
        self:updateMonsterKeepMap(key, self.monsterMap[key])
        self.monsterMap[key] = nil
        self.removedMonList[key] = nil
    elseif ObjPickTypeMonster[ctype] then
        local obj = self.monsterMap[key]
        self.removedMonList[key] = nil
        if SceneUtils.isInSMZC() then
            log("deadclean", key, obj)
        end
        if obj then
            local _m_cfg = Config.Mon[obj.vo.mid]
            if _m_cfg and type(_m_cfg.deatheff) == "table" then 
                local function callBack()
                    if self.monsterMap[key] then
                        self:updateMonsterKeepMap(key, obj)
                        self.monsterMap[key]:delete()
                        self.monsterMap[key] = nil
                    end
                end
                self:playDeadEffect(obj, callBack)
            else 
                if Scene.SHOW_FIHGT_INFO then
                    local node = obj:getGhostNode()
                    local deadNode = obj:getDeadSprite()
                    deadNode:setVisible(false)

                    local pos = obj:getPixelPos()
                    local height = obj:getBoundingBoxHeight()
                    self:deleteFollowObj({mkey=key})

                    if self.selectMonsterKey == key then
                        self.selectMonsterKey = nil
                    end
                    self:doDeadWithAnimate({duration = 0, pos = pos, node = node, attacker = obj.attacker, deadNode = deadNode,
                        height = height/2, dir = obj.dir
                        })
                end
                --删除模型
                self.monsterMap[key]:delete()
                self.monsterMap[key] = nil
                self:updateMonsterKeepMap(key, obj)
            end
            self:checkDeadMonsterInList(key)
        end
    elseif ctype == ObjPickType.ClientMonster then
        local obj = self.clientMonsterMap[key]
        if obj then
            local function callback()
                if Scene.SHOW_FIHGT_INFO then
                    local _node = obj:getGhostNode()
                    local pos = obj:getPixelPos()
                    local height = obj:getBoundingBoxHeight()
                    self:doDeadWithAnimate({duration = 0.4, pos = pos, node = _node, attacker = obj.attacker,
                        height = height/2, dir = obj.dir
                        })
                end
                obj:delete()
            end
            obj:deadEffect(callback)
            self.clientMonsterMap[key] = nil

            GlobalEventSystem:fire(GlobalEventType.CLEAN_CLIENT_MONSTER, key)
        end
    end
end

--死亡效果：1-击退，2-击飞，3-原地死亡(策划暂时不需要)
function Scene:doDeadWithAnimate(dict)
    if not self.sceneId then return end
    self.deadList[dict] = true

    local pos1 = dict.pos
    local pos2 = cc.pAdd(pos1, cc.p(dict.dir/3 == 0 and 1 or -1, dict.dir < 4 and 1 or -1))
    if dict.attacker then
        pos2 = dict.attacker:getPixelPos()
    end
    local _vec = cc.pSub(pos1, pos2)
    local dir = SceneUtils.getDir(_vec)
    local dx, dy = 0.857, 0.5
    if dict.dir == 3 or dict.dir == 9 then
        dx = -dx
    end
    if dict.dir == 1 or dict.dir == 3 then
        dy = -dy
    end

    --死亡效果（飙血，水花）
    local function playEff(nodePosX, nodePosY)
        local eff = nil
        local pos = cc.p(nodePosX, Scene.SCENE_HEIGHT - nodePosY)
        pos = cc.p(pos.x + dx*dict.height, pos.y + dy*dict.height)
        --水花

        if HandleTerrainHandler:isWaterArea(SceneUtils.pixelTologic(pos)) then
            eff = self:playTimeLineEffect({
                position = pos,
                res = ActionTimeLineUtils.getGethitEffectResource(10001),
                animate = "action",
                zorder = cc.RenderQueue.GRQ_UP_EFFECT,
                noEffect = true
            })
            eff:setScale(dict.height/60)
        --概率飙血
        else
            local _ran = math.random()
            if _ran < 0.5 then
                eff = self:playTimeLineEffect({
                    position = pos, 
                    res = ActionTimeLineUtils.getGethitEffectResource(3),
                    animate = "action",
                    isloop = true,
                    zorder = cc.RenderQueue.GRQ_UP_EFFECT,
                    noEffect = true
                })
                eff:setScale(1.2 * dict.height/60)
                eff:runAction(cc.Sequence:create(cc.DelayTime:create(0.8), cc.CallFunc:create(function ()
                    eff:removeFromParent()
                end)))
            end
        end
    end
    --击退
    local function back() 
        local p0 = {x = pos1.x, y = Scene.SCENE_HEIGHT - pos1.y}
        local _idVec = cc.pNormalize(_vec)

        local _tx = _idVec.x >= 0 and 1 or -1
        local _dis = math.random(150, 350)

        local function _cb()
            if not self.deadList[dict] then
                return
            end
            if dict.deadNode then
                dict.deadNode:setVisible(true)
                playEff(dict.node:getPositionX(), dict.node:getPositionY())
                dict.deadNode:setPosition(dict.node:getPosition())
                dict.deadNode:runAction(cc.Sequence:create(cc.DelayTime:create(0.5), cc.FadeTo:create(0.5, 0), cc.CallFunc:create(function ()
                    if dict.deadNode then
                        dict.deadNode:removeFromParent(true)
                    end
                    dict.deadNode = nil
                    self.deadList[dict] = nil
                    dict = nil
                end)))
            end
            dict.node:removeFromParent(true)
            dict.node = nil

            if not dict.deadNode then
                self.deadList[dict] = nil
                dict = nil
            end
        end

        local flyPos = {x = pos1.x + _dis * _idVec.x / cc.pGetLength(_idVec), y = Scene.SCENE_HEIGHT - pos1.y - _dis * _idVec.y / cc.pGetLength(_idVec)}
        local p1 = cc.pAdd(p0, cc.pMul(cc.pSub(flyPos, p0), 0.15))
        local p2 = cc.pAdd(p0, cc.pMul(cc.pSub(flyPos, p0), 0.8))
        local p3 = cc.pAdd(p0, cc.pMul(cc.pSub(flyPos, p0), 1))
        --飞出
        local flyAction = cc.Sequence:create(
            cc.MoveTo:create(0.1, p1),
            cc.MoveTo:create(0.15, p2),
            cc.MoveTo:create(0.1, p3)
            )

        dict.node:runAction(cc.Sequence:create(flyAction, cc.CallFunc:create(function ()
            _cb()
        end)))
    end

    --击飞 1:小飞 2:高飞
    local function fly(typ)
        local _tp = cc.pSub(pos1, pos2)
        _tp = cc.pNormalize(_tp)
        local _tx = _tp.x >= 0 and 1 or -1

        pos1.x = pos1.x
        pos1.y = pos1.y

        local _height = 130 --弹起高度

        local _p1 = cc.pAdd(pos1, cc.p(_tp.x * (100 + _height / 2),  _tp.y * (140 - _height / 2)))
        if typ == 2 then
            _p1 = cc.pAdd(pos1, cc.p(_tp.x * (100 + _height / 2),  _tp.y * (270 - _height / 2)))   
        end
        local _dis = math.random(140, 200)
        if dict.isStory then 
            _dis = 300
        end
        local _p2 = cc.pAdd(pos1, cc.pMul(_tp, _dis))
        local _p3 = cc.pAdd(_p2, cc.p(_tp.x * (40 + _height / 4),  _tp.y * (60 - _height / 4)))
        local _p4 = cc.pAdd(_p2, cc.pMul(_tp, 120))

        pos1.y = Scene.SCENE_HEIGHT - pos1.y
        _p1.y = Scene.SCENE_HEIGHT - _p1.y + 100
        _p2.y = Scene.SCENE_HEIGHT - _p2.y
        _p3.y = Scene.SCENE_HEIGHT - _p3.y + 100
        _p4.y = Scene.SCENE_HEIGHT - _p4.y

        local bezier = cc.BezierTo:create(0.4, {pos1, _p1, _p2})
        local bezier1 = cc.BezierTo:create(0.3, {_p2, _p3, _p4})
        local time = GlobalMsTime
        local function _cb()
            if dict.deadNode then
                playEff(dict.node:getPositionX(), dict.node:getPositionY())
                dict.deadNode:setVisible(true)
                dict.deadNode:setPosition(dict.node:getPosition())
                dict.deadNode:runAction(cc.Sequence:create(cc.DelayTime:create(0.5), cc.FadeTo:create(0.5, 0), cc.CallFunc:create(function ()
                    if dict.deadNode then
                        dict.deadNode:removeFromParent(true)
                    end
                    dict.deadNode = nil
                    self.deadList[dict] = nil
                    dict = nil
                end)))
            end
            dict.node:removeFromParent(true)
            dict.node = nil

            if not dict.deadNode then
                self.deadList[dict] = nil
                dict = nil
            end
        end
        if dict.node then
            dict.node:stopAllActions()
            local ran = math.random(2)
            if ran > 2 then
                dict.node:runAction(cc.Sequence:create(bezier, bezier1, cc.CallFunc:create(_cb)))
            else
                dict.node:runAction(cc.Sequence:create(bezier, cc.CallFunc:create(_cb)))
            end
        end
    end

    if dict.isStory then 
        fly(2)
    elseif dict.attacker and dict.attacker.vo then
        local ran = math.ceil(math.random(3))
        if ran == 1 then
            fly()
        elseif ran == 2 then
            fly(2)
        else
            back()
        end
    else
        dict.node:removeFromParent(true)
        dict.node = nil
        self.deadList[dict] = nil
        dict = nil
    end
end

function Scene:isWaterArea()
    if not self.role then 
        return false 
    end 
    local pos = self.role:getPixelPos()
    return HandleTerrainHandler:isWaterArea(SceneUtils.pixelTologic(pos))
end

function Scene:cleanLastScene() 
    log("Scene:cleanLastScene()")
    AutoFighting:getInstance():stopAutoFight()

    if self.kunTimer then
        GlobalTimerQuest:CancelQuest(self.kunTimer)
        self.kunTimer = nil
    end

    if self.kunList then
        for k, node in pairs(self.kunList) do
            node:removeFromParent()
        end
    end
    self.kunList = {}

    if self.lastMainRole then
        self.lastMainRole:delete()
        self.lastMainRole = nil
    end

    self.roleNum = 0
    self.filterRoleNum = 0

    --多帧移除
    self:delayDelete()
    if self.miniMap then
        self.miniMap:removeFromParent()
        self.miniMap = nil
    end

    --清理客户端
    self:clearAllClientObj()
    self:cleanDeadBody()

    if not self.isStoryScene then 
        self.npcMap = {}
    end
    self.roleMap = {}
    self.petMap = {}
    self.catMap = {}
    self.monsterMap = {}
    self.doorMap = {}
    self.flyMap = {}
    self.dropMap = {}
    self.zbMap = {} -- 珍宝对象列表    
    self.skillMap = {}
    self.escortMap = {}
    self.magicWeaponMap = {}
    self.shenlingMap = {}
    self.followerMap = {}
    self.sceneEffectMap = {}
    self.sceneEffectDic = {}
    self.filterRoleKey = {}
    self.vipSkillMonMap = {} -- vip技能对象列表
    self.kunMap = {} -- 新手鲲对象

    self.roleList = List.New()    --玩家队列
    self.npcList = List.New()     --NPC队列
    self.monsterList = List.New() --怪物队列
    self.doorList = List.New()    --传送门队列
    self.flyList = List.New()     --跳跃点队列
    self.dropList = List.New()
    self.zbList = List.New() --珍宝队列
    self.vipSkillMonList = List.New() -- vip技能队列

    self.moveList = List.New()

    self.removedMonList = {}--已移除怪物列表

    self.monSpeedMap = {}

    self.pickObj = nil
    self.selectMonsterKey = nil
    self.selectNpcKey = nil
end

--移除尸体
function Scene:cleanDeadBody()
    for var, v in pairs(self.deadMap) do
        v:removeFromParent(true)
        v = nil
    end
    self.deadMap = {}
end

function Scene:getMainRole()
    return self.role
end

function Scene:enterScene(sceneId, isReconnect)
    --切换场景中是否涉及副本类型
    self.isShowLoading = SceneUtils.isShowLoading(self.sceneId, sceneId)
    self.removedMonList = {}

    self.recvMonList = {}
    self.leaveMonList = {}
    self.addMonList = {}
    self.createMonList = {}
    self.deleteMonList = {}
    self.isReport = false

    --重连机制
    self.isReconnect = isReconnect
    if not isReconnect then
        --     print("记录上一个场景ID000",sceneId)
    else
        self.isShowLoading = false
    end

    --去掉loading图
    self.isShowLoading = false

    self.isGoldCopyScene = SceneUtils.isGoldCopy(sceneId) 
    self.isBossCopyScene = SceneUtils.isBossScene(sceneId) 
    self.isGhostBattleScene = SceneUtils.isInGhostBattle(sceneId) 
    --无缝切换剧情场景
    self.isStoryScene = (SceneUtils.isStoryScene(sceneId) or SceneUtils.isStoryScene(self.sceneId))

    --加载Loading界面
    self.lastSceneID = self.sceneId
    local delayTime = 0
    if not self.isStoryScene then 
        if self.isShowLoading and self.lastSceneID then
            delayTime = SceneUtils.isTown(sceneId) and 100 or 40
            DefaultLoadingView:getInstance(delayTime)
        else
            GlobalEventSystem:fire(GlobalEventType.SHOW_MAIN_LAYER, false)
        end
    end
    --清理寻路
    HandleOperateManager:clearSrcOperator(true)
    Runner:getInstance():removeRunObj(self) 

    showBuglyLuaLog(string.format("Enter scene by id %s!!!", sceneId or 0))
    collectgarbage("collect")

    local mapCfg = Config.getBaseScene(sceneId)
    if not mapCfg then
        print("记录上一个场景ID111",sceneId)
        return
    end

    local mapID = mapCfg.sid
    require("game.config.scene." .. mapID)
    self.cfg = Config.getScene(mapID)
    if not self.cfg then
        print("记录上一个场景ID222",mapID)
        return
    end

    --记录上一个场景ID
    self.sceneId = sceneId

    Scene.SCENE_WIDTH = self.cfg.width
    Scene.SCENE_HEIGHT = self.cfg.height

    Scene.WIDTH_MAP_NUM, Scene.HEIGHT_MAP_NUM = SceneUtils.getMaxTextureNum(Scene.SCENE_WIDTH, Scene.SCENE_HEIGHT)
    Scene.WIDTH_BLOCK_NUM, Scene.HEIGHT_BLOCK_NUM = SceneUtils.getMaxBlockNum(Scene.SCENE_WIDTH, Scene.SCENE_HEIGHT)

    self:removeAllZone()
    self:registerSceneZone()

    self:cleanLastScene()
    self:changeScene(self.cfg, 0)


    if self.sceneId ~= 10003 then 
        --长安城需要特殊处理,如果不是在主城，强制关闭巡游礼物界面
        MarryController:getInstance():showParadeOperate(false)
    end 
    
    if self.sceneId ~= self.lastSceneID then
        self:loadminiMap(mapID, function () end)
    end

    if Scene:getInstance().sceneId ~= 65033 then -- 灵矿掠夺特殊处理
        for key, var in pairs(self.cfg.doors or {}) do
            List.PushBack(self.doorList, var)
        end
    end

    if Scene:getInstance().sceneId == 10001 then -- 新手场景加一条鲲
        self:checkKunAnimate()
    end

    for key, var in pairs(self.cfg.flys or {}) do
        List.PushBack(self.flyList, var)
    end

    self:request12002()
    AudioManager:getInstance():playBackgroundMusic(mapCfg.soundID)
    if not self.isShowLoading then
        self:sceneAutoFight()
    end
    Runner:getInstance():addRunObj(self, 1)
    GlobalEventSystem:fire(GlobalEventType.ENTER_SCENE, self.sceneId)
    --检查是不是场景没有怪物
    GlobalTimerQuest:AddDelayQuest(function()
        SceneUtils.checkCopyMonster()
    end, 10)
end

function Scene:changeScene(sceneCfg, ctype)
    if self.isStoryScene and self.isNotFirstLoginScene then 
        GlobalEventSystem:fire(GlobalEventType.SCENE_LOADED, self.sceneId)
        log("GlobalEventType.SCENE_LOADED")
        return
    end 
    self.isNotFirstLoginScene = true

    self.sceneCfg = sceneCfg
    self.lastCameraPos = self.camera:getLastCameraPosition()
    self.isLoadingMap = true
    
    if self.endCallback then
        self.endCallback()
        self.endCallback = nil
    end
    
    local delayGap = 0
    self.changeSceneJumping = true
    local changeType = ctype or 2
    if not self.isShowLoading and not self.isReconnect then
        if self.isStoryScene then 
            delayGap = 0.15  
            self.endCallback = HandleTerrainHandler:vagueMap(changeType, 2.5, 2)
        else
            delayGap = 0.15  
            self.endCallback = HandleTerrainHandler:vagueMap(changeType, 2.5, 2)
        end
    end

    --场景加载
    local function TerrianLoadCallBack()
        self:terrainLoaded()

        self.isLoadingMap = false

        if (changeType ~= 0 or not self.role) or self.isShowLoading or self.isReconnect then
            self.changeSceneJumping = false
            self:createMainRole()
            GlobalEventSystem:fire(GlobalEventType.SHOW_MAIN_LAYER, true)
        else
            self.changeSceneJumping = true
            self:createMainRole(true)
        end

        local function delay()
            GlobalTimerQuest:CancelQuest(self.delayLoadParallaxTimer)
            self.loadingUtils:distoryScene()
            local cfg = SceneParallelsList[self.sceneId]
            if cfg then
                self.loadingUtils:loadScene(self.sceneId, cfg.width, cfg.height)
            end
        end
        self.delayLoadParallaxTimer = GlobalTimerQuest:AddDelayQuest(delay, self.isStoryScene and 0 or 0.2)

        if self.endCallback then
            self.endCallback()
            self.endCallback = nil
        end
    end

    local function terrianLoadProgressCallBack(curSize, maxSize, speed)
    end

    local function sceneObjectEnterAOI(objectID, objectType)
        self:SceneObjectEnterAOI(objectID, objectType)
    end

    local function sceneObjectLeaveAOI(objectID, objectType)
        self:sceneObjectLeaveAOI(objectID, objectType)
    end

    local function sceneEnterZone(objectID, objectType)
        self:sceneEnterZone(objectID, objectType)
    end

    local function sceneLeaveZone(objectID, objectType)
    end
    
    --延迟加载
    local function delayLoadNextScene()
        GlobalTimerQuest:CancelQuest(self.delayLoadNextScene)
        HandleRenderUnit:setWorldSize(cc.size(sceneCfg.width, sceneCfg.height))
        local sceneRes = SceneResPathTool.getSceneResPath(sceneCfg.id)
        if HandleTerrainHandler then
            HandleTerrainHandler:setConfigInfo(sceneCfg)
            HandleTerrainHandler:changeScene(sceneRes, TerrianLoadCallBack, TerrianLoadProgressCallBack)
            HandleTerrainHandler:setObjectAOICallback(SceneObjectEnterAOI, SceneObjectLeaveAOI, SceneEnterZone, SceneLeaveZone)
        end
    end

    --场景判断
    if self.lastSceneID == self.sceneId then
        TerrianLoadCallBack()
    else
        self.delayLoadNextScene = GlobalTimerQuest:AddDelayQuest(delayLoadNextScene, delayGap)
    end
end

--注册场景区域buff
function Scene:registerSceneZone()
    self.isExistSceneBuff = false
    for k,v in pairs(Config.SceneBuff) do
        if v.scene_id == self.sceneId then 
            self.isExistSceneBuff = true
            local zoneVo = { 
                mkey = v.buff_id > 100 and v.id or v.buff_id, 
                zoneType = 1,  
                sceneID = self.sceneId, 
                rect = cc.rect(v.point[1] - v.length/2, v.point[2] - v.width/2, v.length, v.width), 
            }
            self:registerZone(zoneVo)
        end
    end
end

--小图
function Scene:loadminiMap(sid, callback)
    local mapCfg = Config.getScene(sid)
    if mapCfg then
        self.miniMap = cc.SpriteUI:createWithResCSpriteLoader(string.format("assets/wmap/minimap/%s.csprite", sid), "default", callback) 
        HandleRenderUnit:getCoreScene():addToRenderGroup(self.miniMap, cc.RenderQueue.GRQ_TERRAIN_DOWN, -1) 
        self.miniMap:setScale(WorldMapConst.BG_SCALE)
        self.miniMap:setPosition(mapCfg.width / 2, mapCfg.height / 2)
    end
end

function Scene:terrainLoaded()
    --场景点击层
    if not self.touchLayer then
        self.touchLayer = cc.Layer:create()
        HandleRenderUnit:getCoreScene():addToRenderGroup(self.touchLayer, cc.RenderQueue.GRQ_BACKGROUD)

        local function onTouchBegan(touch, event)
            self.isLoopJump = nil

            if self.isRunningStory then
                return
            end

            if self.cancelMove ~= nil then
                self.cancelMove()
                return
            end

            if self:isCruise() then
                return
            end

            self.touchBeganPos = touch:getLocationInView()
            return true
        end
        local function onTouchMoved(touch, event)
            self.isLoopJump = nil

            if self.isRunningStory then
                return
            end

            if self.cancelMove ~= nil then
                self.cancelMove()
                return
            end
        end
        local function onTouchEnded(touch, event)
            if self.changeSceneJumping then return end
            local location = touch:getLocationInView()
            self.touchViewPos = location

            GlobalEventSystem:fire(GlobalEventType.SCENE_TOUCHLAYER)    
            
            HandleRenderUnit:getCoreScene():asyncIntersectQuery(location.x, location.y, self.pickMask)
        end

        local listener = cc.EventListenerTouchOneByOne:create()
        listener:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN)
        listener:registerScriptHandler(onTouchMoved, cc.Handler.EVENT_TOUCH_MOVED)
        listener:registerScriptHandler(onTouchEnded, cc.Handler.EVENT_TOUCH_ENDED)
        self.touchLayer:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener, self.touchLayer)

        local function pickFunc(pickType, pickInfo)
            self:pickHandle(pickType, pickInfo)
        end
        HandleRenderUnit:getCoreScene():setPickHandler(pickFunc)
    end

    self.is_loaded = true
end

function Scene:isCruise()
    local roleVo = RoleController:getInstance().model.mainRoleVo
    return roleVo and roleVo.cruise_state > 0
end

function Scene:pickHandle(pickType, sceneObjKey)
    --临时保护
    if self.role and self.role:isJumping() then
        return
    end

    local isPickHandled = false
    self.userPickID = sceneObjKey

    if RoleController:getInstance().model.mainRoleVo and RoleController:getInstance().model.mainRoleVo.attlist.hp <= 0 then
      --  GlobalEventSystem:fire(GlobalEventType.ROLE_REBIRHT, 0)
       -- self.controller:openCopyrebirthView({leave_time = 3},0)
       print("\n\n\n场景复活！！！！！！！！！！！！！！！！！、\n\n\n")
       GlobalEventSystem:fire(GlobalEventType.ROLE_DEAD, {leave_time = 3})
        return
    end
    -- self.minePick = self.minePick  
    -- if SceneUtils.isInMine() and SSDController:getInstance().model.mineClickType == MineClickType.toHandIn then
    --     Message:getInstance():showMessage("再次点击地面停止上交物资！") 
    --     if self.minePick and GlobalMsTime - self.minePick < 0.3 then
    --         SSDController:getInstance().model.mineClickType = MineClickType.Nothing
    --     end
    --     self.minePick = GlobalMsTime
    -- end

    local viewPoint = self.touchViewPos
    local touchWpos = HandleRenderUnit:viewToWorld(viewPoint)
    local endPos = HandleRenderUnit:worldToLogic(touchWpos)
    local distence = cc.pDistanceSQ(self.touchBeganPos, self.touchViewPos)
    
    local info = HandleTerrainHandler:getZoneInfo(endPos)
    if info == 0 and not sceneObjKey then
        self:showTouchNode(touchWpos)
        local function _delay()
            if self.touchNode then 
                self.touchNode:setVisible(false)
            end 
        end
        performWithDelay(self.delayNode, _delay, 0.5)

        return Message:getInstance():showMessage("障碍区域不可寻路")
    end

    if distence > 14400 then --位移
        if TaskController:getInstance():isEscort() then
            Message:getInstance():showMessage("护送状态下不可跳跃")
        elseif SceneUtils.isInGhostBattle(self.sceneId) then 
            Message:getInstance():showMessage("神魔战场存在强大引力不可跳跃")
        elseif SceneUtils.isInBATTLE(self.sceneId) then 
            Message:getInstance():showMessage("修罗战场存在强大引力不可跳跃")
        else 
            if self.role then
                if HandleTerrainHandler:isStraightLine(self.role:getLogicPos(), endPos)
                    and SceneUtils.isCanJump(self.sceneId) then
                    self:stopPicking()
                    self.role:doJump(nil, endPos, true, true)
                    AutoFighting:getInstance():stopAutoFight(0)
                end
            end
       end
    else
        local pickObj = nil
        if pickType then
            pickObj = self.getSceneObjMap[pickType] and self.getSceneObjMap[pickType](sceneObjKey) or nil
        end   
        if not pickObj and not self.forceRun and AutoFighting:getInstance():isAutoFight() then
            self.forceRun = GlobalMsTime
            self:showTouchNode(touchWpos)
            local function _delay()
                if self.touchNode then 
                    self.touchNode:setVisible(false)
                end 
            end

            performWithDelay(self.delayNode, _delay, 0.3)
            
            Message:getInstance():showMessage("再次点击地面停止寻路/挂机")
            return
        end
        if SceneUtils.isInMine() then
            SSDController:getInstance().model.nextSceneId = nil
        end
        self.forceRun = false

        if pickObj then
            self:runToPick(pickObj)
        else


           self:showTouchNode(touchWpos)

            self.lastPointClean = nil
            self:runToSceneObj(endPos, nil, nil, nil, true)  
        end
    end
end
function Scene:showTouchNode(touchWpos)
    if not  self.touchNode then 
        self.touchNode = ActionTimeLineUtils.getUIAnimate("assets/effect/uieffect/10028.csprite", "action", nil, true)--cc.Node:create()
        HandleRenderUnit:getCoreScene():addToRenderGroup(self.touchNode, cc.RenderQueue.GRQ_AIR)
        self.touchNode:setBlendFunc(gl.GL_DST_ALPHA,gl.ONE)
    end 
    self.touchNode:setVisible(true)
    self.touchNode:setPosition(touchWpos)
end
function Scene:FindMainRolePoint( targetpos )
    if not self.role then
        return false, targetpos 
    end
    local logix = self.role:getLogicPos()
    return true, HandleTerrainHandler:fixWalkPoint(logix, targetpos)
end

function Scene:drawLogicRect(start1, start2)
    if self.layerDraw then
        self.layerDraw:removeFromParent(true)
        self.layerDraw = nil
    end

    local logic_w, logic_h = HandleTerrainHandler:getLogicTileWidth(), HandleTerrainHandler:getLogicTileHeight()
    local scene_w, scene_h = HandleTerrainHandler:getSceneWidth(), HandleTerrainHandler:getSceneHeight()
    local mywidth, myheight = math.ceil(scene_w / logic_w), math.ceil(scene_h / logic_h)

    self.layerDraw = cc.Control:create()
    self.layerDraw:setAnchorPoint(cc.vec2(0, 0))
    self.layerDraw:setContentSize(cc.size(mywidth * 60, myheight * 30))
    HandleRenderUnit:getCoreScene():addToRenderGroup(self.layerDraw, cc.RenderQueue.GRQ_TERRAIN_UP)

    start1 = start1 or 1
    start2 = start2 or mywidth
    start2 = start2 > mywidth and mywidth or start2
    for i = start1, start2 do
        for j = 1, myheight do
            local info = HandleTerrainHandler:getZoneInfo(cc.vec2(i - 1, j - 1))
            local myColor = cc.c4b(255, 255, 255, 90)

            if info == 1 then
                myColor = cc.c4b(255, 0, 0, 90)
                local bgColor = cc.LayerColor:create(myColor)
                bgColor:setContentSize(cc.size(59, 29))
                bgColor:setPosition(HandleRenderUnit:flipWorldPosXY(60 * i - 60, 30 * j - 30))
                self.layerDraw:addChild(bgColor)
            end


        end
    end
end

function Scene:sceneObjectEnterAOI(objectID, objectType)
end

function Scene:sceneObjectLeaveAOI(objectID, objectType)
end

function Scene:sceneEnterZone(objectID, objectType)
end

--转换场景自动战斗
function Scene:sceneAutoFight()
    print("切换场景自动战斗----", self.sceneId)
    local isAutoFight, delayTime = SceneUtils.checkAutoFight(self.sceneId)
    if not isAutoFight then return end
    if self.cfg then
        local function _autoFight()
            if not AutoFighting:getInstance():isAutoFight() then 
                AutoFighting:getInstance():startAutoFight(nil, 1)
            end
        end
        GlobalTimerQuest:AddDelayQuest(_autoFight, delayTime)
    end
end

--转换场景特效
function Scene:formatSceneEffect(effects)
    self.sceneEffectDic = {}
    if effects then
        for key, var in pairs(effects) do
            self.sceneEffectDic[var.x] = self.sceneEffectDic[var.x] or {}
            self.sceneEffectDic[var.x][var.y] = var
        end
    end
end

function Scene:checkSceneNpcArea()
    if self.role then
        local _p1 = self.role:getLogicPos()
        for key, var in pairs(self.npcMap) do
            local _p2 = var:getLogicPos()
            if math.abs(_p1.x - _p2.x) > SceneUtils.npcAreaX or math.abs(_p1.y - _p2.y) > SceneUtils.npcAreaY then
                --超出指定范围移除npc
                if self.npcMap[key] then
                    self.npcMap[key]:setHideType(1)
                end
            else
                --指定范围内显示npc
                if self.npcMap[key] then
                    self.npcMap[key]:setHideType(0)
                end
            end
        end
    end
end

function Scene:showSceneName(sceneid)
    local name = cc.Sprite:create()
    name:setSpriteFrame(UITools.getSpriteFrameFromPlist(string.format("ui/mapSmall/res/word%s.png",sceneid),"ui/mapSmall/res/mapSmallPlist"))
    name:setPosition(cc.p(159,50))
    local sp = cc.Sprite:create()
    sp:setSpriteFrame(UITools.getSpriteFrameFromPlist("ui/mapSmall/res/BGSceneName.png","ui/mapSmall/res/mapSmallPlist"))
    sp:setOpacity(0)
    sp:setScale(0.2)
    sp:addChild(name)
    HandleRenderUnit:getCoreScene():addToRenderGroup(sp, cc.RenderQueue.GRQ_AIR_UP)
    sp:setPosition(cc.p(display.cx,display.cy-100))

    local function func()
        local a = cc.FadeTo:create(0.4,255)
        local a1 = cc.ScaleTo:create(0.4,1.3,1.3)
        local a2 = cc.ScaleTo:create(0.1,1,1)
        local a3 = cc.DelayTime:create(1.5)
        local a4 = cc.FadeTo:create(0.5,0)
        local b = cc.CallFunc:create(function() sp:removeFromParent(true) end)
        sp:runAction(cc.Sequence:create(cc.Spawn:create(a,a1),a2,a3,b))
    end
    performWithDelay(sp,func,SceneUtils.findWayDuration)
end

--检查是否卡死角
function Scene:checkRoleInCorner(delayTime)
    --5秒之后检查位置
    GlobalTimerQuest:AddDelayQuest(function()
        if self.role then
            log("check")
            local p = self.role:getLogicPos()
            log("HandleTerrainHandler:isBlock(p)", HandleTerrainHandler:isBlock(p))
            if HandleTerrainHandler:isBlock(p) then
                --直接返回到出生点
                local sid = self.sceneId
                if sid then
                    local sceneCfg = Config.getConfig("BaseScene", sid)
                    local role = self.role
                    if role then
                        GlobalTimerQuest:AddDelayQuest(function()
                            local x, y = sceneCfg.x, sceneCfg.y
                            role:setLogicPos(cc.p(x, y))
                            RoleController:getInstance().model.mainRoleVo.x = x
                            RoleController:getInstance().model.mainRoleVo.y = y
                            Scene.instance:fire(SceneEvent.REQUEST_12001, x, y, 5)
                        end, 1)
                    end
                end
                local roleVo = RoleController:getInstance().model.mainRoleVo
                local info = string.format("444role in block %s : (%s, %s), last : %s", tostring(sid), tostring(roleVo.x), tostring(roleVo.y), tostring(self.lastSceneID))
                local plats = {
                    [cc.PLATFORM_OS_ANDROID] = true,
                    [cc.PLATFORM_OS_IPHONE] = true,
                    [cc.PLATFORM_OS_IPAD] = true,
                }

                if plats[SystemInfo.platform] then 
                    --上报经验副本位置有误
                    if SceneUtils.isExpCopy(self.sceneId) then
                        -- buglyReportLuaException(info, debug.traceback())
                        --继续检查
                        self:checkRoleInCorner()
                    end
                else
                    log("陷入江局!!!", info)
                    log(debug.traceback())
                    if SceneUtils.isExpCopy(self.sceneId) then
                        --继续检查
                        self:checkRoleInCorner()
                    end
                end
            else
                if SceneUtils.isExpCopy(self.sceneId) then
                    --继续检查
                    self:checkRoleInCorner(10)
                end
            end
        end
    end, delayTime or 5)
end

function Scene:createMainRole(isJump)  
    if not self.isStoryScene then  
       self:deleteMainRole(isJump)
    end

    self:showBright()
    if self.brightIcon then
        self.brightIcon:setVisible(true)
    end

    if SceneUtils.isFightArena(self.sceneId) then --竞技场内不创建主角         
        local function _delay()
            self:deleteMainRole()
            GlobalEventSystem:fire(GlobalEventType.SCENE_LOADED, self.sceneId)
            log("GlobalEventType.SCENE_LOADED")
        end
        if self.lastMainRole then 
            self.lastMainRole:doFloating(_delay, false, 600)
        end 
        return 
    end
    
    local roleVo = RoleController:getInstance().model.mainRoleVo
    if not roleVo then
        return
    end
    local isNewRole = not self.role and true or false
    self.mainpKey = roleVo.pkey
    if self.isStoryScene then 
       self.role = self.role or Role.new(roleVo, true)
    else 
       self.role = Role.new(roleVo, true)
    end
    if self.isChangeSceneByFly then 
        local vaildPos = SceneUtils.getValidPos(cc.p(roleVo.x,roleVo.y))
        if vaildPos.x ~= -1 then 
            roleVo.x = vaildPos.x
            roleVo.y = vaildPos.y
        end
    end
    if self.deadMap[self.mainpKey] then
        self.deadMap[self.mainpKey]:removeFromParent(true)
        self.deadMap[self.mainpKey] = nil
    end
        self:refreshBackMan(roleVo) 
        self:updateMainRoleInfo(roleVo)
        self.role:registerPickInfo() 

    if not isJump then
        self.role.stateMechine:runStateById("stand")
        GlobalEventSystem:fire(GlobalEventType.SCENE_LOADED, self.sceneId)
        log("GlobalEventType.SCENE_LOADED1")
        if self.isChangeSceneByFly then
            self.isChangeSceneByFly = false
            GlobalEventSystem:fire(GlobalEventType.OVERFLY_END)
        end
        self:checkRoleInCorner()
    else
        if not self.isStoryScene then 
            self.role:setVisible(false)
            --旧角色相对旧相机偏移量
            local oldOffset = cc.pSub(self.lastCameraPos, self.lastMainRole:getPixelPos())
            --新角色相对新相机偏移量
            local newOffset = cc.pSub(self.camera:getLastCameraPosition(), self.role:getPixelPos())

            --旧主角新坐标（相对于新相机偏移计算）
            local tempPos = cc.pAdd(self.role:getPixelPos(), cc.pSub(newOffset, oldOffset))
            self.lastMainRole:setPixelPos(tempPos)
        end

        local function delayCallback()
            if self.lastMainRole then 
                self.lastMainRole:delete()
                self.lastMainRole = nil
            end 
            local function floatback()
                GlobalEventSystem:fire(GlobalEventType.SCENE_LOADED, self.sceneId)
                GlobalEventSystem:fire(GlobalEventType.OPEN_WORLD_BOSS_NEW, self.sceneId)
                log("GlobalEventType.SCENE_LOADED2")
                self:sceneAutoFight()
                self:checkRoleInCorner()
                if self.role then
                    self.role:updateModelPos()
                end
                local pox = self.role:getLogicPos()
                --切换场景后，上报坐标切换，防止切换过程中的移动，导致坐标位置对不上
                self:request12001(pox.x, pox.y, 6)
                self.roleFloating = false
            end
            print("=====showFloating======")
            self:showFloating(floatback)
        end

        if self.isStoryScene then 
            delayCallback()
        else 
            self.roleFloating = true
            self.lastMainRole:doFloating(delayCallback, false, 600)
        end
    end

    if not self.isStoryScene then 
        --竞技场玩家面向处理
        self:setBirthDir(self.role, self.role:getLogicPos().x)
        -- 主角进入场景的朝向
        local sceneInfo = Config.BaseScene[self.sceneId or 0 ]
        if self.sceneId and Config.BaseScene[self.sceneId] and sceneInfo.dir > 0 then
            self.role:setDir(sceneInfo.dir)
        end 
    end
end

--出生点玩家面向处理
function Scene:setBirthDir(role, logicPosX)
    if self.sceneId and Config.BaseScene[self.sceneId] then
        local subtype =  Config.getBaseScene(self.sceneId).subtype
        if subtype == DungeonType.Arena then 
            role:setDir(9)
        elseif subtype == DungeonType.CrossMatch then
            if logicPosX <= 14 then
                role:setDir(9)
            elseif logicPosX >= 22 then 
                role:setDir(1)
            end   
        else
            role:setDir(3)        
        end    
    end
end

function Scene:updateMainRoleInfo(roleVo)
    local p = cc.p(roleVo.x, roleVo.y)
    self.role:setLogicPos(p)
    
    --角色的高度
    self.camera:setTarget(self.role)
    self.camera:setPosition(self.role:getPixelPos())   
    self:createFollowObj(roleVo)    

    --宠物跟随
    self:following(self.role, cc.p(roleVo.x, roleVo.y))
    self.mapStopLoading = false
end

--更改角色及跟随物速度
function Scene:updateFollowersState(updateVo)
    --更新速度
    if updateVo.speed then
        --其他玩家
        local role = self.roleMap[updateVo.key]
        if role then
            role:setMoveSpeed(updateVo.speed)
        end

        --自己
        if not role and self.role and  updateVo.key == self.role.vo.pkey then
            self.role:setMoveSpeed(updateVo.speed)

            --全局广播
            local _vo = {}
            _vo.attlist = {}
            _vo.attlist.speed = updateVo.speed
            RoleController:getInstance():fire(RoleEvent.CHANGE_ROLE_INFO, _vo)
        end

        if self.petMap[updateVo.key] then
            self.petMap[updateVo.key].vo.speed = updateVo.speed
            self.petMap[updateVo.key]:setMoveSpeed(updateVo.speed)
        end
        if self.catMap[updateVo.key] then
            self.catMap[updateVo.key].vo.speed = updateVo.speed
            self.catMap[updateVo.key]:setMoveSpeed(updateVo.speed)
        end


        if self.escortMap[updateVo.key] then
            self.escortMap[updateVo.key].vo.speed = updateVo.speed
            self.escortMap[updateVo.key]:setMoveSpeed(updateVo.speed)
        end

        if self.magicWeaponMap[updateVo.key] then
            self.magicWeaponMap[updateVo.key].vo.speed = updateVo.speed
            self.magicWeaponMap[updateVo.key]:setMoveSpeed(updateVo.speed)
        end

        if self.shenlingMap[updateVo.key] then
            self.shenlingMap[updateVo.key].vo.speed = updateVo.speed
            self.shenlingMap[updateVo.key]:setMoveSpeed(updateVo.speed)
        end

        for _, follower in pairs(self.followerMap) do
            follower[updateVo.key].vo.speed = updateVo.speed
            follower:setMoveSpeed(updateVo.speed)
        end
    end
end

function Scene:deleteMainRole(isHold)
    if self.role then
        self:deleteFollowObj(RoleController:getInstance().model.mainRoleVo)

        if isHold then
            --保留旧的mainRole
            if self.lastMainRole then 
                self.lastMainRole:delete()
                self.lastMainRole = nil
            end 
            self.lastMainRole = self.role
            self.role = nil
        else
            self.role:delete()
            self.role = nil
        end
    end
end

function Scene:setCancelMove(cancelMove)
    self.cancelMove = cancelMove
end

function Scene:cleanEndPoint()
    if self.pointNode then
        self.lastPointClean = GlobalMsTime
    end


end

function Scene:runToSceneObj(pos, handler, circle, isAuto, isFind, isTask, isJoyStick, isPickFirst,isCruise)
    self.isPickFirst = isPickFirst
    if not self.role then
        return
    end

    if self.cancelMove ~= nil then
        self.cancelMove()
        return
    end
    --巡游状态下不能操作,除非自动同步
    if self:isCruise() and not isCruise then
        return
    end

    if not isAuto and AutoFighting:getInstance():isAutoFight() then
        AutoFighting:getInstance():stopAutoFight(2)
    end

    if not isFind then
        self.touchRun = GlobalMsTime
    else
        if self.role and self.role:isMoving() and self.touchRun then
            self.touchRun = false
            self:cleanEndPoint()
            Message:getInstance():showMessage("再次点击停止寻路")
            return
        end
    end

    self.findWayNode:stopAllActions()
    self:stopPicking()
    
    HandleOperateManager:clearSrcOperator()

    local roleState = self.role and self.role.stateMechine:getRunningState() or ""
    self.role.runToSceneObjHandler = nil
    if roleState == "attack" then
        self.role.runToSceneObjHandler = function()
            HandleOperateManager:startMoveAction(pos, handler, circle or 0, true, isTask, isJoyStick)
        end
    else
        HandleOperateManager:startMoveAction(pos, handler, circle or 0, true, isTask, isJoyStick)
    end
    if not isTask and self.currFindObjType ~= 4 then
        GlobalEventSystem:fire(GlobalEventType.STOP_AUTOFIND)
    end
end

function Scene:isMainRole(obj)
    return obj == self.role
end

function Scene:responsePick(objs, skillId, isCombo)
    local _pick = self:getDefenseObj(objs[1])
    if not _pick then
        return
    end
    if skillId == 0 then
        --采集
        if SSDUtils.checkIsFullPickTimes(_pick) then
            return
        end
        if SSDUtils.isMineInBody() then
            Message:getInstance():showMessage("您已掠夺，请先回本服提交")
            return
        end
        if self.monsterMap[_pick.vo.mkey] then
            local _p1 = _pick:getPixelPos()
            local _p2 = self.role:getPixelPos()
            local _offset = cc.pSub(_p1, _p2)
            local _dir = SceneUtils.getDir(_offset, self.role.dir)
            self.role:setDir(_dir)
            _pick:onClick()
        else
            --消消乐屏蔽挂机
            if not ClearFunUtilFun.isInClearFun() then
                self:autoFighting()
            end
        end
    else
        --攻击
        if _pick and (self.monsterMap[_pick.vo.mkey] or self.roleMap[_pick.vo.pkey]) then
            if SceneUtils.isMonsterInFightFilter(_pick, true) or (_pick and _pick.pickType == ObjPickType.RoleShadow) then
                --骑战修改增加
                if not self:checkFightState(_pick) then return end
            end 
            
            --提示首领没有掉落
            WorldBossHomeUtils.tipsCanDrop(_pick)

            local point
            local _cfg = Config.getConfig("Skill", skillId)
            if _cfg.drop_block and _cfg.drop_block > 0 then --特殊骑战跳跃技能
                self.role.stopMountsAttackAction = true
                self:fightRequest(objs, 1200001, point)
            end
           
            local flag = self:doFighting(self.role, objs, skillId, true, nil, isCombo)
            if not flag then
                self:fightRequest(objs, skillId, point)
            end
        else
            AutoFighting:getInstance():setTarget()
            --消消乐屏蔽挂机
            if not ClearFunUtilFun.isInClearFun() then
                self:autoFighting()
            end
        end
    end
end

function Scene:autoFighting(time)
    if AutoFighting:getInstance():isAutoFight() then
        AutoFighting:getInstance():setLastAttackTime(time)
    end
end

function Scene:isOutMapArea(pos)
    if not self.mapInfo[pos.x] or not self.mapInfo[pos.x][pos.y] then
        return true
    end
    
    return false
end

--骑战修改
function Scene:checkFightState(pick)
    
    local roleVo = RoleController:getInstance().model.mainRoleVo
    --领地战
    if SociatyUtils.isInDomain() and roleVo.pkstate == 3 and pick.vo.pkstate == 3 then
        if pick.pickType == ObjPickType.Role and roleVo.guildkey ~= pick.vo.guildkey and not AutoFighting:getInstance():isAutoFight() then
            AutoFighting:getInstance():startAutoFight()
        end
        return
    elseif SociatyUtils.isInUtage() then
        if pick.pickType == ObjPickType.Role and roleVo.guildkey == pick.vo.guildkey then
            return
        end
    elseif TransfigurationController:getInstance().isTransScene then 
        return true
    end
    local targetLevel = pick.vo.lv or 0
    local cfg = Config.getBaseScene(Scene:getInstance().sceneId)
    local isOutside = not cfg.subtype or cfg.subtype == 0
    local isLevelLimit = pick.pickType == ObjPickType.Role and math.abs(targetLevel - roleVo.lv) >= 80 and isOutside
    local isRedName = pick.vo.pkvalue and pick.vo.pkvalue >= 100

    if isLevelLimit then
        Message:getInstance():showMessage("野外场景中不能攻击等于差大于80级的玩家")
        return
    end
    if ObjNoMainRole[pick.pickType] and roleVo.pkstate == 0 and not isRedName and not pick.isAttackParty then
        Message:getInstance():showMessage("当前为【和平】模式，不可攻击其他玩家")
        AutoFighting:getInstance():stopAutoFight()
        return
    end

    if ObjNoMainRole[pick.pickType] and pick.vo.lv <= 60 and pick.vo.pkstate == 0 and pick.vo.pk_protect_time > 0 then
        Message:getInstance():showMessage("玩家处于首刀保护状态暂时无法攻击")
        AutoFighting:getInstance():stopAutoFight()
        return
    end

    if HandleTerrainHandler:isSafeArea(self.role:getLogicPos()) and ObjNoMainRole[pick.pickType] then
        Message:getInstance():showMessage("当前处于安全区，不可攻击其他玩家")
        AutoFighting:getInstance():stopAutoFight()
        return
    end

    if SceneUtils.isRoleInFightFilter(roleVo, pick, true) then return end
      
    return true
end

function Scene:runToPick(pick)
    if self.touchNode then 
        self.touchNode:setVisible(false)
    end 
    if pick.pickType == ObjPickType.Role or (pick.pickType == ObjPickType.Monster and SceneUtils.isMonsterInFightFilter(pick, true)) or (pick and pick.pickType == ObjPickType.RoleShadow) then 
        --场景点击玩家两次后进行攻击
        if pick.pickType == ObjPickType.Role then
            local curTarget = AutoFighting:getInstance():getTarget()
            if curTarget and not AutoFighting:getInstance():isAutoFight() and pick.pickType ~= ObjPickType.MainRole then
                if curTarget and curTarget.vo.pkey == pick.vo.pkey then
                    if not self:checkFightState(pick) then return end
                    local curFightType = AutoFighting:getInstance():getAutoFightType() or 0
                    AutoFighting:getInstance():startAutoFight(nil, curFightType > 0 and 1 or 0)
                end
            end
            AutoFighting:getInstance():setTarget(pick)
        else
            if not self:checkFightState(pick) then 
                return 
            end
            AutoFighting:getInstance():setTarget(pick)
            if not AutoFighting:getInstance():isAutoFight() and pick.pickType ~= ObjPickType.MainRole then
                local curFightType = AutoFighting:getInstance():getAutoFightType() or 0
                AutoFighting:getInstance():startAutoFight(nil, curFightType > 0 and 1 or 0)
            end
        end
    elseif pick.pickType == ObjPickType.Gather then
        if SceneUtils.isPickOnce(pick, self.sceneId) then
            AutoFighting:getInstance():pickGatherOnce(pick)
        else
            AutoFighting:getInstance():setTarget(pick)
            if not AutoFighting:getInstance():isAutoFight() then
                AutoFighting:getInstance():startAutoFight()
            end
        end
    else
        if pick.pickType == ObjPickType.Npc then
            self:changeNpcTarget(pick)
        end

        local function handler()
            local _p1 = pick:getPixelPos()
            local _p2 = self.role:getPixelPos()
            local _offset = cc.pSub(_p1, _p2)
            local _dir = SceneUtils.getDir(_offset, self.role.dir)
            self.role:setDir(_dir)

            pick:onClick()
        end
        
        if pick.pickType == ObjPickType.Armyer then --主城膜拜
            handler()
            return
        elseif pick.vo.kind == 49 or Config.Dungeon_juhun[pick.vo.mid]  then
            handler()   
            return 
        elseif pick.pickType == ObjPickType.ZhenBao then
            handler()   
            return 
        end 
        self:runToSceneObj(pick:getLogicPos(), handler, MoveEndCircle[pick.pickType])
    end
end

function Scene:fightRequest(objs, skillId, point)
    local key = SkillUtilFun.getSkillCDKey(skillId)

    if CDManager:getInstance():isInCD(1, key) then
        return
    end
    local _cfg = Config.getConfig("Skill", skillId)
    point = point or cc.p(0, 0)
 
    local _arr = {}
    for var = 1, #objs do
        local key = objs[var][2].pkey or objs[var][2].mkey
        if objs[var][1] == ObjPickType.Role then
            table.insert(_arr, {1, key})
        else
            table.insert(_arr, {2, key})
        end
    end

    if not SkillUtilFun.isSpecialAttackSkill(skillId) and _cfg and _cfg.action_time and _cfg.action_time > 0 then
        local function _delayRequest()
            FightController:getInstance():fire(FightEvent.REQUEST_20001, skillId, 0, point.x, point.y,  _arr)
        end
        performWithDelay(self.delayNode, _delayRequest, _cfg.action_time)
    else
        FightController:getInstance():fire(FightEvent.REQUEST_20001, skillId, 0, point.x, point.y,  _arr)
    end
    self:updateTimeBySkillID(skillId)

    --非普通攻击
    local isNormalAttack = SkillUtilFun.isNormalAttack(skillId)  
    if _cfg and not isNormalAttack then
        FightController:getInstance():fire(FightEvent.REFRESH_CD, skillId)
    end

    if _cfg and _cfg.sftime > 0 then
        self.continueTime = _cfg.sftime
        self.continueStart = GlobalMsTime
    end
end

function Scene:getSpecialJumpSkillPos(block , endP,obj)


    local role = obj or self.role

    local _startPosition = role:getPixelPos()
    local _endPosition = endP or role:getLogicPos()
    local info
    local stepPixel 
    local _endPos
    local _normalize
 
    if endP then
        _normalize = cc.pNormalize(cc.pSub(SceneUtils.logicToPixel(endP), _startPosition))
    else
        _normalize = cc.pNormalize(AutoFighting:getInstance():getDirNormal(role.dir))
    end 
    for var=1, block*2 do 
        stepPixel = 30*var
        _endPos = cc.pAdd(_startPosition, cc.pMul(_normalize, stepPixel))
        _endPos = SceneUtils.pixelTologic(_endPos)
        info = HandleTerrainHandler:getZoneInfo(_endPos)
        --障碍区
        if info == 0 or HandleTerrainHandler:isJumpArea(_endPos) or HandleTerrainHandler:isFlyArea(_endPos) then
            break
        end
        _endPosition = _endPos
    end
    return cc.p(math.ceil(_endPosition.x), math.ceil(_endPosition.y))
end
 
--释放时间的时间
function Scene:updateTimeBySkillID(skillID)
    self.skillTimeMap[skillID] = GlobalMsTime
end

--释放时间的时间
function Scene:getTimeBySkillID(skillID)
    if skillID ~= 0 then
        return self.skillTimeMap[skillID] or 0
    end
    return 0
end

--延迟多久执行
function Scene:getSurplusTimeBySkillID(skillID)
    if skillID == 0 then return 0 end
    local cfg = Config.getConfig("Skill", skillID)
    local originTime = self:getTimeBySkillID(skillID)
    local gapTime = GlobalMsTime - originTime
    --print("=originTime==", originTime, "cfg.excuteTime:", cfg.excuteTime, cfg.excuteTime - gapTime, "network:", gapTime)
    return math.max(0, (cfg.excuteTime or 0) - gapTime)
end

function Scene:getDefenseObj(defense)
    local def
    if defense then
        local pickType = defense[1]
        local key = defense[2].mkey or defense[2].pkey
        if ObjPickTypeMonster[pickType] or pickType == ObjPickType.Gather then
            def = self.monsterMap[key]
        elseif pickType == ObjPickType.Armyer or pickType == ObjPickType.RoleShadow then
            def = self.monsterMap[key]
        elseif pickType == ObjPickType.Role then
            --or是为了兼容破魂剧情
            def = self.roleMap[key] or self.monsterMap[key]
        elseif pickType == ObjPickType.MainRole then
            def = self.role
        elseif pickType == ObjPickType.ClientMonster then
            def = self.clientMonsterMap[key]
        elseif pickType == ObjPickType.ClientRole then
            def = self.clientRoleMap[key]
        end
    end

    return def
end


--[[
受击特效分为跟随和非跟随特效
isFollow判别（0.不跟随 1.跟随）
gethitType字段是获取受击特效的
gethitType参数是根据攻击方职业类型决定
]]
function Scene:doGethitEffect(pos, gethitType, skillId, defense, attPos)
    if not Scene.SHOW_FIHGT_INFO then return end
    local skillCfg = Config.Skill[skillId]
    if skillCfg and skillCfg.isFollow ~= 1 then
        if pos and skillCfg.gethit > 0 then
            self:playTimeLineEffect({
                    position = pos, 
                    res = ActionTimeLineUtils.getGethitEffectResource(skillCfg.gethit), 
                    animate = "action", 
                    zorder = skillCfg and skillCfg.gethitZorder or cc.RenderQueue.GRQ_AIR
                })
        end
    else
        if defense and self:getDefenseObj({defense.pickType, defense.vo}) then            
            if skillCfg and skillCfg.gethit > 0 then
                defense:playTimeLineEffect({
                        position = defense:getPixelPos(), 
                        res = ActionTimeLineUtils.getGethitEffectResource(skillCfg.gethit), 
                        animate = "action", 
                        zorder = skillCfg and skillCfg.gethitZorder or cc.RenderQueue.GRQ_AIR,
                    })
            else
                if gethitType then
                    defense:playGethitEffectWithDir(attPos, defense:getPixelPos(), ActionTimeLineUtils.getGethitEffectResource(gethitType), 
                        "action", nil, nil, nil, skillCfg and skillCfg.gethitZorder or cc.RenderQueue.GRQ_AIR)
                end
            end
        end
    end
end

--=================================================================
function Scene:doFighting(attacker, defenses, skillId, client, storyCallback, isCombo, skillPos)
    if not attacker then
        return
    end
    local _cfg = Config.Skill[skillId]
    local defender = self:getDefenseObj(defenses[1])
    --判断是否自己或队友相关
    local isContainMyself = SceneUtils.isContainMyself(attacker, defenses)

    --大内存机型不屏蔽特效等......or
    if SystemInfo and SystemInfo.memory and SystemInfo.memory > 3000 then
        isContainMyself = true
    end
    
    local gethitType = SceneUtils.getGethitType(attacker)
    --战斗数据，主角客户端战斗，返回受击飘血。其他均为返回时战斗并受击飘血
    local function _callback(current, segment)
        local pos = nil
        defender = self:getDefenseObj(defenses[1])
        if defender then
            pos = defender:getPixelPos()
        end

        local function doGethit()
            local _isCurrent = false
            if not current or type(current) ~= "number" or current == 1 then
                _isCurrent = true
            end

            for var = 1, #defenses do
                local defender = self:getDefenseObj(defenses[var])
                --飘血,聚魂塔伤害显示
                if isContainMyself or (attacker and attacker.vo.kind == 45) then
                    if _isCurrent then
                        if defenses[var][4] then
                            for _htype, fuc in ipairs(defenses[var][4]) do
                                if segment and segment > 1 and _htype == 1 then
                                    fuc[1](math.ceil(fuc[2]/segment) + math.random(1, 8), defender)
                                else
                                    fuc[1](fuc[2], defender)
                                end
                            end
                        end
                    else
                        if defenses[var][4] and defenses[var][4][1] then
                            defenses[var][4][1][1](math.ceil(defenses[var][4][1][2]/segment)+ math.random(1, 8))
                        end
                    end
                end
                --受击
                if defender then
                    if (not SceneUtils.IsPlayer(defender.pickType) or (defender and defender.fightInfo and not List.Empty(defender.fightInfo)))
                    and not SceneUtils.IsShadow(defender) then
                        defender:doGethit(attacker, skillId, segment)
                    end

                    local _isMon = false
                end
            end
        end

        --剧情回调
        if storyCallback then
            --临时处理方案
            if WindowMgr:getInstance():isShow("StoryView") then
                storyCallback()
            end
            storyCallback = nil

            doGethit()
            return
        end

        if attacker == self.role and client then
            --主角攻击播技能受击特效
            for var = 1, #defenses do
                if not (Scene.FAST_MODE and not isContainMyself) then
                    local defender = self:getDefenseObj(defenses[var])
                    local _defPos
                    if defenses[var][2] then
                        _defPos = SceneUtils.logicToPixel(cc.p(defenses[var][2].x, defenses[var][2].y))
                    end
                    if var == 1 then
                        if pos then
                            self:doGethitEffect(pos, gethitType, skillId, defender, self.role:getPixelPos())
                        end
                    else
                        if defender then
                            self:doGethitEffect(defender:getPixelPos(), gethitType, nil, defender, self.role:getPixelPos())
                        end
                    end
                end
            end
        else
            doGethit()
        end
    end

    local function _gethitHandler(delta)
        local _segmentAll = 1  --总段数
        local _segment = 1  --段数

        if _cfg and _cfg.segment ~= 0 then
            _segmentAll = _cfg.segment.segment
        end

        if _segmentAll > 1 then
            local function _playSegment()
                _callback(_segment, _segmentAll)
                _segment = _segment + 1
                if _segment <= _segmentAll then
                    performWithDelay(self.delayNode, _playSegment, _cfg.segment.duration)
                end
            end
            performWithDelay(self.delayNode, _playSegment, _cfg.segment.delay + delta)
        else
            performWithDelay(self.delayNode, _callback, delta)
        end
    end

    --正常主角出手（client是否剧情）
    if attacker == self.role and not client then
        _gethitHandler(0)
        return
    end
    --法器攻击
    if attacker.pickType == ObjPickType.MagicWeapon then
        self:doMagicWeaponFighting(attacker, defenses, skillId) 
        return      
    end
    --神灵攻击
    if attacker.pickType == ObjPickType.Shenling then
        attacker:doAttack()
        for var = 1, #defenses do
            --血量飘字
            local master = SceneUtils.getMasterRole(attacker.vo.key)
            if master and SceneUtils.isContainMyself(master, defenses) then
                if defenses[var][4] and defenses[var][4][1] then
                    local function _showBlood()
                        local defender = self:getDefenseObj(defenses[var])
                        defenses[var][4][1][1]((defenses[var][4][1][2]), defender)
                        if defender then
                            defender:doGethit(attacker, skillId)
                        end
                    end
                    performWithDelay(self.delayNode, _showBlood, 0.3)
                end
            end
        end
        return      
    end
    --纠正方向
    local normalize = SceneUtils.adJustDirByFight(attacker, defender)
    if attacker then
        local _actionType = 1
        local _continueTime = 0

        if skillId ~= 0 then
            if _cfg then
                _actionType = _cfg.action_type
                _continueTime = _cfg.sftime
            else
                _actionType = skillId
            end
        end

        --震屏(经验副本不震屏)
       if self.mainpKey == attacker.vo.pkey and _cfg and _cfg.isShake ~= 0 and self.isShake and not SceneUtils.isExpCopy(self.sceneId) then 
            local _ran = math.random(0, 1)
            if _cfg.isShake.pro and _ran <= _cfg.isShake.pro then
                self.camera:startShake(_cfg.isShake.range, _cfg.isShake.cycle, _cfg.isShake.time, _cfg.isShake.delay)
            end
        end

        local isDelayAttack = false
        local defEndPos
        if attacker == self.role then
            --放技能骑战不移动
            if not SkillUtilFun.isNormalAttack(skillId) or attacker:isChangePosture() then --变身不doOnMountsAttack
                if defender and defender.bossType and defender.bossType == 0 then
                    defEndPos = defender:getLogicPos()
                else
                    defEndPos = attacker:getLogicPos()
                end 
                isDelayAttack = attacker:doAttack(_callback, _actionType, _continueTime, skillId, storyCallback, normalize, defEndPos)
            else
                if defender then
                    isDelayAttack = attacker:doOnMountsAttack(nil, defender:getLogicPos(), false ,_callback, _actionType, _continueTime, skillId, storyCallback, normalize, isCombo)
                end
            end
        else
            --非主角的出招，延迟飘血即可
            --放技能骑战不移动
            if SkillUtilFun.isNormalAttack(skillId) and ObjRole[attacker.pickType] and defender then
                isDelayAttack = attacker:doOnMountsAttack(nil, defender:getLogicPos(), false , nil, _actionType, _continueTime, skillId, storyCallback, normalize)
            else
                if defender then
                    if defender.bossType and defender.bossType == 0 then
                        defEndPos = defender:getLogicPos()
                    else
                        defEndPos = attacker:getLogicPos()
                    end 
                    isDelayAttack = attacker:doAttack(nil, _actionType, _continueTime, skillId, storyCallback, normalize, defEndPos)
                else
                    isDelayAttack = attacker:doAttack(nil, _actionType, _continueTime, skillId, storyCallback, normalize, attacker:getLogicPos())
                end 
            end
            
            _gethitHandler(0)
        end

        --buff延时(骑战屏蔽)
        if isDelayAttack then
            return true
        end
    end

    --无目标播技能效果
    if not defender and skillPos and attacker and isContainMyself then
        if _cfg then
            local _start = attacker:getPixelPos()
            local _ended = skillPos
            local function _delay()
                SkillDisplay.skillAnalysis(_ended, _ended, skillId, isCombine, scale, isStory, attacker, defenser, zorder, self)
            end
            performWithDelay(self.delayNode, _delay, Config.Skill[skillId].effectAfter or 0)
        end
        return
    end

    if defender then
        --技能攻击
        local isTowerObj = attacker.vo.kind == 45 or attacker.vo.kind == 55 --是否塔防建筑
        if _cfg and (attacker and attacker.pickType ~= ObjPickType.Pet) and not isTowerObj then --宠物技能攻击走下面
            local _start = attacker:getPixelPos()
            local _ended = defender:getPixelPos()

            if (not Scene.FAST_MODE and isContainMyself) then
                defender.delayDeadTime = GlobalMsTime + 0.3
                table.insert(self.skillMap, {attacker = attacker, defenser = defender, p1 = _start, p2 = _ended, sid = skillId, icon = Config.Skill[skillId].icon, duration = Config.Skill[skillId].effectAfter, start = GlobalMsTime, isStory = storyCallback})
            end
        elseif isTowerObj then --塔攻击，先拷贝一份，防止后续修改成其他表现
            for i = 1, #defenses do
                local target = self:getDefenseObj(defenses[i])
                if target then
                    local pos = cc.p(attacker:getPixelPos().x, attacker:getPixelPos().y - attacker.boudingBox.height/4)
                    local tpos0 = cc.p(pos.x, Scene.SCENE_HEIGHT - pos.y)
                    local pos1 = cc.p(target:getPixelPos().x, Scene.SCENE_HEIGHT - target:getPixelPos().y + target.boudingBox.height/2)                        
                    local tpos = cc.p(pos1.x, Scene.SCENE_HEIGHT - pos1.y)
                    local vec0 = cc.pNormalize(cc.pSub(pos1, tpos0))
                    local vec = cc.pSub(tpos, pos)

                    local towerCfg = Config.Dungeon_juhun[attacker.vo.mid]
                    local attRes = self.isGhostBattleScene and "qz_jn_chongwudandao1" or "qz_jn_chongwudandao"
                    local attSpeed = 1
                    if towerCfg then
                        attRes = towerCfg.att_type == "0" and attRes or towerCfg.att_type
                    end
                    local function fnArrow()
                        local sp = cc.MyParticleSystem:Create(attRes)
                        sp:setScale(0.7)
                        sp:setPosition(pos.x, Scene.SCENE_HEIGHT - pos.y)
                        HandleRenderUnit:getCoreScene():addToRenderGroup(sp, cc.RenderQueue.GRQ_AIR, 20)
                        local angle = cc.pToAngleSelf(vec)
                        sp:SetZRotation(-angle)
                        local vecNormalize = cc.p(vec0.x, vec0.y)
                        local targetPos = cc.pAdd(pos1, cc.pMul(vecNormalize, 600))
                        sp:runAction(cc.Sequence:create(cc.MoveTo:create(attSpeed, targetPos),
                            cc.CallFunc:create(function()
                                sp:removeFromParent()
                                sp = nil
                            end)
                         ))
                    end
                    fnArrow()
                end
            end
        else
            --普通攻击
            --普通攻击是否有弹道
            if not (storyCallback or Scene.SHOW_FIHGT_INFO) then
            else
                if attacker then
                    if Scene.FAST_MODE and not isContainMyself then
                        return
                    end
                    --宠物弹道
                    if attacker.pickType == ObjPickType.Pet then
                        local masterKey = attacker.master.vo.pkey
                        if masterKey and masterKey == self.role.vo.pkey then
                            local pos = cc.p(attacker:getPixelPos().x, attacker:getPixelPos().y - attacker.boudingBox.height/4)
                            local tpos0 = cc.p(pos.x, Scene.SCENE_HEIGHT - pos.y)
                            local pos1 = cc.p(defender:getPixelPos().x, Scene.SCENE_HEIGHT - defender:getPixelPos().y + defender.boudingBox.height/2)                        
                            local tpos = cc.p(pos1.x, Scene.SCENE_HEIGHT - pos1.y)
                            local vec0 = cc.pNormalize(cc.pSub(pos1, tpos0))
                            local vec = cc.pSub(tpos, pos)

                            local petCfg = Config.getPet(attacker.vo.petId)
                            local attRes = "qz_jn_chongwudandao"
                            local skillRes = "qz_jn_chongwudandao1"
                            local attSpeed = 1
                            if petCfg then
                                attRes = petCfg.att_type == "0" and attRes or petCfg.att_type
                                skillRes = petCfg.skill_type == "0" and skillRes or petCfg.skill_type
                                attSpeed = petCfg.att_speed
                            end
                            local function fnArrow()
                                local sp = _cfg and cc.MyParticleSystem:Create(skillRes) or cc.MyParticleSystem:Create(attRes)
                                sp:setScale(0.7)
                                sp:setPosition(pos.x, Scene.SCENE_HEIGHT - pos.y)
                                HandleRenderUnit:getCoreScene():addToRenderGroup(sp, cc.RenderQueue.GRQ_AIR, 20)
                                local angle = cc.pToAngleSelf(vec)
                                sp:SetZRotation(-angle)
                                local vecNormalize = cc.p(vec0.x, vec0.y)
                                local targetPos = cc.pAdd(pos1, cc.pMul(vecNormalize, 600))
                                sp:runAction(cc.Sequence:create(cc.MoveTo:create(attSpeed, targetPos),
                                    cc.CallFunc:create(function()
                                        sp:removeFromParent()
                                        sp = nil
                                    end)
                                 ))
                            end

                            for i = 1, 2 do
                                GlobalTimerQuest:AddDelayQuest(function()
                                    fnArrow()
                                end, 0.3 * (i - 1))
                            end
                        end
                    end
                end
            end
        end
    end
end

function Scene:delayToFight()
    self.delayNode:stopAllActions()
    local function _delay()
        self:autoFighting()
    end
    performWithDelay(self.delayNode, _delay, 1)
end

--=================================================================
--剧情用的法宝攻击特效
function Scene:MagicWeaponAttackEffect(attacker, defenses, skillId)
    local _defender = defenses[1]
    if _defender then
        local _lastDefender = attacker  --储存上一个攻击目标，用连线机制播放法宝攻击动画
        local _start = attacker:getPixelPos()
        local _ended = _defender:getPixelPos()
        local _skill = Config.getConfig("Skill", skillId)
        --播放法宝发出攻击动画
        local _res = ActionTimeLineUtils.getGethitEffectResource(_skill.gethit)

        self:playTimeLineEffect({
            position = attacker:getPixelPos(),
            res = _res,
            animate = "action",
            zorder = _skill.gethitZorder,
            noEffect = true
        })
        --记录已经访问过的点
        local visitMap = {}
        for var = 1, #defenses do
            local maxDis = 0
            local maxIndex = 1
            local _st = _lastDefender:getPixelPos()
            local _maxDisDefender = defenses[var]
            local _ed = _maxDisDefender:getPixelPos()
            table.insert(self.skillMap, {attacker = attacker, defenser = _maxDisDefender, p1 = _st, p2 = _ed, sid = skillId, duration = 0, start = GlobalMsTime, isStory = nil})           
            _lastDefender = _maxDisDefender
            visitMap[maxIndex] = true
        end
    end
end

function Scene:doMagicWeaponFighting(attacker, defenses, skillId)
    --法宝距离太远，先刷到人物旁边再攻击
    if attacker.master and cc.pDistanceSQ(attacker.master:getLogicPos(), attacker:getLogicPos()) > 100 then
        attacker:doFade(true, nil, function ()
            attacker:doFade(false, nil, function ()
                self:doMagicWeaponFighting(attacker, defenses, skillId)
            end)
        end)
        return
    end
    local _defender = self:getDefenseObj(defenses[1])
    if _defender then
        local _lastDefender = attacker  --储存上一个攻击目标，用连线机制播放法宝攻击动画
        local _start = attacker:getPixelPos()
        local _ended = _defender:getPixelPos()
        local _skill = Config.getConfig("Skill", skillId)
        --播放法宝发出攻击动画
        local _res = ActionTimeLineUtils.getGethitEffectResource(_skill.gethit)
        self:playTimeLineEffect({
            position = attacker:getPixelPos(),
            res = _res,
            animate = "action",
            zorder = _skill.gethitZorder,
            noEffect = true
        })
        --记录已经访问过的点
        local visitMap = {}
        for var = 1, #defenses do
            local maxDis = 0
            local maxIndex = 1
            local _st = _lastDefender:getPixelPos()
            --筛选最远的目标进行攻击
            for i = 1, #defenses do
                local defender = self:getDefenseObj(defenses[i])
                if defender and not visitMap[i] then
                    local ed = defender:getPixelPos()
                    local dis = cc.pGetLength(ed, _st)
                    if dis > maxDis then
                        maxDis = dis
                        maxIndex = i
                    end 
                end
            end

            local _maxDisDefender = self:getDefenseObj(defenses[maxIndex])
            local _ed = _maxDisDefender:getPixelPos()
            table.insert(self.skillMap, {attacker = attacker, defenser = _maxDisDefender, p1 = _st, p2 = _ed, sid = skillId, duration = 0, start = GlobalMsTime, isStory = nil})           
            _lastDefender = _maxDisDefender
            visitMap[maxIndex] = true
            --血量飘字
            local master = SceneUtils.getMasterRole(attacker.vo.key)
            if master and SceneUtils.isContainMyself(master, defenses) then
                if defenses[var][4] and defenses[var][4][1] then
                    local function _showBlood()
                        local defender = self:getDefenseObj(defenses[var])
                        defenses[var][4][1][1]((defenses[var][4][1][2]), defender)
                        if defender then
                            defender:doGethit(attacker, skillId)
                        end
                    end
                    performWithDelay(self.delayNode, _showBlood, 0.3)
                end
            end
        end
    end
end

function Scene:dropCheckHandler()
	--如果当前已经选中目标,返回拾取数量为0
    if AutoFighting:getInstance():getTarget() then
        return 0
    end
    local _num = 1
    local _area = 1 * 1 --用于判断脚下
    local isScalePick = SceneUtils.isScalePickArea(self.sceneId) --坐骑副本范围扩大
    if isScalePick then
        _area = _area * 3
    end
    local _distance = 9 * 9 --默认为一屏幕内距离，大约写一个距离，效率高一点
    if not AutoFighting:getInstance():isAutoFight() then
        _distance = 1 * 1
    end 
    local _total = 0
    self.checkDropPerSecond = 4 --一秒检查4次

    local t = {
        [6] = true,
    }

    local cfg = Config.getConfig('BaseScene', self.sceneId)
    if t[cfg.subtype] then
        self.checkDropPerSecond = 8
    end

    self.auto_pickup = false
    if self.isGoldCopyScene then --铜钱副本
        self.checkDropPerSecond = 12
        _distance = nil
    end

    --自动捡取
    local auto_list = {}
    
    --屏蔽小精灵自动捡取

    --     print("-------auto_pickup------true---")

    local _nearDrop
    local _canGet
    local requestList = {}
    -- print("自动拾取----",self.startRunPick, self.auto_pickup)
    
    local function handler(drop)
        self.startRunPick = false
        --若果选中玩家，先锤人，再捡东西
        local player = AutoFighting:getInstance():getTarget()
            if player then 
                self:doFighting()
                print("有选取目标,直接打人！")
            return
        else
            print("没目标") 
        end
        if not _nearDrop then return end
        local _drop = drop or _nearDrop
        --防止多次请求
        if requestList[_drop] then
            return
        end
        --假拾取
        requestList[_drop] = true
        if _drop.vo.isVirtural then
            _drop.vo.code = 1
            _drop.vo.dropx = _drop.vo.x
            _drop.vo.dropy = _drop.vo.y
            self:response12023(_drop.vo)
        else
            local _isMine = _drop.vo.is_my
            local _leaveTime = _drop.vo.leave_time
            local _key = _drop.vo.key
            if _isMine == 1 then
                self:request12023({_key})
            elseif _isMine == 0 then
                --不属于自己，有拾取倒数
                if _leaveTime ~= -1 then
                    if _drop:isOverTime() then
                        self:request12023({_key})
                    else
                        local _tipStr = string.format(SceneWords[1], _drop:getLeftTime())
                        Message:getInstance():showMessage(_tipStr)
                    end
                end
            end
        end
    end
    local _getDisFn = SceneUtils.getDistanceSQ
    local _footList = {}
    for _, _drop in pairs(self.dropMap) do
        if not _drop._ispicked then
            local _p1 = _drop:getLogicPos()
            local _p2 = self.role:getLogicPos()

            local _dis = _getDisFn(_p1, _p2)
            --是否在拾取范围
            if not _distance or _dis <= SceneUtils.attackAreaParam * _distance then
                _canGet = true
                if _dis <= SceneUtils.attackAreaParam * _area and (_drop.vo.leave_time >= 0 or isScalePick) then
                    _footList[#_footList + 1] = _drop
                end
                if self.auto_pickup then
                    table.insert(auto_list, _drop.vo.key)
                    if not _nearDrop then
                        _nearDrop = _drop
                    elseif GoodsUtil.getGoodsColor(_nearDrop.vo.goodstype) < GoodsUtil.getGoodsColor(_drop.vo.goodstype) then
                        _nearDrop = _drop
                    end
                else
                    if not _nearDrop then
                        _nearDrop = _drop
                    elseif _dis < _getDisFn(_nearDrop:getLogicPos(), _p2) then
                        _nearDrop = _drop
                    end 
                end
            end
        end
    end
    
    --没有物品
    if not _nearDrop then
        return 0 
    end
    --不在捡取范围内
    if not _canGet then return end
    if not self.startRunPick and not AutoFighting:getInstance():isAutoFight() then 
        handler()
    end
    if self.startRunPick then --正在捡取
        return 
    end 
    --自动捡取
    if self.auto_pickup and #auto_list > 0 then
        self:request12023(auto_list)
        return
    end
    --在挂机时优先捡取物品
    if not self.isGoldCopyScene then
        self.isPickFirst = true
    end

    --铜钱副本特殊处理
    local _canPick = false
    if _nearDrop and (_nearDrop.vo.is_my == 1 or (_nearDrop.vo.is_my == 0 and _nearDrop:getLeftTime() == 0)) then
        _canPick = true
    end
    if self.isPickFirst and _canPick and AutoFighting:getInstance():isAutoFight() then
        self.startRunPick = true
        if self.curDropInfo.key and self.curDropInfo.key == _nearDrop.key then
            self.curDropInfo.count = self.curDropInfo.count + 1
            if self.curDropInfo.count >= 20 then
                handler()
            end
        else
            self.curDropInfo.key = _nearDrop.key
            self.curDropInfo.count = 1
        end
        self:runToSceneObj(_nearDrop:getLogicPos(), handler, nil, true, nil, nil, nil, true)
    end
    if #_footList > 0 then
        for _, dropObj in pairs(_footList) do
            handler(dropObj)
        end
    end
    if self.isGoldCopyScene then
        handler()
    end
end

function Scene:showAllObjPosition()
    self.role:showPosition()

    for key, var in pairs(self.roleMap) do
        var:showPosition()
    end

    for key, var in pairs(self.monsterMap) do
        var:showPosition()
    end

    for key, var in pairs(self.npcMap) do
        var:showPosition()
    end

    for key, var in pairs(self.dropMap) do
        var:showPosition()
    end
end

function Scene:searchNpcByMid(mid)
    for key, var in pairs(self.npcMap) do
        if var.vo.mid == mid then
            return self.npcMap[key]
        end
    end
    return nil
end

function Scene:getNearSceneObj(objs)
    if not self.role then return end
    local _logic = self.role:getLogicPos()

    local _dis
    objs = objs or {}
    for var =1, #objs do
        local _p = cc.p(objs[var].x, objs[var].y)
        local _temp = cc.pDistanceSQ(_logic, _p)
        if _dis then
            if _dis[1] > _temp then
                _dis = {_temp, _p}
            end
        else
            _dis = {_temp, _p}
        end
    end

    if _dis then
        return _dis[2]
    end

    return cc.p(0, 0)
end

function Scene:showFindPathInfo(bo)
    if bo then
        GlobalEventSystem:fire(GlobalEventType.SHOW_FINDPATH_TEXT, 2, true)
    else
        GlobalEventSystem:fire(GlobalEventType.SHOW_FINDPATH_TEXT, 2, false)
    end
end

--如果是寻路状态，跳跃结束后会继续寻路
function Scene:jumpEndFindSceneObj()
    if self.touchRun then 
        self:findSceneObj(self.currFindObjType, self.currFindObjSid, self.currFindObjMid, self.taskCallBack, self.currFindObjIsTask)
    end
end

--寻找场景目标，type类型  1Npc 2怪物 3坐标点 4采集物 5传送门
--sid 场景id
--mid 标示，type=3为坐标点
--callback回调
--isTask 是否任务寻路
--transport 是否点对传送 0否 1点对场景 2点对点 3不直接切场景走传送门
--noUI 是否不需要UI
--isFlyShoe 小飞鞋
function Scene:findSceneObj(type, sid, mid, callback, isTask, transport, noUI, isFlyShoe)
    if not self.role then
        return
    end
    --飞行中，此次寻路下地后处理
    if self.role and self.role:isInOverflyState() then
        self.flyCallback = function()
            self:findSceneObj(type, sid, mid, callback, isTask, transport, noUI, isFlyShoe)
        end
        return
    end
    --巡游状态下不可操作
    if self:isCruise() and transport ~= 4 then
        Message:getInstance():showMessage("巡游状态下不可操作")
        return
    end
    self.flyCallback = nil
    self.isPlayUpAnimation = false
    if type == 2 or type == 4 or type == 5 then
        self.isPlayUpAnimation = true
    end
    self.pathArray = {}
    self:cleanEndPoint()
    self.findWayNode:stopAllActions()
    self.currFindObjType = type
    self.currFindObjSid = sid
    self.currFindObjMid = mid
    self.currFindObjIsTask = isTask
    self.taskCallBack = callback

    if self.touchNode then 
        self.touchNode:setVisible(false)
    end 

    if sid == self.sceneId then
        local function _handler()
            self.touchRun = false
            if callback then
                callback()
            end
        end

        local pos, pick
        if type == FindObjType.Npc then
            local v = self.cfg.npcs[mid]
            pos = cc.p(v.x, v.y)
            pick = ObjPickType.Npc
        elseif type == FindObjType.Monster then
            pos = self:getNearSceneObj(self.cfg.monsters[mid])
            pick = ObjPickType.Monster
        elseif type == FindObjType.Point then
            pos = mid
            pick = ObjPickType.Others
        elseif type == FindObjType.Gather then
            pos = self:getNearSceneObj(self.cfg.monsters[mid])
            pick = ObjPickType.Gather
        elseif type == FindObjType.Door then
            local v = self.doorMap[mid]
            if v then
                pos = cc.p(v.vo.x, v.vo.y)
            end
            pick = ObjPickType.Door

            _handler = function()
                self.touchRun = false
                if v then
                    v:onClick()
                end
                if callback then
                    callback()
                end
            end
        elseif type == FindObjType.None then
            self:showFindPathInfo(false)
            return
        end

        if isTask then
            self.guidePos = pos
        else
            self.guidePos = nil
        end

        if pos then
            if type == FindObjType.Monster then
                local _circle = 6
                -- print("->>>>>>>>>>>>>>>>>>@@@@@@@@@@@@@@@@@@@@@--->>>",_circle,pos.x,pos.y)   
                self:runToSceneObj(pos, _handler, _circle, true, nil, isTask,nil,nil,transport == 4)

            else
                local endCircle = MoveEndCircle[pick]
                if type == FindObjType.Npc then
                    self:changeNpcTarget(self:searchNpcByMid(mid))
                    -- if mid == 11008 then
                        -- endCircle = 2
                    -- else
                        local curPos = self.role:getLogicPos()
                        if math.abs(curPos.x - pos.x) <= 3 and math.abs(curPos.y - pos.y) <= 3 then
                            _handler()
                            return
                        else
                                local tempPos = SceneUtils.isOnRightSide(self.role:getLogicPos(), pos, mid)
                                if tempPos then
                                    pos = tempPos
                                else
                                    endCircle = 2
                                end
                        end
                    -- end
                end
                self:runToSceneObj(pos, _handler, endCircle, nil, nil, isTask,nil,nil,transport == 4)
            end
            self:showFindPathInfo(true)  
        end
    else
        --跨场景
        local canFly = false
        local function _temp()
            self:findSceneObj(type, sid, mid, callback, isTask, isFlyShoe)
            self:showFindPathInfo(true)  
        end

        if SceneUtils.isTown(sid) and not TaskController:getInstance():isEscort() and transport ~= 3 then
            local roleVo = RoleController:getInstance().model.mainRoleVo
            --非战斗状态或和平状态
            if SceneUtils.isCanTransfer(self.role, roleVo) then
                --非死亡状态
                local function sureCallback()
                    AutoFighting:getInstance():stopAutoFight()
                    if transport and transport == 2 then --点对点传送
                        local findType = 2
                        if type == FindObjType.Monster then
                            findType = 3
                        end
                        self:request12015(findType, mid, 1)
                    else
                        self:request12015(1, sid, 0)    
                    end
                    if mid == EscortNpcID then
                        performWithDelay(self.findWayNode, _temp, 2.8)
                    else
                        performWithDelay(self.findWayNode, _temp, SceneUtils.findWayDuration)
                    end
                end

                if type == FindObjType.None then  --世界地图传送不开启传送面板
                    sureCallback()
                    return
                end

                if TranslateView and TranslateView.instance then
                    return
                end
                
                --是否需要传送面板再次确认
                if self.role:isOverfly() then
                    canFly = true
                    sureCallback() 
                    return
                elseif transport and (transport == 1 or transport == 2) then
                    canFly = true
                    --不需要UI
                    if noUI then
                        sureCallback()
                        return
                    end
                    TranslateView:getInstance({name = Config.BaseScene[sid].name, callback = sureCallback}) 
                    return
                end
            end
        end

        local index = 1
        self.pathArray = SceneUtils.getCrossScenePath(self.sceneId, sid)
        local function _move()
            local _path = self.pathArray[index]
            if _path then
                local function _click()
                    self.touchRun = false
                    if self.doorMap[_path.scene] then
                        self.doorMap[_path.scene]:onClick()

                        --临时方法
                        if _path.scene == sid then
                            performWithDelay(self.findWayNode, _temp, SceneUtils.findWayDuration)
                        else
                            performWithDelay(self.findWayNode, _move, SceneUtils.findWayDuration)
                        end
                    end
                end

                local pos = cc.p(_path.x, _path.y)

                if isTask then
                    self.guidePos = pos
                else
                    self.guidePos = nil
                end

                self:runToSceneObj(pos, _click, MoveEndCircle[ObjPickType.Door], nil, nil, isTask)
                self:showFindPathInfo(true)      --显示寻路信息
                if canFly then
                    performWithDelay(self.findWayNode, _temp, 1.0)
                end
            end

            index = index + 1
        end
        _move()
    end
end

function Scene:overflyEnd(isWalk)
    if isWalk then 
        return 
    end
    if SetController:getInstance().model.isUsingFly then
    
        AutoFighting:getInstance():startAutoFight()
        SetController:getInstance().model.isUsingFly = false
    end
    if self.flyCallback then 
        self.flyCallback()
        self.flyCallback = nil
    end
end

--寻找场景目标并执行操作，type类型  1Npc 2怪物 3坐标点 4采集物 5传送门
--sid 场景id
--mid 标示，type=3为坐标点
--callback回调
--是否任务寻路
function Scene:findObjAndOperate(type, sid, mid, callback, isTask)
    local function _callback()
        if type == FindObjType.Npc then
            local _npc = self.npcMap[mid]
            if _npc then
                _npc:onClick()
            end
        elseif type == FindObjType.Monster then
            GlobalEventSystem:fire(GlobalEventType.START_AUTO_FIGHT)
        elseif type == FindObjType.Door then
            local _door = self.doorMap[mid]
            _door:onClick()
        elseif type == FindObjType.Gather then
            local gather = self.monsterMap[mid]
            gather:onClick()
        end
        if callback then
            callback()
        end
    end
    self:findSceneObj(type, sid, mid, _callback, isTask)
end

--得到当前寻路的终点坐标
function Scene:getCurrFindObjPos()
    local pos
    local mid = self.currFindObjMid
    if self.currFindObjType == FindObjType.Npc then
        if self.sceneId == self.currFindObjSid then --同场景npc
            local v = self.cfg.npcs[mid]
            pos = cc.p(v.x, v.y)
        else
            if not Config.Scene[self.currFindObjSid] then
                require("game.config.scene." .. self.currFindObjSid)
            end
            local npc = Config.getScene(self.currFindObjSid).npcs[mid]
            pos = cc.p(npc.x, npc.y)
        end
    elseif self.currFindObjType == FindObjType.Monster then
        if self.sceneId == self.currFindObjSid then --同场景寻怪
            pos = self:getNearSceneObj(self.cfg.monsters[mid])
        else
            if not Config.Scene[self.currFindObjSid] then
                require("game.config.scene." .. self.currFindObjSid)
            end
            local monster = Config.getScene(self.currFindObjSid).monsters[mid][1]
            pos = cc.p(monster.x, monster.y)
        end
    elseif self.currFindObjType == FindObjType.Gather then
        pos = self:getNearSceneObj(self.cfg.monsters[mid])
    elseif self.currFindObjType == FindObjType.Point then
        pos = self.currFindObjMid
        if self.sceneId == self.currFindObjSid then
            local route = HandleOperateManager:getFindPath()
            if route then
                pos = route[#route]
            end
        end
    elseif self.currFindObjType == FindObjType.Door then
        local v = self.doorMap[mid]
        if v then
            pos = cc.p(v.vo.x, v.vo.y)
        end
    end
    return pos
end

function Scene:startPicking(obj, cd, flag, name)
    if self.pickObj then
        if self.pickObj == obj then return end
        self:stopPicking()
    end

    self.pickObj = obj 
    if not self.pickNode then
        local resPath = "assets/ui/boxActivityUI.csprite"            
        local gatherNode = cc.SpriteUI:createWithResCSpriteLoader(resPath, "boxBgImg") 
        HandleRenderUnit:getCoreScene():addToRenderGroup(gatherNode, cc.RenderQueue.GRQ_UI)
        gatherNode:setPosition(cc.p(0, -150))
        self.pickNode = gatherNode
        self.pickNode:setScale(HandleRenderUnit:getResolutionScale())
        self.pickNode:setVisible(false)
        local boxBgImg = cc.SpriteUI:createWithResCSpriteLoader(resPath, "boxNameBgImg")
        boxBgImg:setPosition(62, -12)
        boxBgImg:setAnchorPoint(cc.p(0.5, 0.5))
        gatherNode:addChild(boxBgImg, 3)

        local nameLbl = cc.Label:create()
        nameLbl:setPosition(cc.p(62, -12))
        nameLbl:setSystemFontSize(18)
        nameLbl:setColor(cc.c3b(100, 50, 45)) 
        nameLbl:setAnchorPoint(cc.p(0.5,0.5))
        gatherNode:addChild(nameLbl, 3)
        local boxImg = cc.SpriteUI:createWithResCSpriteLoader(resPath, "hand")
        boxImg:setPosition(62, 62)
        boxImg:setAnchorPoint(cc.p(0.5, 0.5))
        gatherNode:addChild(boxImg,5)
        self.pickNode.boxImg = boxImg
        self.pickNode.nameLbl = nameLbl

        local function delayCreateFunc(obj)
            self.sprite = obj
            self.pickBar = cc.ProgressTimer:create(self.sprite)
            gatherNode:addChild(self.pickBar)
            self.pickBar:setPosition(62, 62)
            self.pickBar:setAnchorPoint(0.5, 0.5)
            self.pickBar:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
            self.pickBar:setPercentage(0)
            self.sprite:autorelease()
        end
        
        local resName = "boxProgressBarImg"
        self.sprite = cc.SpriteUI:createWithResCSpriteLoaderNotify(resPath, resName, delayCreateFunc)
        self.sprite:retain()
    end
    --手指/宝箱
    if self.pickNode.boxImg then
        local pathRes, iconImg ="assets/ui/boxActivityUI.csprite", "hand"
        local gatherId = obj.vo.mid or 1
        local gatherInfo = Config.getConfig("Mon", gatherId) or Config.getConfig("Mon", 1)
        local tipsText = "采集中"
        if IsgatherBoxImg[gatherInfo.icon] then
            pathRes, iconImg = "assets/ui/boxActivityUI.csprite", "boxIcon"
            tipsText = "开启中"
        end
        self.pickNode.nameLbl:setString(tipsText)
        self.pickNode.boxImg:setResCsprite(pathRes, iconImg)
    end
    local percent = 0
    if self.pickBar then
        self.pickBar:setPercentage(percent)
    end
    if self.role then
        self.role:showPicking(true)
    end
    local starTime = GlobalMsTime
    local floor = math.floor
    local function countFunc()
        if self.role and self.role.isDead and self.pickObj then
            self:stopPicking()
            self.pickNode:stopAllActions()
            self.pickNode:setVisible(false)
            return
        end

        percent = (GlobalMsTime - starTime)/cd*100
        percent = floor(percent)
        percent = percent < 100 and percent or 100
        if percent > 1 then
            self.pickNode:setVisible(true)
        end
        if self.pickBar then
            self.pickBar:setPercentage(percent)
        end
        if percent >= 100 then
            self.pickNode:stopAllActions()
            self.pickNode:setVisible(false)
            if self.touchSwallowPane then 
                self.touchSwallowPane:removeFromParent()
                self.touchSwallowPane = nil
            end

            if self.pickObj then
                --播放采集效果
                self:showCollectEffect(obj)
                self.pickObj:stopEffect()
                -- self:stopPicking() --骑战屏蔽
                FightController:getInstance():fire(FightEvent.REQUEST_20003, self.pickObj.vo.mkey, 2)
                --采集完成不停止挂机
                if SociatyUtils.isInDinner() then
                    AutoFighting:getInstance():stopAutoFight()
                end
            end
        end
    end
    schedule(self.pickNode, countFunc, 0.01)
    
    if self.pickObj.vo and self.pickObj.vo.mid then 
        local mid = self.pickObj.vo.mid
        if mid == 10106 or mid == 10109 then --新手采集增加遮罩不让打断
            if not self.touchSwallowPane then 
                self.touchSwallowPane = cc.Control:create()
                self.touchSwallowPane:setContentSize(display.size)
                self.touchSwallowPane:setAnchorPoint(cc.p(0.5, 0.5))
                self.touchSwallowPane:setPosition(0, 0)
                self.touchSwallowPane:setSwallowsTouches(true)
                self.touchSwallowPane:setTouchEnabled(true)
                HandleRenderUnit:getCoreScene():addToRenderGroup(self.touchSwallowPane, cc.RenderQueue.GRQ_UI2, 1)
            end

            performWithDelay(self.delayNode, function( ... )
                if self.touchSwallowPane then 
                    self.touchSwallowPane:removeFromParent()
                    self.touchSwallowPane = nil
                end
            end,3)
        end
    end
end

function Scene:stopPicking()
    if self.role then
        self.role:showPicking(false)
    end

    if self.pickNode then
        self.pickNode:stopAllActions()
        self.pickNode:setVisible(false)
    end

    if self.pickObj then
        self.pickObj:stopPicking()
        self.pickObj = nil

        --消消乐屏蔽挂机
        if AutoFighting:getInstance():isPickingGather() then
            AutoFighting:getInstance():stopPickGather()
        end
        if not ClearFunUtilFun.isInClearFun() then
            --骑战屏蔽
        else
            AutoFighting:getInstance():stopAutoFight()
        end
    end
end

function Scene:getNearDoor()
    if not self.role then return end
    local pos = self.role:getPixelPos()
    for key, var in pairs(self.doorMap) do
        local _box = var:getBoundingBox()
        if cc.rectContainsPoint(_box, pos) then
            return var
        end
    end

    return nil
end

function Scene:changeRoleInfo(vo)
    if vo.mount_id or (vo.vip and self.role and vo.vip > self.role.vo.vip) then
        if self.role then
            self.role:initWithVo(RoleController:getInstance().model.mainRoleVo)
        end
    end
end

function Scene:updateNpcStatus(npcStatusList)
    self.npcStatusList = {}
    for npcID, statusVo in pairs(npcStatusList) do
        self.npcStatusList[npcID] = statusVo
    end

    --刷新npc状态
    for _, npc in pairs(self.npcMap) do
        if self.npcStatusList[npc.vo.mid] then
            npc:updateView(self.npcStatusList[npc.vo.mid])
        else
            npc:updateView()
        end
    end
end

function Scene:changeMonsterTarget(target)
    local _mon = self.monsterMap[self.selectMonsterKey]   

    --选中目标添加特效光圈
    if self.lastTarget then
        self.lastTarget:setEfffect(false)    
    end
    if target and target.vo.pkey ~= RoleController:getInstance().model.mainRoleVo.pkey then
        target:setEfffect(true)
    end 
    self.lastTarget = target    

    if _mon then
        if _mon == target then return end
        _mon:setSelected(false)
        self.selectMonsterKey = nil
    end

    if not target or target.pickType ~= ObjPickType.Monster then
        return
    end

    self.selectMonsterKey = target.vo.mkey
    self.monsterMap[self.selectMonsterKey]:setSelected(true)
    self:changeNpcTarget(nil)
end

function Scene:changeNpcTarget(target)
    local _npc = self.npcMap[self.selectNpcKey]
    if _npc then
        if _npc == target then return end
        _npc:setSelected(false)
        _npc:setDirToRole(false)
        self.selectNpcKey = nil
    end

    if not target then
        return
    end

    self.lastSelectNpcFlag = false
    self.selectNpcKey = target.vo.mid
    self.npcMap[self.selectNpcKey]:setSelected(true)
    self.npcMap[self.selectNpcKey]:setDirToRole(true)
end

--测试持续施法
function Scene:continueBar()
end

function Scene:cleanData()
    self.doubleMountVo = {} -- 坐骑共乘信息
    self.isPlayVipSkill = false
    self.curDropInfo = {}
    self.flyCallback = nil
    self.changeSceneJumping = false
    --停止各种回调
    self.delayNode:stopAllActions()
    self.findWayNode:stopAllActions()
    self.delDelayNode:stopAllActions()

    --移除死亡效果
    for dict in pairs(self.deadList or {}) do
        if dict.deadNode then
            dict.deadNode:removeFromParent(true)
            dict.deadNode = nil
        end

        if dict.node then
            dict.node:removeFromParent(true)
            dict.node = nil
        end
    end
    self.deadList = {}
    self.clearMonList = {}

    self.sceneId = 0
    self.lastSceneID = nil

    AutoFighting:getInstance():stopAutoFight()
    if self.brightIcon then
        self.brightIcon:removeFromParent()
        self.brightIcon = nil
    end

    --清除场景特效
    for _, effectNode in pairs(self.effectList or {}) do
        effectNode:removeFromParent()
    end
    self.effectList = {}

    HandleOperateManager:clearSrcOperator()
    Runner:getInstance():removeRunObj(self)

    self:cleanLastScene()
    self:deleteMainRole()

    --清除上一次的数据
    if self.loadingUtils then
        self.loadingUtils:distoryScene()
    end
    if HandleTerrainHandler then
        HandleTerrainHandler:distory()
    end

    if self.touchLayer then
        self.touchLayer:removeFromParent(true)
        self.touchLayer = nil
    end

    self.sceneId = 0
    self.isGoldCopyScene = false
    self.isBossCopyScene = false
    self.isGhostBattleScene = false

    self.monSpeedMap = {}

    Runner:getInstance():removeRunObj(self)
    print("Scene cleanData >>")
end

function Scene:createClientNpc(npcIDVoList)
    for npcId, npcVo in pairs(npcIDVoList) do
        List.PushBack(self.clientNpcList, npcVo)
    end
end

function Scene:createClientMonster(monstersIDVoList)
    for monsID, monsVo in pairs(monstersIDVoList) do
        List.PushBack(self.clientMonsterList, monsVo)
    end
end

function Scene:createClientRole(roleIDVoList)
    for _, roleVo in pairs(roleIDVoList) do
        List.PushBack(self.clientRoleList, roleVo)
    end
end

function Scene:createClientDoor(doorVoList)
    for _, doorVo in pairs(doorVoList or {}) do
        List.PushBack(self.doorList, doorVo)
    end
end

function Scene:createMonsterClient()

end

function Scene:createRoleClient()
end

function Scene:createNpcClient()


end

function Scene:clearClientNpc(nkeylist)
    for var =1, #nkeylist do
        local nkey = nkeylist[var].nkey
        local _npc = self.clientNpcMap[nkey]
        if _npc then
            local function callback()
                _npc:delete()
                self.clientNpcMap[nkey] = nil
            end
            _npc:deadEffect(callback)
        end
    end
end

function Scene:clearClientMonster(mkeylist)
    for var =1, #mkeylist do
        local mkey = mkeylist[var].mkey
        local _mon = self.clientMonsterMap[mkey]
        if _mon then
            local function callback()
                _mon:delete()
                self.clientMonsterMap[mkey] = nil
            end
            _mon:deadEffect(callback)
        end
    end
end

function Scene:clearClientRole(pkeylist)
    for var =1, #pkeylist do
        local pkey = pkeylist[var].pkey
        local _role = self.clientRoleMap[pkey]
        if _role then
            local function callback()
                _role:delete()
                self.clientRoleMap[pkey] = nil
            end
            _role:deadEffect(callback)
        end
    end
end

--伴随npc
--[[option 为"add", "remove"]]
function Scene:followerOption(voList, option)
    --判断场景类型类型
    if not SceneUtils.isTown(self.sceneId) then
        return
    end

    for var =1, #voList do
        List.PushBack(self.followerList, {voList[var], option})
    end
end

function Scene:createFollowerHandler()
    if List.Empty(self.followerList) then return end

    local _t = List.PopFront(self.followerList)
    local _vo = _t[1]

    if _t[2] == "add" then
        if not self.followerMap[_vo.fkey] then
            local _follower = Follower.new(_vo)
            _follower:setDir(_vo.dir)
            self.followerMap[_vo.fkey] = _follower
        end
        self.followerMap[_vo.fkey]:setLogicPos(cc.p(_vo.x, _vo.y))

        --角色在行走中时
        if self.role:isRunning() then
            Scene:getInstance():fire(SceneEvent.MAIN_ROLE_START_MOVE, clone(self.role.endPos))
        end
    else
        local _follower = self.followerMap[_vo.fkey]
        if _follower then
            _follower:delete()
            self.followerMap[_vo.fkey] = nil
        end
    end
end

--宠物
--[[option 为"add", "remove"]]
function Scene:petOption(voList, option)
    for var =1, #voList do
        List.PushBack(self.petList, {voList[var], option})
    end
end

function Scene:createPetHandler(voList, option)
    local _vo = voList[1]
    if option == "add" then
        --消消乐屏蔽宠物
        if ClearFunUtilFun.isInClearFun() then
            return
        end
        
        if not self.petMap[_vo.pkey] then
            local pet = Pet.new(_vo)
            pet:setDir(_vo.dir)
            pet:setVisible(not self.isHidePet)
            self.petMap[_vo.pkey] = pet
            self.petMap[_vo.pkey]:setLogicPos(cc.p(_vo.x, _vo.y))
            self:updateFollerHideType(pet, _vo.pkey)
        else
            self.petMap[_vo.pkey]:initWithVo(_vo)
        end
    else
        local pet = self.petMap[_vo.pkey]
        if pet then
            local _node = pet:getGhostNode()
            _node:setOpacity(220)
            local function nodeBack()
                _node:removeFromParent()
                _node = nil
            end
            _node:runAction(cc.Sequence:create(cc.FadeTo:create(0.3,0),cc.CallFunc:create(nodeBack)))
            pet:delete()
            self.petMap[_vo.pkey] = nil
        end
    end
end

function Scene:createEscortHandler(escortVo, option)
    if option == "add" then
        escortVo.mid = escortVo.mid + ESCORT_FIRST_ID
        if not self.escortMap[escortVo.pkey] then
            local _escort = Follower.new(escortVo)
            _escort.pickType = ObjPickType.Escorter
            self.escortMap[escortVo.pkey] = _escort
            _escort:setMoveSpeed(160 * 0.6)
            self:updateFollerHideType(_escort, escortVo.pkey)
        end
        self.escortMap[escortVo.pkey]:setLogicPos(cc.p(escortVo.x, escortVo.y))
    else
        local _escort = self.escortMap[escortVo.pkey]
        if _escort then
            _escort:delete()
            self.escortMap[escortVo.pkey] = nil
        end
    end
end

function Scene:createMagicWeaponHandler(vo, option)
    if option == "add" then       
        if not self.magicWeaponMap[vo.key] then
            local magicObj = MagicWeapon.new(vo)
            local obj, isMain = self:getRoleObj(vo.key)
            magicObj:setVisible(not self.isHideMagic or isMain)
            self.magicWeaponMap[vo.key] = magicObj
            self.magicWeaponMap[vo.key]:setLogicPos(cc.p(vo.x + 1, vo.y - 2))
            self:updateFollerHideType(magicObj, vo.key)
        else
            self.magicWeaponMap[vo.key]:initWithVo(vo)
        end
    else
        local magicObj = self.magicWeaponMap[vo.key]
        if magicObj then
            magicObj:delete()
            self.magicWeaponMap[vo.key] = nil
        end
    end
end

function Scene:createShenlingHandler(vo, option)
    local key = vo.key
    if not key then return end
    if option == "add" then
        if not self.shenlingMap[key] then
            local shenlingObj = Shenling.new(vo)
            local obj, isMain = self:getRoleObj(key)
            shenlingObj:setVisible(not self.isHideShenling or isMain)
            self.shenlingMap[key] = shenlingObj
            self.shenlingMap[key]:setLogicPos(cc.p(vo.x, vo.y))
            self:updateFollerHideType(shenlingObj, key)
        else
            self.shenlingMap[key]:initWithVo(vo)
        end
    else
        local obj = self.shenlingMap[key]
        if obj then
            obj:delete()
            self.shenlingMap[key] = nil
        end
    end
end


function Scene:createCatHandler(vo, option)
    local key = vo.key
    if not key then return end
    if option == "add" then
        if not self.catMap[key] then
            local catObj = Cat.new(vo)
            local obj, isMain = self:getRoleObj(key)
            catObj:setVisible(not self.isHideCat or isMain)
            self.catMap[key] = catObj
            self.catMap[key]:setLogicPos(cc.p(vo.x, vo.y))
            self:updateFollerHideType(catObj, key)
        else
            self.catMap[key]:initWithVo(vo)
        end
    else
        local obj = self.catMap[key]
        if obj then
            obj:delete()
            self.catMap[key] = nil
        end
    end
end


--暂时全部隐藏，根据需求细化处理
function Scene:showSceneObj(bool, type, isRunningStory)
    if isRunningStory == "yes" then
        self.isRunningStory = true
        Scene.SHOW_FIHGT_INFO = false
    else
        self.isRunningStory = false
        Scene.SHOW_FIHGT_INFO = true
    end

    type = type or 0

    if type == 0 then
        for _, _role in pairs(self.roleMap) do
            if Scene.FAST_MODE and not SceneUtils.hideFilter(_role.vo) then
                _role:setHideType(1)
            else
                _role:setHideType(0)
                _role:setVisible(bool)
            end
        end

        for _, _mon in pairs(self.monsterMap) do
            _mon:setVisible(bool)
        end

        for _, _npc in pairs(self.npcMap) do
            _npc:setVisible(bool)
        end

        for _, _follower in pairs(self.followerMap) do
            _follower:setVisible(bool)
        end

        for _, _pet in pairs(self.petMap) do
            _pet:setVisible(bool)
        end

        for _, _door in pairs(self.doorMap) do
            _door:setVisible(bool)
        end

        for _, _escort in pairs(self.escortMap) do
            _escort:setVisible(bool)
        end

        for _, _getherEffect in pairs(self.gatherEffectMap) do
            _getherEffect:setVisible(bool)
        end
    end

    self.objVisible = bool
end

function Scene:createClientHandler(nowTime, elapseTime)
    self:createMonsterClient()
    self:createNpcClient()
    self:createRoleClient()
end

function Scene:updateClient(nowTime, elapseTime)
    for key, var in pairs(self.clientMonsterMap) do
        var:update(nowTime, elapseTime)
    end

    for key, var in pairs(self.clientNpcMap) do
        var:update(nowTime, elapseTime)
    end

    for key, var in pairs(self.clientRoleMap) do
        var:update(nowTime, elapseTime)
    end
end

function Scene:clearAllClientObj()
    self.clientNpcList = List.New()
    self.clientRoleList = List.New()
    self.clientMonsterList = List.New()

    for key, monster in pairs(self.clientMonsterMap) do
        monster:delete()
    end
    self.clientMonsterMap = {}

    if not self.isStoryScene then 
        for key, npc in pairs(self.clientNpcMap) do
            npc:delete()
        end
        self.clientNpcMap = {}
    end

    for key, role in pairs(self.clientRoleMap) do
        role:delete()
    end
    self.clientRoleMap = {}
end

function Scene:registerZone(zoneVo)
    local zoneKey = zoneVo.mkey .. '#' .. zoneVo.sceneID .. '#' .. zoneVo.rect.x .. zoneVo.rect.y .. zoneVo.rect.width .. zoneVo.rect.height
    zoneVo.zoneKey = zoneKey
    self.zoneList[zoneKey] = zoneVo
    return zoneKey
end

function Scene:removeAllZone()
    for k,v in pairs(self.zoneList) do
        self.zoneList[k] = nil
    end
    self.zoneList = {}
end

function Scene:removeZone(mkey)
    for k,v in pairs(self.zoneList) do
        if v.mkey == mkey then 
            self.zoneList[k] = nil
            break
        end
    end
end

function Scene:zoneCheck(rolePos)
    for _, zoneVo in pairs(self.zoneList) do
        if self.sceneId == zoneVo.sceneID and cc.rectContainsPoint(zoneVo.rect, rolePos) then
            return zoneVo
        end
    end
    return false
end

function Scene:cleanRoleMap()
    for key, var in pairs(self.roleMap) do
        var:delete()
    end
    self.roleMap = {}
end

function Scene:updateEXbgPos()
    if self.exbg and self.role:isRunning() then
        self.exbg:setPosition(self.camera:getCameraPosition().x+display.cx+display.rw/2, self.camera:getCameraPosition().y+display.cy+display.rw/2-30)
    end
end

--显示怪物技能tips
function Scene:showSkillTips(obj, skillId)
    local _cfg = Config.Skill[skillId]
    if _cfg and _cfg.sktips ~= 0 then
        --泡泡显示
        if _cfg.sktips.type == 2 then
            obj:say(SkillContent.paopao[_cfg.sktips.content])
        else
            --技能飘字
            if _cfg.sktips.type == 1 then
                if obj.showSkillName then
                    obj:showSkillName(_cfg.name)
                end
            end

            --警告提示
            if _cfg.sktips.content then
                self:showSkillWarming(SkillContent.tips[_cfg.sktips.content])
            end
        end
    end
end

function Scene:showSkillWarming(content)
    local _node = cc.Node:create()
    HandleRenderUnit:getCoreScene():addToRenderGroup(_node, cc.RenderQueue.GRQ_AIR_UP, 10)
    _node:setPosition(display.cx+20, 180)

    local _bg = cc.Sprite:create("ui/res/pic/skillNameBg.png")
    _bg:setScale(1.4)
    _node:addChild(_bg)
    _bg:runAction(cc.Repeat:create(cc.Sequence:create(cc.TintTo:create(0.2, 255, 0, 0), cc.TintTo:create(0.2, 255, 255, 255)), 4))

    local _txt = ccui.RichLabel:create()
    _txt:setContentSize(cc.size(300, 50))
    _txt:setAnchorPoint(cc.p(0, 1))
    _txt:setTouchEnabled(false)
    _txt:setText(content)
    _node:addChild(_txt, 2)

    local _size = _txt:getRealSize()
    _txt:setPosition(cc.p(-150+(300-_size.width)/2, 10))

    local function func()
        _node:removeFromParent()
        _node = nil
    end
    performWithDelay(_node, func, 3)
end

function Scene:showRoleFastMode()
    for _, _role in pairs(self.roleMap) do
        if not SceneUtils.hideFilter(_role.vo) then
            _role:setHideType(Scene.FAST_MODE and 1 or 0)

            local _pet = self.petMap[_role.vo.pkey]
            if _pet then
                _pet:setHideType(Scene.FAST_MODE and 1 or 0)
            end
        end
    end
end

function Scene:setFastMode(bool)
    if Scene.FAST_MODE == bool then return end

    Scene.FAST_MODE = bool
    self:showRoleFastMode()
end

function Scene:stopRunning()
    if self.role then
        self.role:stopMoving()
    end
    HandleOperateManager:clearSrcOperator()
    
    self:cleanEndPoint()
    self.touchRun = false
end

-- --采集后的效果
function Scene:showCollectEffect(obj)
    if not obj or not obj.vo then
        return
    end

    local gatherVo = obj.vo
    local mid = gatherVo.mid
    local handlerMap = {
        [23002] = true,
    }

    local specialActMap = {
        [23002] = true,
    }

    --不存在 则不做任何处理
    if not handlerMap[mid] then
        return
    end

    --隐藏原先采集物
    if gatherVo.mkey and self.monsterMap[gatherVo.mkey] then
        self.monsterMap[gatherVo.mkey]:setVisible(false)
    end

    --手工设置播放的序列帧
    gatherVo.aniName = "action"--临时
    --创建采集物
    if specialActMap[mid] then
        --灯笼单独处理
        local gather = Gather.new(gatherVo, collectCB)
        gather:setLogicPos(cc.p(gatherVo.x, gatherVo.y))
        gather:setVisible(self.objVisible)
        self.gatherEffectMap[gatherVo.mkey] = gather

        local moveAct = cc.MoveBy:create(3, cc.p(200, 400))
        local callback = cc.CallFunc:create(
            function ()
                if self.gatherEffectMap[gatherVo.mkey] then
                    self.gatherEffectMap[gatherVo.mkey]:delete()
                    self.gatherEffectMap[gatherVo.mkey] = nil
                end

                if self.monsterMap[gatherVo.mkey] then
                    self.monsterMap[gatherVo.mkey]:setVisible(true)
                end
            end )
        local node = gather:getPlayLayer()
        if node then
            node:runAction( cc.Sequence:create(moveAct, callback) )
        end
    else
        local function collectCB(mkey)
            if self.gatherEffectMap[mkey] then
                self.gatherEffectMap[mkey]:delete()
                self.gatherEffectMap[mkey] = nil
            end

            if self.monsterMap[mkey] then
                self.monsterMap[mkey]:setVisible(true)
            end
        end

        local gather = Gather.new(gatherVo, collectCB)
        gather:setLogicPos(cc.p(gatherVo.x, gatherVo.y))
        gather:setVisible(self.objVisible)
        self.gatherEffectMap[gatherVo.mkey] = gather
    end
end

--设置玩家是否显示
--key 玩家key
--bool true显示，false隐藏
--return true自己，false玩家
function Scene:setRoleVisibleByKey(key, bool)
    if not key then return end

    if self.role and self.role.vo.pkey == key then
        self.role:setVisible(bool)
        self:setFollowVisible(self.role.vo, bool)
        return true
    end

    if self.roleMap[key] then
        self.roleMap[key]:setVisible(bool)
        self:setFollowVisible(self.roleMap[key].vo, bool)
        return false
    end

    return false
end

function Scene:setFollowVisible(roleVo, bool)
    if roleVo.petfigure > 0 then
        local pkey = roleVo.pkey or roleVo.mkey
        if pkey and self.petMap[pkey] then
            self.petMap[pkey]:setVisible(bool)
        end
    end
end

function Scene:isRoleVisibleByKey(key)
    local role = self.roleMap[key]
    if role == nil then
        return
    end

    return role:isVisible()
end

function Scene:cleanFromReborn()
    local tb = {
        self.roleMap, 
        self.petMap,
        self.catMap,
        self.monsterMap,
        self.doorMap,
        self.flyMap,
        self.escortMap,
        self.magicWeaponMap,
        self.shenlingMap,
        self.followerMap,
        self.dropMap,
        self.sceneEffectMap,
        self.gatherEffectMap,
    }
    for _, map in pairs(tb) do
        for _, obj in pairs(map) do
            obj:delete()
        end
    end
    self.roleMap = {}
    self.petMap = {}
    self.catMap = {}
    self.monsterMap = {}
    self.doorMap = {}
    self.flyMap = {}
    self.escortMap = {}
    self.magicWeaponMap = {}
    self.shenlingMap = {}
    self.followerMap = {}
    self.dropMap = {}
    self.sceneEffectMap = {}
    self.gatherEffectMap = {}
    self.roleNum = 0
end

--下一帧一触
--多针移除
function Scene:delayDelete()
    local handlerList = {}

    if not self.isStoryScene then 
        table.insertTab(handlerList, self.npcMap)
    end
    table.insertTab(handlerList, self.roleMap)
    table.insertTab(handlerList, self.petMap)
    table.insertTab(handlerList, self.catMap)
    table.insertTab(handlerList, self.monsterMap)
    table.insertTab(handlerList, self.doorMap)
    table.insertTab(handlerList, self.flyMap)
    table.insertTab(handlerList, self.escortMap)
    table.insertTab(handlerList, self.magicWeaponMap)
    table.insertTab(handlerList, self.shenlingMap)
    table.insertTab(handlerList, self.followerMap)
    table.insertTab(handlerList, self.dropMap)
    table.insertTab(handlerList, self.sceneEffectMap)
    table.insertTab(handlerList, self.gatherEffectMap)
    table.insertTab(handlerList, self.vipSkillMonMap)
    table.insertTab(handlerList, self.zbMap)    
    if #handlerList == 0 then return end
    --分帧删除
    local max = 15
    local duration = 2*SystemInfo.fpsRate
    local function delay(elapseTime)
        if elapseTime > duration then
            max = math.max(max - 3, 10)
        end

        local length = #handlerList
        local endIndex = math.max(length - max, 1)
        for index = length, endIndex, -1 do
            handlerList[index]:delete()
            handlerList[index] = nil
        end

        print("delay delete obj of scene: ", max, length)
        if endIndex == 1 then
            self.delDelayNode:unscheduleUpdate()
        end
    end

    self.delDelayNode:scheduleUpdateWithPriorityLua(delay, 1)
    for k, v in pairs(self.kunMap) do 
        v:removeFromParent()
        v = nil
    end
end

function Scene:isMoving(vo)
    local obj, flag = self:getRoleObj(vo.pkey)
    if obj then
        return obj:isMoving()
    end

    return false
end

function Scene:destructor()
    if self.camera_helper then
        self.camera_helper:DeleteMe()
        self.camera_helper = nil
    end

    if HandleTerrainHandler then
        HandleTerrainHandler:clearAllTile()
        HandleTerrainHandler:delete()
    end

    if self.pickBar then
        self.pickBar:removeFromParent(true)
        self.pickBar = nil
    end

    self.isGoldCopyScene = false
end

function Scene:showBright()
    if self.brightIcon then
        return
    end

    self.brightIcon = cc.SpriteUI:createWithResCSpriteLoader("assets/progress/roleBright.csprite", "default") 
    self.brightIcon:setBlendFunc(gl.GL_DST_ALPHA, gl.ONE)
    HandleRenderUnit:getCoreScene():addToRenderGroup(self.brightIcon, cc.RenderQueue.GRQ_TERRAIN + 2)
end

--屏蔽友方玩家
function Scene:setMyTeamerHide(isHide)
    if self.isHideMyTeamer == isHide then
        return
    end

    self.isHideMyTeamer = isHide

    for _, role in pairs(self.roleMap) do
        if SceneUtils.hideFilter(role.vo) then
            role:setHideType(self.isHideMyTeamer and 1 or 0)
            self:setFollerHide(role.vo.pkey or role.vo.mkey, self.isHideMyTeamer)
        end
    end
end

function Scene:fliterRoleHide(role)
    if (SceneUtils.hideFilter(role.vo) and self.isHideMyTeamer) or 
        (not SceneUtils.hideFilter(role.vo) and self.isHideOtherRole) then
        role:setHideType(1)
        self:setFollerHide(role.vo.pkey or role.vo.mkey, true)
    end
end

--屏蔽他人
function Scene:setOtherRoleHide(isHide)
    if self.isHideOtherRole == isHide then
        return
    end

    self.isHideOtherRole = isHide

    for _, role in pairs(self.roleMap) do
        if not SceneUtils.hideFilter(role.vo) then
            role:setHideType(self.isHideOtherRole and 1 or 0)
            self:setFollerHide(role.vo.pkey or role.vo.mkey, self.isHideOtherRole)
        end
    end
end

--限制同屏人数
function Scene:setOtherRoleHideForNum(limitNum)
    if self.isHideOtherRole == true then
        return
    end
    self.filterRoleNum = self.filterRoleNum > limitNum and self.filterRoleNum or self.filterRoleNum
    SceneUtils.setOverFilterNum(limitNum)
end

--获取法器
function Scene:getMagicObj(roleVo)
    local pkey = roleVo.pkey or roleVo.mkey
    return self.magicWeaponMap[pkey]
end

--获取神灵
function Scene:getShenlingObj(roleVo)
    local pkey = roleVo.pkey or roleVo.mkey
    return self.shenlingMap[pkey]
end

--获取宠物
function Scene:getPetObj(roleVo)
    local pkey = roleVo.pkey or roleVo.mkey
    return self.petMap[pkey]
end

--获取妖灵
function Scene:getCatObj(roleVo)
    local pkey = roleVo.pkey or roleVo.mkey
    return self.catMap[pkey]
end

--获取怪物
function Scene:setMonsterHide(isHide)
    if self.isHideMonster == isHide then
        return
    end

    self.isHideMonster = isHide
    for _, monter in pairs(self.monsterMap) do
        if monter.__cname ~= "Role" then
            if SceneUtils.isCanHideMonster(self:getSceneID(), monter.vo) then
                monter:setVisible(not self.isHideMonster)
            end
        end
    end
end

--屏蔽跟随物
function Scene:setFollerHide(pkey, isHide)
    if self.petMap[pkey] then
        self.petMap[pkey]:setVisible(not isHide)
    end

    if self.followerMap[pkey] then
        self.followerMap[pkey]:setVisible(not isHide)
    end

    if self.escortMap[pkey] then
        self.escortMap[pkey]:setVisible(not isHide)
    end

    if self.magicWeaponMap[pkey] then
        self.magicWeaponMap[pkey]:setVisible(not isHide)
    end

    if self.shenlingMap[pkey] then
        self.shenlingMap[pkey]:setVisible(not isHide)
    end
    if self.catMap[pkey] then
        self.catMap[pkey]:setVisible(not isHide)
    end

end

-- 屏蔽其他玩家坐骑、翅膀、时装、光武/神兵，使用默认资源
function Scene:setOtherRolePartHide(isHide)
    for _, role in pairs(self.roleMap) do
        if role.vo.pkey ~= self.mainpKey and role.hideType ~= 1 then
            if role then
                local _info = role.vo
                role:initWithVo(_info)
                role:resetAnimate()
            end
        end
    end
end

--屏蔽斗气
function Scene:setDouqiHide(isHide)
    for _, role in pairs(self.roleMap) do
        --if not SceneUtils.hideFilter(role.vo) and role.hideType ~= 1 then
        if role.vo.pkey ~= self.mainpKey and role.hideType ~= 1 then
            role:setDouqiVisible(not isHide)
        end
    end
end

function Scene:setSelfDouqiHide(isHide)
    if self.role then
        self.role:setDouqiVisible(not isHide)
    end
end

--屏蔽法器
function Scene:setMagicHide(isHide)
    if isHide == nil then
        isHide = self.isHideMagic
    end

    self.isHideMagic = isHide

    for pkey, magicWeapon in pairs(self.magicWeaponMap) do
        if pkey ~= self.mainpKey then
            local role = SceneUtils.getMasterRole(pkey)
            if role and role.hideType ~= 1 then
                magicWeapon:setVisible(not self.isHideMagic)
            end
        end
    end
end

--屏蔽神灵
function Scene:setShenlingHide(isHide)
    if isHide == nil then
        isHide = self.isHideShenling
    end

    self.isHideShenling = isHide

    for pkey, shenling in pairs(self.shenlingMap) do
        if pkey ~= self.mainpKey then
            local role = SceneUtils.getMasterRole(pkey)
            if role and role.hideType ~= 1 then
                shenling:setVisible(not self.isHideMagic)
            end
        end
    end
end

--屏蔽宠物
function Scene:setCatHide(isHide)
    if isHide == nil then
        isHide = self.isHideCat
    end
    self.isHideCat = isHide
    if self.isHideOtherRole == true then
        return
    end
    for pkey, cat in pairs(self.catMap) do
        if pkey ~= self.mainpKey then
            cat:setVisible(not self.isHideCat)
        end
    end
end

-- 设置控制屏蔽的flag值
function Scene:setHideFlag(isHide)
    self.hideConfig = isHide
    self.isHidePet = self.hideConfig
    self.isHideMagic = self.hideConfig
    self.isHideShenling = self.hideConfig
    self.isHideOtherRolePart[SetHideType.SwordPool] = self.hideConfig
end

--屏蔽宠物
function Scene:setPetHide(isHide)
    if isHide == nil then
        isHide = self.isHidePet
    end
    self.isHidePet = isHide
    if self.isHideOtherRole == true then
        return
    end
    for pkey, pet in pairs(self.petMap) do
        if pkey ~= self.mainpKey then
            pet:setVisible(not self.isHidePet)
        end
    end
end




--获取主人的隐藏类型
--创建的时候调用
function Scene:updateFollerHideType(obj, pkey)
    if self.isHideMyTeamer or self.isHideMonster or self.isHideMagic or self.isHidePet or self.isHideOtherRole or self.isHideShenling then
        local hideType = 0
        if self.roleMap[pkey] then
            hideType = self.roleMap[pkey].hideType
        end
        if self.monterMap and pkey and self.monterMap[pkey] then
            hideType = self.monterMap[pkey].hideType
        end
        if hideType == 1 then
            obj:setVisible(false)
        end
    end
end

function Scene:partRoleHide(role)
    self:setRolePartHideByType(SetHideType.Wing)
    self:setRolePartHideByType(SetHideType.SwordPool)
    self:setRolePartHideByType(SetHideType.ArtifactUp)
    self:setRolePartHideByType(SetHideType.Title)
    self:setRolePartHideByType(SetHideType.Cloak)
    self:setMagicHide()
    self:setPetHide()
end

function Scene:setRolePartHideByType(id, isHide)
    if isHide ~= nil then
        self.isHideOtherRolePart[id] = isHide
    else
        isHide = self.isHideOtherRolePart[id]
    end
    local typeList = SetUtils.hideTypeList[id]
    for _, role in pairs(self.roleMap) do
        --if not SceneUtils.hideFilter(role.vo) and role.hideType ~= 1 then
        if role.vo.pkey ~= self.mainpKey and role.hideType ~= 1 then
            if id == SetHideType.Title then
                role:setTitleHide(isHide)
            else
                role:setHideByTypeList(id, typeList, isHide and true or false)
            end
        end
    end
end

function Scene:setSelfRolePartHideByType(id, isHide)
    if isHide ~= nil then
        self.isHideSelfRolePart[id] = isHide
    else
        isHide = self.isHideSelfRolePart[id]
    end
    local typeList = SetUtils.hideTypeList[id]
    self:getMainRole():setHideByTypeList(id, typeList, isHide and true or false)
end

function Scene:updateMonsterKeepMap(key, obj)
    if not key or not obj then
        return
    end
    self.monsterKeepMap[key] = {gap = SceneMaxKeepGap, pos = obj:getPixelPos(), boudingBox = obj.boudingBox}
end

function Scene:updateScreenPos()
    if not self.role then
        return
    end

    local logicPos = self.role:getLogicPos()
    self.lastScreenPos = SceneUtils.worldToScreen(logicPos)
end

function Scene:onPathChange()
    self.pathID = self.pathID + 1
    if self.pathID > 10000 then
        self.pathID = 0
    end
end

--自动使用小飞鞋
function Scene:autoFly(fun)
    if fun then
        fun(true)
    end
end
--下落
function Scene:showFloating(backFun)
    print("=====showFloating===backFun===")
    local function callback()
        if self.lastMainRole then 
            self.lastMainRole:delete()
            self.lastMainRole = nil
        end 
        local role = self.role
        if role then
            role:setVisible(true)
        end
        print("=====showFloating===callback===")
        GlobalEventSystem:fire(GlobalEventType.SHOW_MAIN_LAYER, true)
        if backFun then
            backFun()
        end
        if self.isChangeSceneByFly then
            self.isChangeSceneByFly = false
            GlobalEventSystem:fire(GlobalEventType.OVERFLY_END)
        end
        self.changeSceneJumping = false
    end
    if self.isStoryScene then 
        self.role:setVisible(true)
        callback()
    else
        self.role:setVisible(true)
        self.role:doFloating(callback, true) 
    end
end

--UI层场景特效
function Scene:loadSceneEffect(sceneID)
    for _, effectNode in pairs(self.effectList or {}) do
        effectNode:removeFromParent()
    end
    self.effectList = {}
    
    if SceneParticleMap[sceneID] then
        local gameScene = HandleRenderUnit:getCoreScene()
        local effectNode = nil
        for _, effectCfg in pairs(SceneParticleMap[sceneID]) do
            effectNode = cc.MyParticleSystem:Create(effectCfg.path)
            local pos = effectCfg.position
            effectNode:setPosition(pos.x, pos.y)
            effectNode:SetCycle(true)
            effectNode:setLocalZOrder(-100)
            self.effectList[#self.effectList + 1] = effectNode
        end
    end
end

function Scene:getLastSceneID()
    return self.lastSceneID
end

function Scene:getSceneID()
    return self.sceneId
end


function Scene:closeTowerTip(mInfo)
    local obj =  self.monsterMap[mInfo.mkey] 
    if obj then 
        obj:closeTowerAnima()
    end 
end 

function Scene:refreshTowerTip(soul_num)
    for k ,monster in pairs(self.monsterMap) do 
        if monster.vo and monster.vo.mid and  Config.Dungeon_juhun[monster.vo.mid] then 
            local jVo = Config.Dungeon_juhun[monster.vo.mid]
            local soul = jVo.up_cost
          --  print("-------------->>>>>>>>>>>>>>>>>>>>>怪物检查：",soul_num,soul)
            if soul_num >= soul and tonumber(jVo.next_skill_id) ~= 0 then 
                monster:aminaLev(true)   
            else
                monster:aminaLev(false)
            end 
        end 
    end 
end

function Scene:request12224()
    self:send(12224)
end
function Scene:response12224(vo)
    if SceneUtils.isDefendKidom(self.sceneId) then
        local function fight()
            AutoFighting:getInstance():startAutoFight()
            self.isKDRuning = false
        end
        math.randomseed(tostring(os.time()):reverse():sub(1, 6))
        --random 为了兼容ios
        local randNum = math.random(1, math.min(1, #vo.mon_list))

        if not vo.mon_list[randNum] then
            return
        end
        if not self.isKDRuning and (not vo.mon_list[randNum] or #vo.mon_list <= 2) then
            local function delay()
                self:request12224()
            end
            performWithDelay(self.delayNode, delay, 3.0)
            return
        end

        local endPoint = cc.p(vo.mon_list[randNum].x, vo.mon_list[randNum].y)
        self:runToSceneObj(endPoint, fight, nil, true)
    end
end

function Scene:reportInfo(preFix)
    --断线重连中不需要上报
    if Network:getInstance():isReconnect() then
        return
    end
    local plats = {
        [cc.PLATFORM_OS_ANDROID] = true,
        [cc.PLATFORM_OS_IPHONE] = true,
        [cc.PLATFORM_OS_IPAD] = true,
    }

    local pkey = RoleController:getInstance().model.mainRoleVo and RoleController:getInstance().model.mainRoleVo.pkey or ""
    local pos = self.role:getLogicPos()
    local monStr = "[monMap:"
    for key, mon in pairs(self.monsterMap) do
        monStr = monStr .. "," .. tostring(key)
    end
    monStr = monStr .. "]"
    local recvStr = table.concat(self.recvMonList, ",")
    local leaveStr = table.concat(self.leaveMonList, ",")
    local addStr = table.concat(self.addMonList, ",")
    local createStr = table.concat(self.createMonList, ",")
    local deleteStr = table.concat(self.deleteMonList, ",")

    local info = string.format(tostring(preFix) .. "{recv:%s}|{leave:%s}|{add:%s}|{create:%s}|{delete:%s}=", recvStr, leaveStr, addStr, createStr, deleteStr)
    local str = string.format("none in %s_%s_(%s,%s) : %s", tostring(self.sceneId), tostring(pkey), pos.x, pos.y, tostring(info))
    if plats[SystemInfo.platform] then 
        buglyReportLuaException(str .. monStr, debug.traceback())
    else
        log("上报没怪信息 : ", str .. monStr)
    end
end

function Scene:request12098(...)
    self:send(12098, ...)
    self:reportInfo("before666")
    self.isReport = true
end

--检查死亡的怪物
function Scene:checkDeadMonsterInList(key)
    if SceneUtils.isInSMZC() then
        local length = List.Size(self.monsterList)
        for i = 0, length - 1 do
            local listInfo = List.Get(self.monsterList, i)
            local vo, action = listInfo[1], listInfo[2]
            --不在队列中移除，直接把add改成none不处理
            if vo.mkey == key and action == "add" then
                log("error! monster was dead", key)
                listInfo[2] = "none"
            end
        end
    end
end

function Scene:cleanSMZCDeadMonster()
    if not SceneUtils.isInSMZC() then
        return
    end
    local _getDisFn = SceneUtils.getDistanceSQ
    local removeList = {}
    for key, mon in pairs(self.monsterMap) do
        if mon.vo.kind == 58 then
            local _p1 = mon:getLogicPos()
            local _p2 = self.role:getLogicPos()
            local _dis = _getDisFn(_p1, _p2)
            mon.__calcPosTime = mon.__calcPosTime or 1
            if mon.__lastPos == _p1 then
                mon.__calcPosTime = mon.__calcPosTime + 1
            end
            --超过1分钟，怪物没有移动，暂且认为是尸体
            if mon.__calcPosTime == 12 then
                removeList[key] = true
            end
            mon.__lastPos = _p1
            if _dis > 580 then
               removeList[key] = true 
            end
        end
    end

    for key, v in pairs(removeList) do
        self.monsterMap[key]:delete()
        self.monsterMap[key] = nil
    end
end

function Scene:playSkill(skillid, again)
    if not self.role then
        return
    end
    -- ===============================参数列表===============================
    -- ===================================================================== 
    local inlineGap_X = 4       -- 同一行间的横向间距
    local inlineGap_Y = 5       -- 同一行间的纵向间距
    local outlineGap_X = 6      -- 不同行之间的横向间距
    local outlineGap_Y = 5      -- 不同行之间的纵向间距
    local totalLines = 6        -- 总行数
    local num = 3               -- 一行多少个
    local ifAgain = true        -- 是否重复播放
    local numAgain = 1          -- 重复播放次数
    local duration = 0.8        -- 重复播放间隔时间
    local runSpeed = 4          -- 负重 值越大 速度越慢
    local runTime = 8           -- 奔跑时长
    -- =====================================================================
    -- ===================================================================== 
    self.isPlayVipSkill = false
    AudioManager:getInstance():playEffectMusic("vipskill")
    local _cfg = Config.Skill[skillid]
    self.camera:startShake(_cfg.isShake.range, _cfg.isShake.cycle, _cfg.isShake.time, _cfg.isShake.delay)
    local pos = self.role:getLogicPos()
    local list = {
        [9] = {30, 120},
        [1] = {30, -60},
        [6] = {90, 180},
        [4] = {90, 0},
        [3] = {-30, -120},
        [7] = {-30, 60},
    }
    local cfg = Config.Skill[skillid]
    math.randomseed(tonumber(tostring(os.time()):reverse():sub(1,6)))
    for factor = 0, totalLines - 1 do
        -- 对每一行的怪物位置随机排列
        local iconList = clone(cfg.icon)
        table.sort(iconList, function (a, b)
            return math.random(1, 10) < 5
        end)
        local iconNum = #iconList
        local idx = math.floor(num/2) -- 对称排列
        for i = -idx, idx do
            local index = tostring(i) .. tostring(factor) .. tostring(SceneUtils.vipSkillNum)
            local info = list[self.role.dir]
            local iconIndex = (i + idx + 1) % iconNum
            iconIndex = iconIndex == 0 and iconNum or iconIndex
            local vo = {
                mid = 0,
                key = index,
                name = "",
                speed = 400,
                dir = self.role.dir,
                resPath = string.format("assets/effect/skilleffect/%s.csprite", iconList[iconIndex]),
                moveDir = info,
                x = factor * math.cos(math.rad(info[2])) * outlineGap_X + pos.x + math.cos(math.rad(info[1])) * i * inlineGap_X,
                y = factor * math.sin(math.rad(info[2])) * outlineGap_Y + pos.y + math.sin(math.rad(info[1])) * i * inlineGap_Y,
                runSpeed = runSpeed,
                runTime = runTime,
            }
            List.PushBack(self.vipSkillMonList, {vo, "add"})
            SceneUtils.vipSkillNum = SceneUtils.vipSkillNum + 1
        end
    end
    
    if again == false then
        return
    end
    if ifAgain then
        local timer
        local function delay()
            if numAgain <= 0 then
                if timer then
                    GlobalTimerQuest:CancelQuest(timer)
                    timer = nil
                end
                return
            end
            numAgain = numAgain - 1            
            self:playSkill(skillid, false)
        end
        timer = GlobalTimerQuest:AddPeriodQuest(delay, duration, -1)
    end
end

function Scene:removeVipSkill(key)
    List.PushBack(self.vipSkillMonList, {key, "remove"})    
end

function Scene:createVIPSkillHandler()
    if List.Empty(self.vipSkillMonList) then return end
    local _t = List.PopFront(self.vipSkillMonList)
    if _t[2] == "add" then
        local _vo = _t[1]
        if not self.vipSkillMonMap[_vo.key] then
            local _vipSkillMon = EffectMonster.new(_vo)
            self.vipSkillMonMap[_vo.key] = _vipSkillMon
        end
        local logicPos = cc.p(_vo.x, _vo.y)
        self.vipSkillMonMap[_vo.key]:setLogicPos(logicPos)
    elseif _t[2] == "remove" then
        local key = _t[1]
        local _vipSkillMon = self.vipSkillMonMap[key]
        if _vipSkillMon then
            _vipSkillMon:delete()
            self.vipSkillMonMap[key] = nil
        end
    end
end

function Scene:checkKunAnimate()
    self.kunList = self.kunList or {}
    local kun1, kun2
    local function fnCreate1()
        local key = 10001
        local kunInfo = NewPlayerKunUtil.kunObj[key]
        local kunRes = "assets/media/changjingkun/" .. key ..".csprite"

        if self.kunList[key] then
            self.kunList[key]:removeFromParent()
        end
        local kunObj, kunAction = ActionTimeLineUtils.getAnimate(kunRes, "action", function()
            if self.kunList[key] then
                self.kunList[key]:removeFromParent()
            end
            self.kunList[key] = nil
        end, false)
        local pixelPos = SceneUtils.logicToPixel(cc.p(kunInfo.x, kunInfo.y))
        local realp = cc.p(pixelPos.x, Scene.SCENE_HEIGHT - pixelPos.y)
        kunObj:setPosition(realp)
        kunObj:setVisible(true)
        HandleRenderUnit:getCoreScene():addToRenderGroup(kunObj, cc.RenderQueue.GRQ_TERRAIN_DOWN, 100)
        self.kunList[key] = kunObj
    end

    local function fnCreate2()
        local key = 10002
        local kunInfo = NewPlayerKunUtil.kunObj[key]
        local kunRes = "assets/media/changjingkun/" .. kunInfo.id ..".csprite"
        if self.kunList[key] then
            self.kunList[key]:removeFromParent()
            self.kunList[key] = nil
        end
        local node = cc.Node:create()
        local kunObj, kunAction = ActionTimeLineUtils.getAnimate(kunRes, "action", nil, true)
        local pixelPos = SceneUtils.logicToPixel(cc.p(kunInfo.x, kunInfo.y))
        local realp = cc.p(pixelPos.x, Scene.SCENE_HEIGHT - pixelPos.y)
        node:setPosition(realp)
        kunObj:setVisible(true)
        node:addChild(kunObj)
        HandleRenderUnit:getCoreScene():addToRenderGroup(node, cc.RenderQueue.GRQ_TERRAIN_DOWN, 100)
        self.kunList[key] = kunObj
        local pos1 = cc.p(realp.x + 400, realp.y)
        local pos2 = cc.p(realp.x - 400, realp.y)
        local call1 = cc.CallFunc:create(function()
            node:setScaleX(1)
        end)
        local act1 = cc.MoveTo:create(3, pos1)
        local act2 = cc.MoveTo:create(3, pos2)
        local call2 = cc.CallFunc:create(function()
            node:setScaleX(-1)
        end)
        local action = cc.RepeatForever:create(cc.Sequence:create(call1, act1, call2, act2))
        node:runAction(action)
        self.kunList[key] = node
    end

    fnCreate1()
    fnCreate2()

    if self.kunTimer then
        GlobalTimerQuest:CancelQuest(self.kunTimer)
        self.kunTimer = nil
    end
    self.kunTimer = GlobalTimerQuest:AddPeriodQuest(function()
        fnCreate1()
    end, 5, -1)
    

    -- local function runKunAction()
    --     for i = 1, 2 do 
    --         self:createKunHandler()
    --     end
    -- end
    -- GlobalTimerQuest:AddPeriodQuest(function()
    --     local pos = rolePost
    --     compare(pos, tagetPos)
    -- end, 0.5, -1)
end